package net.mycompanyname;

public class Global 
{
    private net.thepaymentgateway.common.ISOCountryList m_ISOCountryData;
    private net.thepaymentgateway.common.ISOCurrencyList m_ISOCurrencyData;
    private String m_merchantID;
    private String m_password;
    private String m_siteSecureBaseURL;
    private String m_paymentProcessorFullDomain;
    private String m_secretKey;
    
    /** Creates a new instance of Global */
    public Global() 
    {
        String paymentProcessorDomain;
        int paymentProcessorPort;

        // Will need to set these variables to valid a MerchantID and Password
        // These were obtained during sign up
        m_merchantID = "Need Valid MerchantID";
        m_password = "Need Valid Password";

        // This is the domain (minus any host header or port number for your payment processor 
        // e.g. for "https://gwX.paymentprocessor.net:4430/", this should be "paymentprocessor.net" 
        // e.g. for "https://gwX.thepaymentgateway.net/", this should be "thepaymentgateway.net" 
        paymentProcessorDomain = "payvector.net";
        // This is the port that the gateway communicates on 
        // e.g. for "https://gwX.paymentprocessor.net:4430/", this should be "4430" 
        // e.g. for "https://gwX.thepaymentgateway.net/", this should be "443" 
        paymentProcessorPort = 443;

        // This is used to generate the Hash Keys that detect variable tampering 
        // You should change this to something else 
        m_secretKey = "MySecretKey-ChangeMe";
        
        if (paymentProcessorPort == 443)
        {
            m_paymentProcessorFullDomain = paymentProcessorDomain + "/";
        }
        else
        {
            m_paymentProcessorFullDomain = paymentProcessorDomain + ":" + paymentProcessorPort + "/";
        }
            
        // the ISO currency data
        m_ISOCurrencyData = new net.thepaymentgateway.common.ISOCurrencyList();
        m_ISOCurrencyData.add(634, "Qatari Rial","QAR", 2);
        m_ISOCurrencyData.add(566, "Naira", "NGN", 2);
        m_ISOCurrencyData.add(678, "Dobra", "STD", 2);
        m_ISOCurrencyData.add(943, "Metical", "MZN", 2);
        m_ISOCurrencyData.add(826, "Pound Sterling", "GBP", 2);
        m_ISOCurrencyData.add(654, "Saint Helena Pound", "SHP", 2);
        m_ISOCurrencyData.add(704, "Vietnamese ??ng", "VND", 2);
        m_ISOCurrencyData.add(952, "CFA Franc BCEAO", "XOF", 0);
        m_ISOCurrencyData.add(356, "Indian Rupee", "INR", 2);
        m_ISOCurrencyData.add(807, "Denar", "MKD", 2);
        m_ISOCurrencyData.add(959, "Gold (one Troy ounce)", "XAU", 0);
        m_ISOCurrencyData.add(410, "South Korean Won", "KRW", 0);
        m_ISOCurrencyData.add(946, "Romanian New Leu", "RON", 2);
        m_ISOCurrencyData.add(949, "New Turkish Lira", "TRY", 2);
        m_ISOCurrencyData.add(532, "Netherlands Antillian Guilder", "ANG", 2);
        m_ISOCurrencyData.add(788, "Tunisian Dinar", "TND", 3);
        m_ISOCurrencyData.add(646, "Rwanda Franc", "RWF", 0);
        m_ISOCurrencyData.add(504, "Moroccan Dirham", "MAD", 2);
        m_ISOCurrencyData.add(174, "Comoro Franc", "KMF", 0);
        m_ISOCurrencyData.add(484, "Mexican Peso", "MXN", 2);
        m_ISOCurrencyData.add(478, "Ouguiya", "MRO", 2);
        m_ISOCurrencyData.add(233, "Kroon", "EEK", 2);
        m_ISOCurrencyData.add(400, "Jordanian Dinar", "JOD", 3);
        m_ISOCurrencyData.add(292, "Gibraltar pound", "GIP", 2);
        m_ISOCurrencyData.add(690, "Seychelles Rupee", "SCR", 2);
        m_ISOCurrencyData.add(422, "Lebanese Pound", "LBP", 2);
        m_ISOCurrencyData.add(232, "Nakfa", "ERN", 2);
        m_ISOCurrencyData.add(496, "Tugrik", "MNT", 2);
        m_ISOCurrencyData.add(328, "Guyana Dollar", "GYD", 2);
        m_ISOCurrencyData.add(970, "Unidad de Valor Real", "COU", 2);
        m_ISOCurrencyData.add(974, "Belarusian Ruble", "BYR", 0);
        m_ISOCurrencyData.add(608, "Philippine Peso", "PHP", 2);
        m_ISOCurrencyData.add(598, "Kina", "PGK", 2);
        m_ISOCurrencyData.add(951, "East Caribbean Dollar", "XCD", 2);
        m_ISOCurrencyData.add(52, "Barbados Dollar", "BBD", 2);
        m_ISOCurrencyData.add(944, "Azerbaijanian Manat", "AZN", 2);
        m_ISOCurrencyData.add(434, "Libyan Dinar", "LYD", 3);
        m_ISOCurrencyData.add(706, "Somali Shilling", "SOS", 2);
        m_ISOCurrencyData.add(950, "CFA Franc BEAC", "XAF", 0);
        m_ISOCurrencyData.add(840, "US Dollar", "USD", 2);
        m_ISOCurrencyData.add(68, "Boliviano", "BOB", 2);
        m_ISOCurrencyData.add(214, "Dominican Peso", "DOP", 2);
        m_ISOCurrencyData.add(818, "Egyptian Pound", "EGP", 2);
        m_ISOCurrencyData.add(170, "Colombian Peso", "COP", 2);
        m_ISOCurrencyData.add(986, "Brazilian Real", "BRL", 2);
        m_ISOCurrencyData.add(961, "Silver (one Troy ounce)", "XAG", 0);
        m_ISOCurrencyData.add(973, "Kwanza", "AOA", 2);
        m_ISOCurrencyData.add(962, "Platinum (one Troy ounce)", "XPT", 0);
        m_ISOCurrencyData.add(414, "Kuwaiti Dinar", "KWD", 3);
        m_ISOCurrencyData.add(604, "Nuevo Sol", "PEN", 2);
        m_ISOCurrencyData.add(702, "Singapore Dollar", "SGD", 2);
        m_ISOCurrencyData.add(862, "Venezuelan bolvar", "VEB", 2);
        m_ISOCurrencyData.add(953, "CFP franc", "XPF", 0);
        m_ISOCurrencyData.add(558, "Cordoba Oro", "NIO", 2);
        m_ISOCurrencyData.add(348, "Forint", "HUF", 2);
        m_ISOCurrencyData.add(948, "WIR Franc ", "CHW", 2);
        m_ISOCurrencyData.add(116, "Riel", "KHR", 2);
        m_ISOCurrencyData.add(956, "European Monetary Unit", "XBB", 0);
        m_ISOCurrencyData.add(156, "Yuan Renminbi", "CNY", 2);
        m_ISOCurrencyData.add(834, "Tanzanian Shilling", "TZS", 2);
        m_ISOCurrencyData.add(997, "", "USN", 2);
        m_ISOCurrencyData.add(981, "Lari", "GEL", 2);
        m_ISOCurrencyData.add(242, "Fiji Dollar", "FJD", 2);
        m_ISOCurrencyData.add(941, "Serbian Dinar", "RSD", 2);
        m_ISOCurrencyData.add(104, "Kyat", "MMK", 2);
        m_ISOCurrencyData.add(84, " Belize Dollar", "BZD", 2);
        m_ISOCurrencyData.add(710, "South African Rand", "ZAR", 2);
        m_ISOCurrencyData.add(760, "Syrian Pound", "SYP", 2);
        m_ISOCurrencyData.add(512, "Rial Omani", "OMR", 3);
        m_ISOCurrencyData.add(324, "Guinea Franc", "GNF", 0);
        m_ISOCurrencyData.add(196, "Cyprus Pound", "CYP", 2);
        m_ISOCurrencyData.add(960, "Special Drawing Rights", "XDR", 0);
        m_ISOCurrencyData.add(716, "Zimbabwe Dollar", "ZWD", 2);
        m_ISOCurrencyData.add(972, "Somoni", "TJS", 2);
        m_ISOCurrencyData.add(462, "Rufiyaa", "MVR", 2);
        m_ISOCurrencyData.add(979, "Mexican Unidad de Inversion (UDI)", "MXV", 2);
        m_ISOCurrencyData.add(860, "Uzbekistan Som", "UZS", 2);
        m_ISOCurrencyData.add(12, "Algerian Dinar", "DZD", 2);
        m_ISOCurrencyData.add(332, "Haiti Gourde", "HTG", 2);
        m_ISOCurrencyData.add(963, "Code reserved for testing purposes", "XTS", 0);
        m_ISOCurrencyData.add(32, "Argentine Peso", "ARS", 2);
        m_ISOCurrencyData.add(642, "Romanian Leu", "ROL", 2);
        m_ISOCurrencyData.add(984, "Bolivian Mvdol (Funds code)", "BOV", 2);
        m_ISOCurrencyData.add(440, "Lithuanian Litas", "LTL", 2);
        m_ISOCurrencyData.add(480, "Mauritius Rupee", "MUR", 2);
        m_ISOCurrencyData.add(426, "Loti", "LSL", 2);
        m_ISOCurrencyData.add(262, "Djibouti Franc", "DJF", 0);
        m_ISOCurrencyData.add(886, "Yemeni Rial", "YER", 2);
        m_ISOCurrencyData.add(748, "Lilangeni", "SZL", 2);
        m_ISOCurrencyData.add(192, "Cuban Peso", "CUP", 2);
        m_ISOCurrencyData.add(548, "Vatu", "VUV", 0);
        m_ISOCurrencyData.add(360, "Rupiah", "IDR", 2);
        m_ISOCurrencyData.add(51, "Armenian Dram", "AMD", 2);
        m_ISOCurrencyData.add(894, "Kwacha", "ZMK", 2);
        m_ISOCurrencyData.add(90, "Solomon Islands Dollar", "SBD", 2);
        m_ISOCurrencyData.add(132, "Cape Verde Escudo", "CVE", 2);
        m_ISOCurrencyData.add(999, "No currency", "XXX", 0);
        m_ISOCurrencyData.add(524, "Nepalese Rupee", "NPR", 2);
        m_ISOCurrencyData.add(203, "Czech Koruna", "CZK", 2);
        m_ISOCurrencyData.add(44, "Bahamian Dollar", "BSD", 2);
        m_ISOCurrencyData.add(96, "Brunei Dollar", "BND", 2);
        m_ISOCurrencyData.add(50, "Bangladeshi Taka", "BDT", 2);
        m_ISOCurrencyData.add(404, "Kenyan Shilling", "KES", 2);
        m_ISOCurrencyData.add(947, "WIR Euro ", "CHE", 2);
        m_ISOCurrencyData.add(964, "Palladium (one Troy ounce)", "XPD", 0);
        m_ISOCurrencyData.add(398, "Tenge", "KZT", 2);
        m_ISOCurrencyData.add(352, "Iceland Krona", "ISK", 2);
        m_ISOCurrencyData.add(64, "Ngultrum", "BTN", 2);
        m_ISOCurrencyData.add(533, "Aruban Guilder", "AWG", 2);
        m_ISOCurrencyData.add(230, "Ethiopian Birr", "ETB", 2);
        m_ISOCurrencyData.add(800, "Uganda Shilling", "UGX", 2);
        m_ISOCurrencyData.add(968, "Surinam Dollar", "SRD", 2);
        m_ISOCurrencyData.add(882, "Samoan Tala", "WST", 2);
        m_ISOCurrencyData.add(454, "Kwacha", "MWK", 2);
        m_ISOCurrencyData.add(985, "Zloty", "PLN", 2);
        m_ISOCurrencyData.add(124, "Canadian Dollar", "CAD", 2);
        m_ISOCurrencyData.add(776, "Pa'anga", "TOP", 2);
        m_ISOCurrencyData.add(208, "Danish Krone", "DKK", 2);
        m_ISOCurrencyData.add(108, "Burundian Franc", "BIF", 0);
        m_ISOCurrencyData.add(764, "Baht", "THB", 2);
        m_ISOCurrencyData.add(458, "Malaysian Ringgit", "MYR", 2);
        m_ISOCurrencyData.add(364, "Iranian Rial", "IRR", 2);
        m_ISOCurrencyData.add(600, "Guarani", "PYG", 0);
        m_ISOCurrencyData.add(977, "Convertible Marks", "BAM", 2);
        m_ISOCurrencyData.add(446, "Pataca", "MOP", 2);
        m_ISOCurrencyData.add(780, "Trinidad and Tobago Dollar", "TTD", 2);
        m_ISOCurrencyData.add(703, "Slovak Koruna", "SKK", 2);
        m_ISOCurrencyData.add(958, "European Unit of Account 17 (E.U.A.-17)", "XBD", 0);
        m_ISOCurrencyData.add(430, "Liberian Dollar", "LRD", 2);
        m_ISOCurrencyData.add(191, "Croatian Kuna", "HRK", 2); 
        m_ISOCurrencyData.add(694, "Leone", "SLL", 2); 
        m_ISOCurrencyData.add(756, "Swiss Franc", "CHF", 2); 
        m_ISOCurrencyData.add(969, "Malagasy Ariary", "MGA", 0);
        m_ISOCurrencyData.add(270, "Dalasi", "GMD", 2);
        m_ISOCurrencyData.add(418, "Kip", "LAK", 2);
        m_ISOCurrencyData.add(516, "Namibian Dollar", "NAD", 2);
        m_ISOCurrencyData.add(392, "Japanese yen", "JPY", 0);
        m_ISOCurrencyData.add(320, "Quetzal", "GTQ", 2);
        m_ISOCurrencyData.add(554, "New Zealand Dollar", "NZD", 2);
        m_ISOCurrencyData.add(578, "Norwegian Krone", "NOK", 2);
        m_ISOCurrencyData.add(376, "New Israeli Shekel", "ILS", 2);
        m_ISOCurrencyData.add(957, "European Unit of Account 9 (E.U.A.-9)", "XBC", 0);
        m_ISOCurrencyData.add(498, "Moldovan Leu", "MDL", 2);
        m_ISOCurrencyData.add(998, "", "USS", 2);
        m_ISOCurrencyData.add(955, "European Composite Unit (EURCO)", "XBA", 0);
        m_ISOCurrencyData.add(344, "Hong Kong Dollar", "HKD", 2);
        m_ISOCurrencyData.add(417, "Som", "KGS", 2);
        m_ISOCurrencyData.add(858, "Peso Uruguayo", "UYU", 2);
        m_ISOCurrencyData.add(60, "Bermudian Dollar ", "BMD", 2);
        m_ISOCurrencyData.add(682, "Saudi Riyal", "SAR", 2);
        m_ISOCurrencyData.add(643, "Russian Ruble", "RUB", 2);
        m_ISOCurrencyData.add(470, "Maltese Lira", "MTL", 2);
        m_ISOCurrencyData.add(340, "Lempira", "HNL", 2);
        m_ISOCurrencyData.add(72, "Pula", "BWP", 2);
        m_ISOCurrencyData.add(368, "Iraqi Dinar", "IQD", 3);
        m_ISOCurrencyData.add(188, "Costa Rican Colon", "CRC", 2);
        m_ISOCurrencyData.add(144, "Sri Lanka Rupee", "LKR", 2);
        m_ISOCurrencyData.add(752, "Swedish Krona", "SEK", 2);
        m_ISOCurrencyData.add(136, "Cayman Islands Dollar", "KYD", 2);
        m_ISOCurrencyData.add(8, "Lek", "ALL", 2);
        m_ISOCurrencyData.add(48, "Bahraini Dinar", "BHD", 3);
        m_ISOCurrencyData.add(795, "Manat", "TMM", 2);
        m_ISOCurrencyData.add(938, "Sudanese Pound", "SDG", 2);
        m_ISOCurrencyData.add(590, "Balboa", "PAB", 2);
        m_ISOCurrencyData.add(152, "Chilean Peso", "CLP", 0);
        m_ISOCurrencyData.add(980, "Hryvnia", "UAH", 2);
        m_ISOCurrencyData.add(428, "Latvian Lats", "LVL", 2);
        m_ISOCurrencyData.add(288, "Cedi", "GHS", 2);
        m_ISOCurrencyData.add(978, "Euro", "EUR", 2);
        m_ISOCurrencyData.add(976, "Franc Congolais", "CDF", 2);
        m_ISOCurrencyData.add(586, "Pakistan Rupee", "PKR", 2);
        m_ISOCurrencyData.add(408, "North Korean Won", "KPW", 2);
        m_ISOCurrencyData.add(388, "Jamaican Dollar", "JMD", 2);
        m_ISOCurrencyData.add(990, "Unidades de formento", "CLF", 0);
        m_ISOCurrencyData.add(971, "Afghani", "AFN", 2);
        m_ISOCurrencyData.add(975, "Bulgarian Lev", "BGN", 2);
        m_ISOCurrencyData.add(36, "Australian Dollar", "AUD", 2);
        m_ISOCurrencyData.add(238, "Falkland Islands Pound", "FKP", 2);
        m_ISOCurrencyData.add(901, "New Taiwan Dollar", "TWD", 2);
        m_ISOCurrencyData.add(784, "United Arab Emirates dirham", "AED", 2);

        // the ISO country data
        m_ISOCountryData = new net.thepaymentgateway.common.ISOCountryList();
        m_ISOCountryData.add(826, "United Kingdom", "GBR", 3);
	m_ISOCountryData.add(840, "United States", "USA", 2);
	m_ISOCountryData.add(36, "Australia", "AUS", 1);
	m_ISOCountryData.add(124, "Canada", "CAN", 1);
	m_ISOCountryData.add(250, "France", "FRA", 1);
	m_ISOCountryData.add(276, "Germany", "DEU", 1);
	m_ISOCountryData.add(4, "Afghanistan", "AFG", 0);
	m_ISOCountryData.add(248, "land Islands", "ALA", 0);	
	m_ISOCountryData.add(8, "Albania", "ALB", 0);
	m_ISOCountryData.add(12, "Algeria", "DZA", 0);
	m_ISOCountryData.add(16, "American Samoa", "ASM", 0);
	m_ISOCountryData.add(20, "Andorra", "AND", 0);
	m_ISOCountryData.add(24, "Angola", "AGO", 0);
	m_ISOCountryData.add(660, "Anguilla", "AIA", 0);
	m_ISOCountryData.add(10, "Antarctica", "ATA", 0);
	m_ISOCountryData.add(28, "Antigua and Barbuda", "ATG", 0);
	m_ISOCountryData.add(32, "Argentina", "ARG", 0);
	m_ISOCountryData.add(51, "Armenia", "ARM", 0);
	m_ISOCountryData.add(533, "Aruba", "ABW", 0);
	m_ISOCountryData.add(40, "Austria", "AUT", 0);
	m_ISOCountryData.add(31, "Azerbaijan", "AZE", 0);
	m_ISOCountryData.add(44, "Bahamas", "BHS", 0);
	m_ISOCountryData.add(48, "Bahrain", "BHR", 0);
	m_ISOCountryData.add(50, "Bangladesh", "BGD", 0);
	m_ISOCountryData.add(52, "Barbados", "BRB", 0);
	m_ISOCountryData.add(112, "Belarus", "BLR", 0);
	m_ISOCountryData.add(56, "Belgium", "BEL", 0);
	m_ISOCountryData.add(84, "Belize", "BLZ", 0);
	m_ISOCountryData.add(204, "Benin", "BEN", 0);
	m_ISOCountryData.add(60, "Bermuda", "BMU", 0);
	m_ISOCountryData.add(64, "Bhutan", "BTN", 0);
	m_ISOCountryData.add(68, "Bolivia", "BOL", 0);
	m_ISOCountryData.add(70, "Bosnia and Herzegovina", "BIH", 0);
	m_ISOCountryData.add(72, "Botswana", "BWA", 0);
	m_ISOCountryData.add(74, "Bouvet Island", "BVT", 0);
	m_ISOCountryData.add(76, "Brazil Federative", "BRA", 0);
	m_ISOCountryData.add(86, "British Indian Ocean Territory", "IOT", 0);
	m_ISOCountryData.add(96, "Brunei", "BRN", 0);
	m_ISOCountryData.add(100, "Bulgaria", "BGR", 0);
	m_ISOCountryData.add(854, "Burkina Faso", "BFA", 0);
	m_ISOCountryData.add(108, "Burundi", "BDI", 0);
	m_ISOCountryData.add(116, "Cambodia", "KHM", 0);
	m_ISOCountryData.add(120, "Cameroon", "CMR", 0);
	m_ISOCountryData.add(132, "Cape Verde", "CPV", 0);
	m_ISOCountryData.add(136, "Cayman Islands", "CYM", 0);
	m_ISOCountryData.add(140, "Central African Republic", "CAF", 0);
	m_ISOCountryData.add(148, "Chad", "TCD", 0);
	m_ISOCountryData.add(152, "Chile", "CHL", 0);
	m_ISOCountryData.add(156, "China", "CHN", 0);
	m_ISOCountryData.add(162, "Christmas Island", "CXR", 0);
	m_ISOCountryData.add(166, "Cocos (Keeling) Islands", "CCK", 0);
	m_ISOCountryData.add(170, "Colombia", "COL", 0);
	m_ISOCountryData.add(174, "Comoros", "COM", 0);
        m_ISOCountryData.add(180, "Congo, the Democratic Republic of the", "COD", 0);
	m_ISOCountryData.add(178, "Congo", "COG", 0);
	m_ISOCountryData.add(184, "Cook Islands", "COK", 0);
	m_ISOCountryData.add(188, "Costa Rica", "CRI", 0);
	m_ISOCountryData.add(384, "Cte d'Ivoire", "CIV", 0);
	m_ISOCountryData.add(191, "Croatia", "HRV", 0);
	m_ISOCountryData.add(192, "Cuba", "CUB", 0);
	m_ISOCountryData.add(196, "Cyprus", "CYP", 0);
	m_ISOCountryData.add(203, "Czech Republic", "CZE", 0);
	m_ISOCountryData.add(208, "Denmark", "DNK", 0);
	m_ISOCountryData.add(262, "Djibouti", "DJI", 0);
	m_ISOCountryData.add(212, "Dominica", "DMA", 0);
	m_ISOCountryData.add(214, "Dominican Republic", "DOM", 0);
	m_ISOCountryData.add(626, "East Timor", "TMP", 0);
	m_ISOCountryData.add(218, "Ecuador", "ECU", 0);
	m_ISOCountryData.add(818, "Egypt", "EGY", 0);
	m_ISOCountryData.add(222, "El Salvador", "SLV", 0);
	m_ISOCountryData.add(226, "Equatorial Guinea", "GNQ", 0);
	m_ISOCountryData.add(232, "Eritrea", "ERI", 0);
	m_ISOCountryData.add(233, "Estonia", "EST", 0);
	m_ISOCountryData.add(231, "Ethiopia", "ETH", 0);
	m_ISOCountryData.add(238, "Falkland Islands (Malvinas)", "FLK", 0);
	m_ISOCountryData.add(234, "Faroe Islands", "FRO", 0);
	m_ISOCountryData.add(242, "Fiji", "FJI", 0);
	m_ISOCountryData.add(246, "Finland", "FIN", 0);
	m_ISOCountryData.add(254, "French Guiana", "GUF", 0);
	m_ISOCountryData.add(258, "French Polynesia", "PYF", 0);
	m_ISOCountryData.add(260, "French Southern Territories", "ATF", 0);
	m_ISOCountryData.add(266, "Gabon", "GAB", 0);
	m_ISOCountryData.add(270, "Gambia", "GMB", 0);
	m_ISOCountryData.add(268, "Georgia", "GEO", 0);
	m_ISOCountryData.add(288, "Ghana", "GHA", 0);
	m_ISOCountryData.add(292, "Gibraltar", "GIB", 0);
	m_ISOCountryData.add(300, "Greece", "GRC", 0);
	m_ISOCountryData.add(304, "Greenland", "GRL", 0);
	m_ISOCountryData.add(308, "Grenada", "GRD", 0);
	m_ISOCountryData.add(312, "Guadaloupe", "GLP", 0);
	m_ISOCountryData.add(316, "Guam", "GUM", 0);
	m_ISOCountryData.add(320, "Guatemala", "GTM", 0);
	m_ISOCountryData.add(831, "Guernsey", "GGY", 0);
	m_ISOCountryData.add(324, "Guinea", "GIN", 0);
	m_ISOCountryData.add(624, "Guinea-Bissau", "GNB", 0);
	m_ISOCountryData.add(328, "Guyana", "GUY", 0);
	m_ISOCountryData.add(332, "Haiti", "HTI", 0);
	m_ISOCountryData.add(334, "Heard Island and McDonald Islands", "HMD", 0);
	m_ISOCountryData.add(340, "Honduras", "HND", 0);
	m_ISOCountryData.add(344, "Hong Kong", "HKG", 0);
	m_ISOCountryData.add(348, "Hungary", "HUN", 0);
	m_ISOCountryData.add(352, "Iceland", "ISL", 0);
	m_ISOCountryData.add(356, "India", "IND", 0);
	m_ISOCountryData.add(360, "Indonesia", "IDN", 0);
	m_ISOCountryData.add(364, "Iran", "IRN", 0);
	m_ISOCountryData.add(368, "Iraq", "IRQ", 0);
	m_ISOCountryData.add(372, "Ireland", "IRL", 0);
	m_ISOCountryData.add(833, "Isle of Man", "IMN", 0);
	m_ISOCountryData.add(376, "Israel", "ISR", 0);
	m_ISOCountryData.add(380, "Italy", "ITA", 0);
	m_ISOCountryData.add(388, "Jamaica", "JAM", 0);
	m_ISOCountryData.add(392, "Japan", "JPN", 0);
	m_ISOCountryData.add(832, "Jersey", "JEY", 0);
	m_ISOCountryData.add(400, "Jordan", "JOR", 0);
	m_ISOCountryData.add(398, "Kazakhstan", "KAZ", 0);
	m_ISOCountryData.add(404, "Kenya", "KEN", 0);
	m_ISOCountryData.add(296, "Kiribati", "KIR", 0);
        m_ISOCountryData.add(410, "Korea, Republic of", "KOR", 0);
        m_ISOCountryData.add(408, "Korea, Democratic People's Republic of", "PRK", 0);
	m_ISOCountryData.add(414, "Kuwait", "KWT", 0);
	m_ISOCountryData.add(417, "Kyrgyzstan", "KGZ", 0);
	m_ISOCountryData.add(418, "Lao", "LAO", 0);
	m_ISOCountryData.add(428, "Latvia", "LVA", 0);
	m_ISOCountryData.add(422, "Lebanon", "LBN", 0);
	m_ISOCountryData.add(426, "Lesotho", "LSO", 0);
	m_ISOCountryData.add(430, "Liberia", "LBR", 0);
	m_ISOCountryData.add(434, "Libyan Arab Jamahiriya", "LBY", 0);
	m_ISOCountryData.add(438, "Liechtenstein", "LIE", 0);
	m_ISOCountryData.add(440, "Lithuania", "LTU", 0);
	m_ISOCountryData.add(442, "Luxembourg", "LUX", 0);
	m_ISOCountryData.add(446, "Macau", "MAC", 0);
	m_ISOCountryData.add(807, "Macedonia", "MKD", 0);
	m_ISOCountryData.add(450, "Madagascar", "MDG", 0);
	m_ISOCountryData.add(454, "Malawi", "MWI", 0);
	m_ISOCountryData.add(458, "Malaysia", "MYS", 0);
	m_ISOCountryData.add(462, "Maldives", "MDV", 0);
	m_ISOCountryData.add(466, "Mali", "MLI", 0);
	m_ISOCountryData.add(470, "Malta", "MLT", 0);
	m_ISOCountryData.add(584, "Marshall Islands", "MHL", 0);
	m_ISOCountryData.add(474, "Martinique", "MTQ", 0);
	m_ISOCountryData.add(478, "Mauritania Islamic", "MRT", 0);
	m_ISOCountryData.add(480, "Mauritius", "MUS", 0);
	m_ISOCountryData.add(175, "Mayotte", "MYT", 0);
	m_ISOCountryData.add(484, "Mexico", "MEX", 0);
	m_ISOCountryData.add(583, "Micronesia", "FSM", 0);
	m_ISOCountryData.add(498, "Moldova", "MDA", 0);
	m_ISOCountryData.add(492, "Monaco", "MCO", 0);
	m_ISOCountryData.add(496, "Mongolia", "MNG", 0);
	m_ISOCountryData.add(499, "Montenegro", "MNE", 0);	
	m_ISOCountryData.add(500, "Montserrat", "MSR", 0);
	m_ISOCountryData.add(504, "Morocco", "MAR", 0);
	m_ISOCountryData.add(508, "Mozambique", "MOZ", 0);
	m_ISOCountryData.add(104, "Myanmar", "MMR", 0);
	m_ISOCountryData.add(516, "Namibia", "NAM", 0);
	m_ISOCountryData.add(520, "Nauru", "NRU", 0);
	m_ISOCountryData.add(524, "Nepal", "NPL", 0);
	m_ISOCountryData.add(528, "Netherlands", "NLD", 0);
	m_ISOCountryData.add(530, "Netherlands Antilles", "ANT", 0);
	m_ISOCountryData.add(540, "New Caledonia", "NCL", 0);
	m_ISOCountryData.add(554, "New Zealand", "NZL", 0);
	m_ISOCountryData.add(558, "Nicaragua", "NIC", 0);
	m_ISOCountryData.add(562, "Niger", "NER", 0);
	m_ISOCountryData.add(566, "Nigeria", "NGA", 0);
	m_ISOCountryData.add(570, "Niue", "NIU", 0);
	m_ISOCountryData.add(574, "Norfolk Island", "NFK", 0);
	m_ISOCountryData.add(580, "Northern Mariana Islands", "MNP", 0);
	m_ISOCountryData.add(578, "Norway", "NOR", 0);
	m_ISOCountryData.add(512, "Oman", "OMN", 0);
	m_ISOCountryData.add(586, "Pakistan", "PAK", 0);
	m_ISOCountryData.add(585, "Palau", "PLW", 0);
	m_ISOCountryData.add(275, "Palestine", "PSE", 0);	
	m_ISOCountryData.add(591, "Panama", "PAN", 0);
	m_ISOCountryData.add(598, "Papua New Guinea", "PNG", 0);
	m_ISOCountryData.add(600, "Paraguay", "PRY", 0);
	m_ISOCountryData.add(604, "Peru", "PER", 0);
	m_ISOCountryData.add(608, "Philippines", "PHL", 0);
	m_ISOCountryData.add(612, "Pitcairn", "PCN", 0);
	m_ISOCountryData.add(616, "Poland", "POL", 0);
	m_ISOCountryData.add(620, "Portugal", "PRT", 0);
	m_ISOCountryData.add(630, "Puerto Rico", "PRI", 0);
	m_ISOCountryData.add(634, "Qatar", "QAT", 0);
	m_ISOCountryData.add(638, "Runion", "REU", 0);
	m_ISOCountryData.add(642, "Romania", "ROM", 0);
	m_ISOCountryData.add(643, "Russian Federation", "RUS", 0);
	m_ISOCountryData.add(646, "Rwanda", "RWA", 0);
	m_ISOCountryData.add(652, "Saint Barthlemy", "BLM", 0);
	m_ISOCountryData.add(654, "Saint Helena", "SHN", 0);
	m_ISOCountryData.add(659, "Saint Kitts and Nevis", "KNA", 0);
	m_ISOCountryData.add(662, "Saint Lucia", "LCA", 0);
	m_ISOCountryData.add(663, "Saint Martin (French part)", "MAF", 0);
	m_ISOCountryData.add(666, "Saint Pierre and Miquelon", "SPM", 0);
	m_ISOCountryData.add(670, "Saint Vincent and the Grenadines", "VCT", 0);
	m_ISOCountryData.add(882, "Samoa", "WSM", 0);
	m_ISOCountryData.add(674, "San Marino", "SMR", 0);
	m_ISOCountryData.add(678, "So Tom and Prncipe Democratic", "STP", 0);
	m_ISOCountryData.add(682, "Saudi Arabia", "SAU", 0);
	m_ISOCountryData.add(686, "Senegal", "SEN", 0);
	m_ISOCountryData.add(688, "Serbia", "SRB", 0);
	m_ISOCountryData.add(690, "Seychelles", "SYC", 0);
	m_ISOCountryData.add(694, "Sierra Leone", "SLE", 0);
	m_ISOCountryData.add(702, "Singapore", "SGP", 0);
	m_ISOCountryData.add(703, "Slovakia", "SVK", 0);
	m_ISOCountryData.add(705, "Slovenia", "SVN", 0);
	m_ISOCountryData.add(90, "Solomon Islands", "SLB", 0);
	m_ISOCountryData.add(706, "Somalia", "SOM", 0);
	m_ISOCountryData.add(710, "South Africa", "ZAF", 0);
	m_ISOCountryData.add(239, "South Georgia and the South Sandwich Islands", "SGS", 0);
	m_ISOCountryData.add(724, "Spain", "ESP", 0);
	m_ISOCountryData.add(144, "Sri Lanka", "LKA", 0);
	m_ISOCountryData.add(736, "Sudan", "SDN", 0);
	m_ISOCountryData.add(740, "Suriname", "SUR", 0);
	m_ISOCountryData.add(744, "Svalbard and Jan Mayen", "SJM", 0);
	m_ISOCountryData.add(748, "Swaziland", "SWZ", 0);
	m_ISOCountryData.add(752, "Sweden", "SWE", 0);
	m_ISOCountryData.add(756, "Switzerland", "CHE", 0);
	m_ISOCountryData.add(760, "Syrian Arab Republic", "SYR", 0);
	m_ISOCountryData.add(158, "Taiwan, ", "TWN", 0);
	m_ISOCountryData.add(762, "Tajikistan", "TJK", 0);
	m_ISOCountryData.add(834, "Tanzania", "TZA", 0);
	m_ISOCountryData.add(764, "Thailand", "THA", 0);
	m_ISOCountryData.add(768, "Togo", "TGO", 0);
	m_ISOCountryData.add(772, "Tokelau", "TKL", 0);
	m_ISOCountryData.add(776, "Tonga", "TON", 0);
	m_ISOCountryData.add(780, "Trinidad and Tobago", "TTO", 0);
	m_ISOCountryData.add(788, "Tunisia", "TUN", 0);
	m_ISOCountryData.add(792, "Turkey", "TUR", 0);
	m_ISOCountryData.add(795, "Turkmenistan", "TKM", 0);
	m_ISOCountryData.add(796, "Turks and Caicos Islands", "TCA", 0);
	m_ISOCountryData.add(798, "Tuvalu", "TUV", 0);
	m_ISOCountryData.add(800, "Uganda", "UGA", 0);
	m_ISOCountryData.add(804, "Ukraine", "UKR", 0);
	m_ISOCountryData.add(784, "United Arab Emirates", "ARE", 0);
	m_ISOCountryData.add(581, "United States Minor Outlying Islands", "UMI", 0);
	m_ISOCountryData.add(858, "Uruguay Eastern", "URY", 0);
	m_ISOCountryData.add(860, "Uzbekistan", "UZB", 0);
	m_ISOCountryData.add(548, "Vanuatu", "VUT", 0);
	m_ISOCountryData.add(336, "Vatican City State", "VAT", 0);
	m_ISOCountryData.add(862, "Venezuela", "VEN", 0);
	m_ISOCountryData.add(704, "Vietnam", "VNM", 0);
	m_ISOCountryData.add(92, "Virgin Islands,  British", "VGB", 0);
	m_ISOCountryData.add(850, "Virgin Islands,  U.S.", "VIR", 0);
	m_ISOCountryData.add(876, "Wallis and Futuna", "WLF", 0);
	m_ISOCountryData.add(732, "Western Sahara", "ESH", 0);
	m_ISOCountryData.add(887, "Yemen", "YEM", 0);
	m_ISOCountryData.add(894, "Zambia", "ZMB", 0);
	m_ISOCountryData.add(716, "Zimbabwe", "ZWE", 0);
    }

    public net.thepaymentgateway.common.ISOCountryList getISOCountryData() 
    {
        return m_ISOCountryData;
    }

    public net.thepaymentgateway.common.ISOCurrencyList getISOCurrencyData() 
    {
        return m_ISOCurrencyData;
    }

    public String getMerchantID() 
    {
        return m_merchantID;
    }

    public String getPassword() 
    {
        return m_password;
    }

    public String getPaymentProcessorFullDomain() 
    {
        return m_paymentProcessorFullDomain;
    }    

    public String getSecretKey() 
    {
        return m_secretKey;
    }    
}