<jsp:useBean id="global" class="net.mycompanyname.Global" scope="application" />

<%
    net.thepaymentgateway.paymentsystem.RequestGatewayEntryPointList requestGatewayEntryPointList;
    net.thepaymentgateway.paymentsystem.CrossReferenceTransaction crossReferenceTransaction;
    net.thepaymentgateway.paymentsystem.OutCrossReferenceTransactionResult crossReferenceTransactionResult;
    net.thepaymentgateway.paymentsystem.OutTransactionOutputData transactionOutputData;
    boolean transactionProcessed;
    int loopIndex;
        
    int amount = 1000;
    int currencyISOCode = 826;
    String orderID = "Order-12345";
    String orderDescription = "A Test Order";
//>>> This will need to be changed to a valid cross reference for this script to work
    String crossReference = "CHANGE_ME_TO_VALID_CROSSREFERENCE";
//<<<
    
    requestGatewayEntryPointList = new net.thepaymentgateway.paymentsystem.RequestGatewayEntryPointList();
    // you need to put the correct gateway entry point urls in here
    // contact support to get the correct urls

    // The actual values to use for the entry points can be established in a number of ways
    // 1) By periodically issuing a call to GetGatewayEntryPoints
    // 2) By storing the values for the entry points returned with each transaction
    // 3) Speculatively firing transactions at https://gw1.xxx followed by gw2, gw3, gw4....
    // The lower the metric (2nd parameter) means that entry point will be attempted first,
    // EXCEPT if it is -1 - in this case that entry point will be skipped
    // NOTE: You do NOT have to add the entry points in any particular order - the list is sorted
    // by metric value before the transaction sumbitting process begins
    // The 3rd parameter is a retry attempt, so it is possible to try that entry point that number of times
    // before failing over onto the next entry point in the list
    requestGatewayEntryPointList.add("https://gw1." + global.getPaymentProcessorFullDomain(), 100, 1);
    requestGatewayEntryPointList.add("https://gw2." + global.getPaymentProcessorFullDomain(), 200, 1);
    requestGatewayEntryPointList.add("https://gw3." + global.getPaymentProcessorFullDomain(), 300, 1);
    
    crossReferenceTransaction = new net.thepaymentgateway.paymentsystem.CrossReferenceTransaction(requestGatewayEntryPointList);
    
    crossReferenceTransaction.getMerchantAuthentication().setMerchantID(global.getMerchantID());
    crossReferenceTransaction.getMerchantAuthentication().setPassword(global.getPassword());

    //Cross reference transactions accept PREAUTH, SALE, COLLECTION, REFUND and VOID
    crossReferenceTransaction.getTransactionDetails().getMessageDetails().setTransactionType("SALE");
    crossReferenceTransaction.getTransactionDetails().getMessageDetails().setCrossReference(crossReference);

    crossReferenceTransaction.getTransactionDetails().getAmount().setValue(amount);
    crossReferenceTransaction.getTransactionDetails().getCurrencyCode().setValue(currencyISOCode);

    crossReferenceTransaction.getTransactionDetails().setOrderID(orderID);
    crossReferenceTransaction.getTransactionDetails().setOrderDescription(orderDescription);
    
    //Optional - cross reference transactions do not perform 3DSecure authentication by default (regardless of MMS setting)
    crossReferenceTransaction.getTransactionDetails().getTransactionControl().getThreeDSecureOverridePolicy().setValue(true);

    crossReferenceTransactionResult = new net.thepaymentgateway.paymentsystem.OutCrossReferenceTransactionResult();
    transactionOutputData = new net.thepaymentgateway.paymentsystem.OutTransactionOutputData();
    transactionProcessed = crossReferenceTransaction.processTransaction(crossReferenceTransactionResult, transactionOutputData);
    
    /**
     * You can handle the results off cross reference transactions exactly the same as card details transactions - each status code means the same thing
     */
    if (!transactionProcessed)
    {
        // could not communicate with the payment gateway 
    }
    else
    {
        switch (crossReferenceTransactionResult.output.getStatusCode())
        {
            case 0:
                // status code of 0 - means transaction successful 
                break;
            case 3:
                // status code of 3 - means 3D Secure authentication required 
                break;
            case 5:
                // status code of 5 - means transaction declined 
                break;
            case 20:
                // status code of 20 - means duplicate transaction 
                break;
            case 30:
                // status code of 30 - means an error occurred 
                break;
            default:
                // unhandled status code  
                break;
        }
    }
%>