<jsp:useBean id="global" class="net.mycompanyname.Global" scope="application" />
<jsp:useBean id="paymentFormHelper" class="net.mycompanyname.PaymentFormHelper" scope="page" />
<jsp:useBean id="paymentForm" class="net.mycompanyname.PaymentForm" scope="page" />

<%
    int width;
    boolean duplicateTransaction;
    String message = "";
    String messageClass = "";
    String siteSecureBaseURL = "";
    net.thepaymentgateway.common.OutISOCurrency outISOCurrency;
    String displayAmount = "";
    net.mycompanyname.ListItemList expiryDateMonthList;
    net.mycompanyname.ListItemList expiryDateYearList;
    net.mycompanyname.ListItemList startDateMonthList;
    net.mycompanyname.ListItemList startDateYearList;
    net.mycompanyname.ListItemList ISOCountryList;
    String bodyAttributes = "";
    String formAttributes = "";
    String formAction = "";
    String hashDigest = "";
    
    paymentForm.preProcessPaymentForm(request, global);
    
    formAction = paymentForm.getFormAction();
    bodyAttributes = paymentForm.getBodyAttributes();
    formAttributes = paymentForm.getFormAttributes();
    
    width = 800;
    %><%@ include file="Templates/FormHeader.tpl" %><%

    switch (paymentForm.getFormModeEnum())
    {
        case net.mycompanyname.PaymentForm.FORM_MODE.RESULTS:
            message = paymentForm.getMessage();
            
            duplicateTransaction = paymentForm.getDuplicateTransaction();

            if (paymentForm.getTransactionSuccessful() == false)
            {
                messageClass = "ErrorMessage";
            }
            else
            {
                messageClass = "SuccessMessage";
            }
            %><%@ include file="Templates/FinalResultsPanel.tpl" %><%            
            break;
        case net.mycompanyname.PaymentForm.FORM_MODE.THREE_D_SECURE:
            siteSecureBaseURL = paymentFormHelper.getSiteSecureBaseURL(request);
            %><%@ include file="Templates/3DSIFrame.tpl" %><%
            break;
	case net.mycompanyname.PaymentForm.FORM_MODE.PAYMENT_FORM:
            message = paymentForm.getMessage();
            if (message != null && !message.equals(""))
            {
                %><%@ include file="Templates/ProcessingErrorResultsPanel.tpl" %><%
            }

            if (paymentForm.getSuppressFormDisplay() == false)
            {
                outISOCurrency = new net.thepaymentgateway.common.OutISOCurrency();
                  
                if (global.getISOCurrencyData().getISOCurrency(paymentForm.getCurrencyShort(), outISOCurrency))
		{
                    displayAmount = outISOCurrency.output.getAmountCurrencyString(Integer.parseInt(paymentForm.getAmount()));
		}

		hashDigest = paymentFormHelper.calculateHashDigest(paymentFormHelper.generateStringToHash(paymentForm.getAmount(),
			                        paymentForm.getCurrencyShort(),
			                        paymentForm.getOrderID(),
			                        paymentForm.getOrderDescription(),
			                        global.getSecretKey()));

		expiryDateMonthList = paymentFormHelper.createExpiryDateMonthListItemList(paymentForm.getExpiryDateMonth());
		expiryDateYearList = paymentFormHelper.createExpiryDateYearListItemList(paymentForm.getExpiryDateYear());
		startDateMonthList = paymentFormHelper.createStartDateMonthListItemList(paymentForm.getStartDateMonth());
		startDateYearList = paymentFormHelper.createStartDateYearListItemList(paymentForm.getStartDateYear());
				
		ISOCountryList = paymentFormHelper.createISOCountryListItemList(paymentForm.getCountryShort(), global.getISOCountryData());
                %><%@ include file="Templates/PaymentForm.tpl" %><%
            }
            break;
    }
%>
<%@ include file="Templates/FormFooter.tpl" %>
