using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using ThePaymentGateway.Common;

namespace MyCompanyName
{
    public partial class StartHere : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            string szStringToBeHashed;
            ISOCurrency icISOCurrency;

            // copy the values from the textboxes to the hidden fields
            hfShoppingCartAmount.Value = "1000";
            hfShoppingCartCurrencyShort.Value = "GBP";
            hfShoppingCartOrderID.Value = "Order-1234";
            hfShoppingCartOrderDescription.Value = "A Test Order";

            if (!Global.ISOCurrencyData.GetISOCurrency(hfShoppingCartCurrencyShort.Value, out icISOCurrency))
            {
                throw new Exception("Couldn't get ISO currency: " + hfShoppingCartCurrencyShort.Value);
            }

            lbAmount.Text = icISOCurrency.GetAmountCurrencyString(System.Convert.ToInt32(hfShoppingCartAmount.Value), false);
            lbCurrencyShort.Text = hfShoppingCartCurrencyShort.Value;
            lbOrderID.Text = hfShoppingCartOrderID.Value;
            lbOrderDescription.Text = hfShoppingCartOrderDescription.Value;

            // generate the string to be hashed
            szStringToBeHashed = PaymentFormHelper.GenerateStringToHash(hfShoppingCartAmount.Value, hfShoppingCartCurrencyShort.Value, hfShoppingCartOrderID.Value, hfShoppingCartOrderDescription.Value, MyCompanyName.Global.SecretKey);
            hfShoppingCartHashDigest.Value = PaymentFormHelper.CalculateHashDigest(szStringToBeHashed);
        }
    }
}
