using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

namespace MyCompanyName
{
    public partial class ThreeDSecureLandingPage : System.Web.UI.Page
    {
        protected internal string m_szThreeDSMethodData;
        protected internal string m_szCRES;
        protected internal string m_szCrossReference;
        protected internal string m_szFormAction;
        protected internal string m_szShoppingCartHashDigest;

        protected void Page_Load(object sender, EventArgs e)
        {
            string szStringToHash;

            if (Request.Form["threeDSMethodData"] != null)
            {
                m_szFormAction = "PaymentForm.aspx";
                m_szThreeDSMethodData = MyCompanyName.PaymentFormHelper.StripAllWhitespace(Request.Form["threeDSMethodData"]);

                szStringToHash = MyCompanyName.PaymentFormHelper.GenerateStringToHash(m_szThreeDSMethodData, Global.SecretKey);

                m_szShoppingCartHashDigest = MyCompanyName.PaymentFormHelper.CalculateHashDigest(szStringToHash);
                BodyTag.Attributes.Add("onload", "document.threeDSecureEnvironmentForm.submit();");
            }
            else if (Request.Form["cres"] != null &&
                     Request.Form["threeDSSessionData"] != null)
            {
                m_szFormAction = "PaymentForm.aspx";
                m_szCRES = MyCompanyName.PaymentFormHelper.StripAllWhitespace(Request.Form["cres"]);
                m_szCrossReference = MyCompanyName.PaymentFormHelper.StripAllWhitespace(Request.Form["threeDSSessionData"]);

                szStringToHash = MyCompanyName.PaymentFormHelper.GenerateStringToHash(m_szCRES, m_szCrossReference, Global.SecretKey);

                m_szShoppingCartHashDigest = MyCompanyName.PaymentFormHelper.CalculateHashDigest(szStringToHash);
                BodyTag.Attributes.Add("onload", "document.threeDSecureChallengeForm.submit();");
            }
            else
            {
                pnMessagePanel.Visible = true;
                lbMessageLabel.Text = "There were errors collecting the responses back from the ACS";
            }
        }
    }
}
