Imports System.Web.Security
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports System.Web.UI.WebControls.WebParts
Imports System.Web.UI.HtmlControls
Imports System.Security.Cryptography
Imports System.Text

''' <summary>
''' Summary description for PaymentFormHelper
''' </summary>
Namespace MyCompanyName
    Public Class PaymentFormHelper
        Public Shared Function GetSiteSecureBaseURL(ByVal hrHTTPRequest As HttpRequest) As String
            Dim szReturnString As String = Nothing
            Dim nIndex As Integer

            szReturnString = hrHTTPRequest.Url.AbsoluteUri

            nIndex = szReturnString.LastIndexOf("/"c)

            szReturnString = szReturnString.Substring(0, nIndex + 1)

            Return szReturnString
        End Function
        Public Shared Function StringToByteArray(ByVal str As String) As Byte()
            Dim encoding As UTF8Encoding = New UTF8Encoding()
            Return encoding.GetBytes(str)
        End Function
        Public Shared Function ByteArrayToHexString(ByVal aByte As Byte()) As String
            Dim sbStringBuilder As StringBuilder
            Dim nCount = 0

            sbStringBuilder = New StringBuilder()
            For nCount = 0 To aByte.Length - 1
                sbStringBuilder.Append(aByte(nCount).ToString("x2"))
            Next

            Return (sbStringBuilder.ToString())
        End Function
        Public Shared Function ForwardPaddedNumberString(ByVal nNumber As Integer, ByVal nPaddingAmount As Integer, ByVal cPaddingChar As Char) As String
            Dim szReturnString As String
            Dim sbString As StringBuilder
            Dim nCount = 0

            szReturnString = nNumber.ToString()

            If szReturnString.Length < nPaddingAmount AndAlso nPaddingAmount > 0 Then
                sbString = New StringBuilder()

                For nCount = 0 To nPaddingAmount - szReturnString.Length - 1
                    sbString.Append(cPaddingChar)
                Next
                sbString.Append(szReturnString)
                szReturnString = sbString.ToString()
            End If
            Return szReturnString
        End Function
        Public Shared Function StripAllWhitespace(ByVal szString As String) As String
            Dim sbReturnString As StringBuilder
            Dim nCount = 0

            If Equals(szString, Nothing) Then
                Return Nothing
            End If

            sbReturnString = New StringBuilder()

            For nCount = 0 To szString.Length - 1
                If szString(nCount) <> " "c AndAlso szString(nCount) <> ChrW(9) AndAlso szString(nCount) <> ChrW(10) AndAlso szString(nCount) <> ChrW(13) Then
                    sbReturnString.Append(szString(nCount))
                End If
            Next
            Return (sbReturnString.ToString())
        End Function
        Public Shared Function CalculateHashDigest(ByVal szInputString As String) As String
            Dim abBytes As Byte()
            Dim abHashDigest As Byte()
            Dim md5 As MD5

            abBytes = StringToByteArray(szInputString)

            md5 = New MD5CryptoServiceProvider()
            abHashDigest = md5.ComputeHash(abBytes)

            Return ByteArrayToHexString(abHashDigest)
        End Function

        Public Shared Function GenerateStringToHash(ByVal szAmount As String, ByVal szCurrencyShort As String, ByVal szOrderID As String, ByVal szOrderDescription As String, ByVal szSecretKey As String) As String

            Dim sbReturnString As StringBuilder

            sbReturnString = New StringBuilder()

            sbReturnString.AppendFormat("Amount={0}&CurrencyShort={1}&OrderID={2}&OrderDescription={3}&SecretKey={4}", szAmount, szCurrencyShort, szOrderID, szOrderDescription, szSecretKey)

            Return (sbReturnString.ToString())
        End Function
        Public Shared Function GenerateStringToHash(ByVal szCRES As String, ByVal szCrossReference As String, ByVal szSecretKey As String) As String
            Dim sbReturnString As StringBuilder

            sbReturnString = New StringBuilder()

            sbReturnString.AppendFormat("CRES={0}&CrossReference={1}&SecretKey={2}", szCRES, szCrossReference, szSecretKey)

            Return (sbReturnString.ToString())
        End Function
        Public Shared Function GenerateStringToHash(ByVal szThreeDSMethodData As String, ByVal szSecretKey As String) As String
            Dim sbReturnString As StringBuilder

            sbReturnString = New StringBuilder()

            sbReturnString.AppendFormat("szThreeDSMethodData={0}&SecretKey={1}", szThreeDSMethodData, szSecretKey)

            Return (sbReturnString.ToString())
        End Function

        ' This is a "hook" function that is run when the results of the transaction are
        ' known. This will be run is 2 places:
        ' 1) After the initial CardDetailsTransaction
        ' 2) After the ThreeDSecureAuthentication transaction (if 3DS was required)
        '
        ' IMPORTANT: in case 1) the unique key is set to be the OrderID, and this will allow
        ' your system to lookup the transaction (in your database) if need be, so you need to ensure
        ' that your orders are reference-able by their order ids
        '
        ' Also, in case 2) the order id field is not avaiable, so the cross reference of the
        ' previous "3DS authentication required" transaction is used as the unique key for
        ' the transactioon. In order to get this working, you must ensure that when a transaction
        ' is set to "3DS auth required" (i.e. the status code is 3), that you update that transaction
        ' so that it can be referenced by the cross refernce of the "3DS required" response
        Public Shared Sub ReportTransactionResults(ByVal szTransactionUniqueKey As String, ByVal nStatusCode As Integer, ByVal szMessage As String, ByVal szCrossReference As String)
            If nStatusCode = 3 Then
                ' you must update the transaction with the szCrossReference field, so that when
                ' this function is called after the 3DS authentication is done, the transaction
                ' is referenceable by that cross reference - as the subsequent post-3DS call to this
                ' function of the transaction will use that cross reference as the transaction's
                ' TransactionUniqueKey
            End If
        End Sub
    End Class
End Namespace
