Imports System
Imports System.Data
Imports System.Configuration
Imports System.Collections
Imports System.Web
Imports System.Web.Security
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports System.Web.UI.WebControls.WebParts
Imports System.Web.UI.HtmlControls
Imports ThePaymentGateway.Common

Namespace MyCompanyName
    Partial Public Class StartHere
        Inherits System.Web.UI.Page
        Protected Sub Page_Load(ByVal sender As Object, ByVal e As EventArgs)
            Dim szStringToBeHashed As String
            Dim icISOCurrency As ISOCurrency

            ' copy the values from the textboxes to the hidden fields
            hfShoppingCartAmount.Value = "1000"
            hfShoppingCartCurrencyShort.Value = "GBP"
            hfShoppingCartOrderID.Value = "Order-1234"
            hfShoppingCartOrderDescription.Value = "A Test Order"

            If Not [Global].ISOCurrencyData.GetISOCurrency(hfShoppingCartCurrencyShort.Value, icISOCurrency) Then
                Throw New Exception("Couldn't get ISO currency: " & hfShoppingCartCurrencyShort.Value)
            End If

            lbAmount.Text = icISOCurrency.GetAmountCurrencyString(System.Convert.ToInt32(hfShoppingCartAmount.Value), False)
            lbCurrencyShort.Text = hfShoppingCartCurrencyShort.Value
            lbOrderID.Text = hfShoppingCartOrderID.Value
            lbOrderDescription.Text = hfShoppingCartOrderDescription.Value

            ' generate the string to be hashed
            szStringToBeHashed = PaymentFormHelper.GenerateStringToHash(hfShoppingCartAmount.Value, hfShoppingCartCurrencyShort.Value, hfShoppingCartOrderID.Value, hfShoppingCartOrderDescription.Value, MyCompanyName.[Global].SecretKey)
            hfShoppingCartHashDigest.Value = PaymentFormHelper.CalculateHashDigest(szStringToBeHashed)
        End Sub
    End Class
End Namespace