Imports System
Imports System.Web.Security
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports System.Web.UI.WebControls.WebParts
Imports System.Web.UI.HtmlControls

Namespace MyCompanyName
    Public Partial Class ThreeDSecureLandingPage
        Inherits Web.UI.Page
        Protected Friend m_szThreeDSMethodData As String
        Protected Friend m_szCRES As String
        Protected Friend m_szCrossReference As String
        Protected Friend m_szFormAction As String
        Protected Friend m_szShoppingCartHashDigest As String

        Protected Sub Page_Load(ByVal sender As Object, ByVal e As EventArgs)
            Dim szStringToHash As String

            If Request.Form("threeDSMethodData") IsNot Nothing Then
                m_szFormAction = "PaymentForm.aspx"
                m_szThreeDSMethodData = MyCompanyName.PaymentFormHelper.StripAllWhitespace(Request.Form("threeDSMethodData"))

                szStringToHash = MyCompanyName.PaymentFormHelper.GenerateStringToHash(m_szThreeDSMethodData, [Global].SecretKey)

                m_szShoppingCartHashDigest = MyCompanyName.PaymentFormHelper.CalculateHashDigest(szStringToHash)
                BodyTag.Attributes.Add("onload", "document.threeDSecureEnvironmentForm.submit();")
            ElseIf Request.Form("cres") IsNot Nothing AndAlso Request.Form("threeDSSessionData") IsNot Nothing Then
                m_szFormAction = "PaymentForm.aspx"
                m_szCRES = MyCompanyName.PaymentFormHelper.StripAllWhitespace(Request.Form("cres"))
                m_szCrossReference = MyCompanyName.PaymentFormHelper.StripAllWhitespace(Request.Form("threeDSSessionData"))

                szStringToHash = MyCompanyName.PaymentFormHelper.GenerateStringToHash(m_szCRES, m_szCrossReference, [Global].SecretKey)

                m_szShoppingCartHashDigest = MyCompanyName.PaymentFormHelper.CalculateHashDigest(szStringToHash)
                BodyTag.Attributes.Add("onload", "document.threeDSecureChallengeForm.submit();")
            Else
                pnMessagePanel.Visible = True
                lbMessageLabel.Text = "There were errors collecting the responses back from the ACS"
            End If
        End Sub
    End Class
End Namespace
