<% Option Explicit %>
<!--#include file = "Config.asp" -->
<!--#include file = "PaymentFormHelper.asp" -->
<%
    Dim Width
    Dim FormAction
    Dim DuplicateTransaction
    Dim PreviousTransactionMessage
    Dim boResultValidationSuccessful
    Dim trTransactionResult
    Dim Message
    Dim MessageClass
    Dim szValidateErrorMessage
    Dim szOutputMessage
    Dim szPaymentFormResultHandler

	Width = 800
    FormAction = ""
%>
<!--#include file = "Templates/FormHeader.tpl" -->
<%
	' what we do here depends on the ResultDeliveryMethod
	DuplicateTransaction = False
	PreviousTransactionMessage = ""

	Select Case ResultDeliveryMethod
		Case "POST"
			' the results will be delivered via POST variables to this
			' page	
			boResultValidationSuccessful = ValidateTransactionResult_POST(MerchantID, _
																   		  Password, _
																		  PreSharedKey, _
																		  HashMethod, _
																		  Request.Form, _
																		  trTransactionResult, _
																		  szValidateErrorMessage)
			' the results need to be stored here as this is the first time
			' they will have touched this system
			If boResultValidationSuccessful = True Then
				If ReportTransactionResults(trTransactionResult, szOutputMessage) = False Then
					' handle the case where the results aren't stored correctly
				End If
			End If
		Case "SERVER"
			' the results have already been delivered via a server-to-server
			' call from the payment form to the ServerResultURL
			' need to query these transaction results to display
			boResultValidationSuccessful = ValidateTransactionResult_SERVER(MerchantID, _
																			Password, _
																			PreSharedKey, _
																			HashMethod, _
																			Request.QueryString, _
																			trTransactionResult, _
																			szValidateErrorMessage)
		Case "SERVER_PULL"
			' need to query the results from the payment form using the passed
			' cross reference
			szPaymentFormResultHandler = "https://mms." & PaymentProcessorDomain & "/Pages/PublicPages/PaymentFormResultHandler.ashx"

			boResultValidationSuccessful = ValidateTransactionResult_SERVER_PULL(MerchantID, _
 																				 Password, _
																				 PreSharedKey, _
																				 HashMethod, _
																				 Request.QueryString, _
																				 szPaymentFormResultHandler, _
																				 trTransactionResult, _
																				 szValidateErrorMessage)
			' the results need to be stored here as this is the first time
			' they will have touched this system
			If boResultValidationSuccessful = True Then
				If ReportTransactionResults(trTransactionResult, szOutputMessage) = False Then
					' handle the case where the results aren't stored correctly
				End If
			End If
	End Select

	' display an error message if the transaction result couldn't be validated
	If boResultValidationSuccessful = False Then
		MessageClass = "ErrorMessage"
		Message = szValidateErrorMessage
	Else
		Select Case trTransactionResult.StatusCode
			Case 0
				MessageClass = "SuccessMessage"
			Case 4
				MessageClass = "ErrorMessage"
			Case 5
				MessageClass = "ErrorMessage"
			Case 20
				DuplicateTransaction = true
				If trTransactionResult.PreviousStatusCode = 0 Then
					MessageClass = "SuccessMessage"
				Else
					MessageClass = "ErrorMessage"
                End If
				PreviousTransactionMessage = trTransactionResult.PreviousMessage
			Case 30
				MessageClass = "ErrorMessage"
			Case Else
				MessageClass = "ErrorMessage"
		End Select

		Message = trTransactionResult.Message
	End If
%>
<!--#include file = "Templates/FinalResultsPanel.tpl" -->
<!--#include file = "Templates/FormFooter.tpl" -->