<% Option Explicit %>
<!--#include file = "Config.asp" -->
<!--#include file = "UTCDateTime.asp" -->
<!--#include file = "PaymentFormHelper.asp" -->
<%
    Dim Width
    Dim FormAction
    Dim szAmount
    Dim szCurrencyCode
    Dim szOrderID
    Dim szTransactionType
    Dim szTransactionDateTime
    Dim szOrderDescription
    Dim szCustomerName
    Dim szAddress1
    Dim szAddress2
    Dim szAddress3
    Dim szAddress4
    Dim szCity
    Dim szState
    Dim szPostCode
    Dim szCountryCode
    Dim szCV2Mandatory
    Dim szAddress1Mandatory
    Dim szCityMandatory
    Dim szStateMandatory
    Dim szPostCodeMandatory
    Dim szCountryMandatory
    Dim szServerResultURL
    Dim szPaymentFormDisplaysResult
    Dim szCallbackURL
    Dim szHashDigest
    Dim szStringToHash

	Width = 800
	FormAction = "https://mms." & PaymentProcessorDomain & "/Pages/PublicPages/PaymentForm.aspx"
%>
<!--#include file = "Templates/FormHeader.tpl" -->
<%
	' the amount in *minor* currency (i.e. 10.00 passed as "1000")
	szAmount = CStr(1000)
	' the currency	- ISO 4217 3-digit numeric (e.g. GBP = 826)
	szCurrencyCode = CStr(826)
	' order ID
	szOrderID = "Order-1234"
	' the transaction type - can be SALE or PREAUTH
	szTransactionType = "SALE"
	' the GMT/UTC relative date/time for the transaction (MUST either be in GMT/UTC 
	' or MUST include the correct timezone offset)
	szTransactionDateTime = GetCurrentUTCDateTime()
	' order description
	szOrderDescription = "A Test Order"
	' these variables allow the payment form to be "seeded" with initial values
	szCustomerName = "A Customer"
	szAddress1 = "14 Some Address"
	szAddress2 = ""
	szAddress3 = ""
	szAddress4 = ""
	szCity = "Some City"
	szState = "Some State"
	szPostCode = "PO57 0DE"
	' the country code - ISO 3166-1  3-digit numeric (e.g. UK = 826)
	szCountryCode = CStr(826)
	' use these to control which fields on the hosted payment form are
	' mandatory
	szCV2Mandatory = CStr(True)
	szAddress1Mandatory = CStr(False)
	szCityMandatory = BoolToString(False)
	szPostCodeMandatory = BoolToString(False)
	szStateMandatory = BoolToString(False)
	szCountryMandatory = BoolToString(False)
	' the URL on this system that the payment form will push the results to (only applicable for 
	' ResultDeliveryMethod = "SERVER")
	If ResultDeliveryMethod <> "SERVER" Then
	   szServerResultURL = ""
	Else
		szServerResultURL = GetSiteSecureBaseURL() & "ReceiveTransactionResult.asp"
	End If
	' set this to true if you want the hosted payment form to display the transaction result
	' to the customer (only applicable for ResultDeliveryMethod = "SERVER")
	If ResultDeliveryMethod <> "SERVER" Then
		szPaymentFormDisplaysResult = ""
	Else
		szPaymentFormDisplaysResult = BoolToString(False)
	End If
	' the callback URL on this site that will display the transaction result to the customer
	' (always required unless ResultDeliveryMethod = "SERVER" and PaymentFormDisplaysResult = "true")
	If ResultDeliveryMethod = "SERVER" AND _
	   StringToBool(szPaymentFormDisplaysResult) = True Then
		szCallbackURL = ""
	Else
		szCallbackURL = GetSiteSecureBaseURL() & "DisplayTransactionResult.asp" 
    End If

	' get the string to be hashed
	szStringToHash = GenerateStringToHash(MerchantID, _
			        					  Password, _
			        					  szAmount, _
										  szCurrencyCode, _
										  szOrderID, _
										  szTransactionType, _
										  szTransactionDateTime, _
										  szCallbackURL, _
										  szOrderDescription, _
										  szCustomerName, _
										  szAddress1, _
										  szAddress2, _
										  szAddress3, _
										  szAddress4, _
										  szCity, _
										  szState, _
										  szPostCode, _
										  szCountryCode, _
										  szCV2Mandatory, _
										  szAddress1Mandatory, _
										  szCityMandatory, _
										  szPostCodeMandatory, _
										  szStateMandatory, _
										  szCountryMandatory, _
										  ResultDeliveryMethod, _
										  szServerResultURL, _
										  szPaymentFormDisplaysResult, _
			         		              PreSharedKey, _
			         		              HashMethod)

	' pass this string into the hash function to create the hash digest
	szHashDigest = CalculateHashDigest(szStringToHash, _
                        			   PreSharedKey, _
                        			   HashMethod)

%>
<!--#include file = "Templates/StartHereForm.tpl" -->
<!--#include file = "Templates/FormFooter.tpl" -->