<cfinclude template="PaymentFormHelper.cfm">

<cfscript>
	Width = 800;
    FormAction = "";
	IncludeTemplate("Templates/FormHeader.tpl");

	// what we do here depends on the ResultDeliveryMethod
	DuplicateTransaction = false;
	PreviousTransactionMessage = "";

	trTransactionResult = StructNew();
	szValidateErrorMessage = StructNew();

	switch (ResultDeliveryMethod)
	{
		case "POST":
			// the results will be delivered via POST variables to this
			// page	
			boResultValidationSuccessful = ValidateTransactionResult_POST(MerchantID, 
																   		  Password, 
																		  PreSharedKey, 
																		  HashMethod,
																		  Form,
																		  trTransactionResult,
																		  szValidateErrorMessage);
			// the results need to be stored here as this is the first time
			// they will have touched this system
			if (boResultValidationSuccessful)
			{
				szOutputMessage = StructNew();

				if (ReportTransactionResults(trTransactionResult, szOutputMessage) NEQ true)
				{
					// handle the case where the results aren't stored correctly
				}
			}
			break;
		case "SERVER":
			// the results have already been delivered via a server-to-server
			// call from the payment form to the ServerResultURL
			// need to query these transaction results to display
			boResultValidationSuccessful = ValidateTransactionResult_SERVER(MerchantID, 
																			Password, 
																			PreSharedKey, 
																			HashMethod,
																			URL,
																			trTransactionResult,
																			szValidateErrorMessage);
			break;
		case "SERVER_PULL":
			// need to query the results from the payment form using the passed
			// cross reference
			szPaymentFormResultHandler = "https://mms." & PaymentProcessorDomain & "/Pages/PublicPages/PaymentFormResultHandler.ashx";

			boResultValidationSuccessful = ValidateTransactionResult_SERVER_PULL(MerchantID, 
																				 Password, 
																				 PreSharedKey, 
																				 HashMethod,
																				 URL,
																				 szPaymentFormResultHandler,
																				 trTransactionResult,
																				 szValidateErrorMessage);
			// the results need to be stored here as this is the first time
			// they will have touched this system
			if (boResultValidationSuccessful)
			{
				szOutputMessage = StructNew();

				if (ReportTransactionResults(trTransactionResult, szOutputMessage) NEQ true)
				{
					// handle the case where the results aren't stored correctly
				}
			}
			break;
	}

	// display an error message if the transaction result couldn't be validated
	if (boResultValidationSuccessful NEQ true)
	{
		MessageClass = "ErrorMessage";
		Message = szValidateErrorMessage.Value;
	}
	else
	{
		switch (trTransactionResult.StatusCode)
		{
			case 0:
				MessageClass = "SuccessMessage";
				break;
			case 4:
				MessageClass = "ErrorMessage";
				break;
			case 5:
				MessageClass = "ErrorMessage";
				break;
			case 20:
				DuplicateTransaction = true;
				if (trTransactionResult.PreviousStatusCode EQ 0)
				{
					MessageClass = "SuccessMessage";
				}
				else
				{
					MessageClass = "ErrorMessage";
				}
				PreviousTransactionMessage = trTransactionResult.PreviousMessage;
				break;
			case 30:
				MessageClass = "ErrorMessage";
				break;
			default:
				MessageClass = "ErrorMessage";
				break;

		}

		Message = trTransactionResult.Message;
	}

	IncludeTemplate("Templates/FinalResultsPanel.tpl");
	IncludeTemplate("Templates/FormFooter.tpl");
</cfscript>