<cfinclude template="PaymentFormHelper.cfm">

<cfscript>
	Width = 800;
	FormAction = "https://mms." & PaymentProcessorDomain & "/Pages/PublicPages/PaymentForm.aspx";
	IncludeTemplate("Templates/FormHeader.tpl");

	// the amount in *minor* currency (i.e. 10.00 passed as "1000")
	szAmount = 1000;
	// the currency	- ISO 4217 3-digit numeric (e.g. GBP = 826)
	szCurrencyCode = 826;
	// order ID
	szOrderID = "Order-1234";
	// the transaction type - can be SALE or PREAUTH
	szTransactionType = "SALE";
	// the GMT/UTC relative date/time for the transaction (MUST either be in GMT/UTC 
	// or MUST include the correct timezone offset)
	szTransactionDateTime = DateFormat(now(), "yyyy-mm-dd") & " " & TimeFormat(now(), "HH:mm:ss") & " " & GetTimeZoneOffset();
	// order description
	szOrderDescription = "A Test Order";
	// these variables allow the payment form to be "seeded" with initial values
	szCustomerName = "A Customer";
	szAddress1 = "14 Some Address";
	szAddress2 = "";
	szAddress3 = "";
	szAddress4 = "";
	szCity = "Some City";
	szState = "Some State";
	szPostCode = "PO57 0DE";
	// the country code - ISO 3166-1  3-digit numeric (e.g. UK = 826)
	szCountryCode = 826;
	// use these to control which fields on the hosted payment form are
	// mandatory
	szCV2Mandatory = true;
	szAddress1Mandatory = false;
	szCityMandatory = false;
	szPostCodeMandatory = false;
	szStateMandatory = false;
	szCountryMandatory = false;
	// the URL on this system that the payment form will push the results to (only applicable for 
	// ResultDeliveryMethod = "SERVER")
	if (ResultDeliveryMethod NEQ "SERVER")
	{
		szServerResultURL = "";
	}
	else
	{
		szServerResultURL = GetSiteSecureBaseURL() & "ReceiveTransactionResult.cfm";
	}
	// set this to true if you want the hosted payment form to display the transaction result
	// to the customer (only applicable for ResultDeliveryMethod = "SERVER")
	if (ResultDeliveryMethod NEQ "SERVER")
	{
		szPaymentFormDisplaysResult = "";
	}
	else
	{
		szPaymentFormDisplaysResult = false;
	}
	// the callback URL on this site that will display the transaction result to the customer
	// (always required unless ResultDeliveryMethod = "SERVER" and PaymentFormDisplaysResult = "true")
	if (ResultDeliveryMethod EQ "SERVER" AND
		szPaymentFormDisplaysResult EQ true)
	{
		szCallbackURL = "";
	}
	else
	{
		szCallbackURL = GetSiteSecureBaseURL() & "DisplayTransactionResult.cfm"; 
	}

	// get the string to be hashed
	szStringToHash = GenerateStringToHash(MerchantID,
			        					  Password,
			        					  szAmount,
										  szCurrencyCode,
										  szOrderID,
										  szTransactionType,
										  szTransactionDateTime,
										  szCallbackURL,
										  szOrderDescription,
										  szCustomerName,
										  szAddress1,
										  szAddress2,
										  szAddress3,
										  szAddress4,
										  szCity,
										  szState,
										  szPostCode,
										  szCountryCode,
										  szCV2Mandatory,
										  szAddress1Mandatory,
										  szCityMandatory,
										  szPostCodeMandatory,
										  szStateMandatory,
										  szCountryMandatory,
										  ResultDeliveryMethod,
										  szServerResultURL,
										  szPaymentFormDisplaysResult,
			         		              PreSharedKey,
			         		              HashMethod);

	// pass this string into the hash function to create the hash digest
	szHashDigest = CalculateHashDigest(szStringToHash,
                        			   PreSharedKey, 
                        			   HashMethod);

	IncludeTemplate("Templates/StartHereForm.tpl");
	IncludeTemplate("Templates/FormFooter.tpl");
</cfscript>