<%@ page import="net.mycompanyname.OutString" %>
<%@ page import="net.mycompanyname.OutTransactionResult" %>

<jsp:useBean id="global" class="net.mycompanyname.Global" scope="application" />
<jsp:useBean id="paymentFormHelper" class="net.mycompanyname.PaymentFormHelper" scope="page" />
<%
    int width;
    String formAction;
    boolean duplicateTransaction;
    String previousTransactionMessage;
    boolean resultValidationSuccessful = false;
    OutTransactionResult transactionResult = null;
    String message;
    String messageClass;
    OutString validateErrorMessage = null;
    OutString outputMessage = null;
    String paymentFormResultHandler;

    width = 800;
    formAction = "";
%>
<%@ include file="Templates/FormHeader.tpl" %>
<%
    // what we do here depends on the ResultDeliveryMethod
    duplicateTransaction = false;
    previousTransactionMessage = "";

    if (global.getResultDeliveryMethod().equalsIgnoreCase("POST"))
    {
        // the results will be delivered via POST variables to this
        // page	
        transactionResult = new OutTransactionResult();
        validateErrorMessage = new OutString();
        
        resultValidationSuccessful = paymentFormHelper.validateTransactionResult_POST(global.getMerchantID(),
                                                                                      global.getPassword(),
                                                                                      global.getPreSharedKey(),
                                                                                      global.getHashMethod(),
                                                                                      request,
                                                                                      transactionResult,
                                                                                      validateErrorMessage);
        // the results need to be stored here as this is the first time
        // they will have touched this system
        if (resultValidationSuccessful)
        {
            outputMessage = new OutString();
            
            if (!paymentFormHelper.reportTransactionResults(transactionResult.output, outputMessage))
            {
                // handle the case where the results aren't stored correctly
            }
        }
    }
    else if (global.getResultDeliveryMethod().equalsIgnoreCase("SERVER"))
    {
        // the results have already been delivered via a server-to-server
        // call from the payment form to the ServerResultURL
        // need to query these transaction results to display
        transactionResult = new OutTransactionResult();
        validateErrorMessage = new OutString();
        
        resultValidationSuccessful = paymentFormHelper.validateTransactionResult_SERVER(global.getMerchantID(),
                                                                                        global.getPassword(),
                                                                                        global.getPreSharedKey(),
                                                                                        global.getHashMethod(),
                                                                                        request,
                                                                                        transactionResult,
                                                                                        validateErrorMessage);
    }
    else if (global.getResultDeliveryMethod().equalsIgnoreCase("SERVER_PULL"))
    {
        // need to query the results from the payment form using the passed
        // cross reference
        transactionResult = new OutTransactionResult();
        validateErrorMessage = new OutString();
        
        paymentFormResultHandler = "https://mms." + global.getPaymentProcessorDomain() + "/Pages/PublicPages/PaymentFormResultHandler.ashx";

        resultValidationSuccessful = paymentFormHelper.validateTransactionResult_SERVER_PULL(global.getMerchantID(),
                                                                                             global.getPassword(),
                                                                                             global.getPreSharedKey(),
                                                                                             global.getHashMethod(),
                                                                                             request,
                                                                                             paymentFormResultHandler,
                                                                                             transactionResult,
                                                                                             validateErrorMessage);
        // the results need to be stored here as this is the first time
        // they will have touched this system
        if (resultValidationSuccessful)
        {
            outputMessage = new OutString();
            
            if (!paymentFormHelper.reportTransactionResults(transactionResult.output, outputMessage))
            {
                // handle the case where the results aren't stored correctly
            }
        }
    }
    else
    {
        resultValidationSuccessful = false;
        messageClass = "ErrorMessage";
        message = "Invalid result delivery method: " + global.getResultDeliveryMethod();
    }

    // display an error message if the transaction result couldn't be validated
    if (!resultValidationSuccessful)
    {
        messageClass = "ErrorMessage";
        message = validateErrorMessage.output;
    }
    else
    {
        switch (transactionResult.output.getStatusCode())
        {
            case 0:
		messageClass = "SuccessMessage";
                break;
            case 4:
                messageClass = "ErrorMessage";
                break;
            case 5:
                messageClass = "ErrorMessage";
                break;
            case 20:
                duplicateTransaction = true;
                if (transactionResult.output.getPreviousStatusCode().getValue() == 0)
                {
                    messageClass = "SuccessMessage";
                }
                else
                {
                    messageClass = "ErrorMessage";
                }
                previousTransactionMessage = transactionResult.output.getPreviousMessage();
                break;
            case 30:
                messageClass = "ErrorMessage";
                break;
            default:
                messageClass = "ErrorMessage";
                break;
        }

        message = transactionResult.output.getMessage();
    }
%>
<%@ include file="Templates/FinalResultsPanel.tpl" %>
<%@ include file="Templates/FormFooter.tpl" %>