<%@ page import="java.text.SimpleDateFormat" %>
<%@ page import="java.util.Date" %>

<jsp:useBean id="global" class="net.mycompanyname.Global" scope="application" />
<jsp:useBean id="paymentFormHelper" class="net.mycompanyname.PaymentFormHelper" scope="page" />

<%   
    int width;
    String formAction;
    String amount;
    String currencyCode;
    String orderID;
    String transactionType;
    String transactionDateTime;
    SimpleDateFormat dateFormat;
    String orderDescription;
    String customerName;
    String address1;
    String address2;
    String address3;
    String address4;
    String city;
    String state;
    String postCode;
    String countryCode;
    String cv2Mandatory;
    String address1Mandatory;
    String cityMandatory;
    String postCodeMandatory;
    String stateMandatory;
    String countryMandatory;
    String serverResultURL;
    String paymentFormDisplaysResult;
    String callbackURL;
    String stringToHash;
    String hashDigest;
    
    width = 800;
    formAction = "https://mms." + global.getPaymentProcessorDomain() + "/Pages/PublicPages/PaymentForm.aspx";    
%>
<%@ include file="Templates/FormHeader.tpl" %>
<%
    // the amount in *minor* currency (i.e. 10.00 passed as "1000")
    amount = Integer.toString(1000);
    // the currency - ISO 4217 3-digit numeric (e.g. GBP = 826)
    currencyCode = Integer.toString(826);
    // order ID
    orderID = "Order-1234";
    // the transaction type - can be SALE or PREAUTH
    transactionType = "SALE";
    // the GMT/UTC relative date/time for the transaction (MUST either be in GMT/UTC 
    // or MUST include the correct timezone offset)
    dateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss Z");
    transactionDateTime = dateFormat.format(new Date());
    // order description
    orderDescription = "A Test Order";
    // these variables allow the payment form to be "seeded" with initial values
    customerName = "A Customer";
    address1 = "14 Some Address";
    address2 = "";
    address3 = "";
    address4 = "";
    city = "Some City";
    state = "Some State";
    postCode = "PO57 0DE";
    // the country code - ISO 3166-1  3-digit numeric (e.g. UK = 826)
    countryCode = Integer.toString(826);
    // use these to control which fields on the hosted payment form are
    // mandatory
    cv2Mandatory = Boolean.toString(true);
    address1Mandatory = Boolean.toString(false);
    cityMandatory = Boolean.toString(false);
    postCodeMandatory = Boolean.toString(false);
    stateMandatory = Boolean.toString(false);
    countryMandatory = Boolean.toString(false);
    // the URL on this system that the payment form will push the results to (only applicable for 
    // ResultDeliveryMethod = "SERVER")
    if (!global.getResultDeliveryMethod().equals("SERVER"))
    {
        serverResultURL = "";
    }
    else
    {
        serverResultURL = paymentFormHelper.getSiteSecureBaseURL(request) + "ReceiveTransactionResult.jsp";
    }
    // set this to true if you want the hosted payment form to display the transaction result
    // to the customer (only applicable for ResultDeliveryMethod = "SERVER")
    if (!global.getResultDeliveryMethod().equals("SERVER"))
    {
        paymentFormDisplaysResult = "";
    }
    else
    {
        paymentFormDisplaysResult = Boolean.toString(false);
    }
    // the callback URL on this site that will display the transaction result to the customer
    // (always required unless ResultDeliveryMethod = "SERVER" and PaymentFormDisplaysResult = "true")
    if (global.getResultDeliveryMethod().equals("SERVER") &&
        Boolean.valueOf(paymentFormDisplaysResult) == Boolean.TRUE)
    {
        callbackURL = "";
    }
    else
    {
        callbackURL = paymentFormHelper.getSiteSecureBaseURL(request) + "DisplayTransactionResult.jsp"; 
    }

    // get the string to be hashed
    stringToHash = paymentFormHelper.generateStringToHash(global.getMerchantID(),
                                                          global.getPassword(),
                                                          amount,
                                                          currencyCode,
                                                          orderID,
                                                          transactionType,
                                                          transactionDateTime,
                                                          callbackURL,
                                                          orderDescription,
                                                          customerName,
                                                          address1,
                                                          address2,
                                                          address3,
                                                          address4,
                                                          city,
                                                          state,
                                                          postCode,
                                                          countryCode,
                                                          cv2Mandatory,
                                                          address1Mandatory,
                                                          cityMandatory,
                                                          postCodeMandatory,
                                                          stateMandatory,
                                                          countryMandatory,
                                                          global.getResultDeliveryMethod(),
                                                          serverResultURL,
                                                          paymentFormDisplaysResult,
                                                          global.getPreSharedKey(),
                                                          global.getHashMethod());

    // pass this string into the hash function to create the hash digest
    hashDigest = paymentFormHelper.calculateHashDigest(stringToHash,
                                                       global.getPreSharedKey(),
                                                       global.getHashMethod());
%>
<%@ include file="Templates/StartHereForm.tpl" %>
<%@ include file="Templates/FormFooter.tpl" %>