package net.mycompanyname;

public class Global 
{
    private String m_merchantID;
    private String m_password;
    private String m_paymentProcessorDomain;    
    private String m_hashMethod;
    private String m_preSharedKey;
    private String m_resultDeliveryMethod;
    
    /** Creates a new instance of Global */
    public Global() 
    {
        // Will need to set these variables to valid a MerchantID and Password
        // These were obtained during sign up
        m_merchantID = "Need Valid MerchantID";
        m_password = "Need Valid Password";

	// The domain ONLY for the hosted payment form - e.g. if the hosted payment form URL is
	// https://mms.paymentprocessor.net/Pages/PublicPages/PaymentForm.aspx, then the domain
	// will be "paymentprocessor.net"
        m_paymentProcessorDomain = "payvector.net";

        // The chosen hash method - can be either "MD5", "SHA1", "HMACMD5" or "HMACSHA1"
	// This method MUST match the hash method set for the merchant in the MMS
	m_hashMethod = "SHA1";

	// This is the PreSharedKey known to both this system and the payment system
	// This MUST match the PreSharedKey set for the merchant in the MMS
	m_preSharedKey = "Need Valid PreSharedKey";

	// determines how the transaction result will be delivered back to this site:
	// "POST" - only use if this site has an SSL certificate. Best method to use if you do have an SSL
	// "SERVER" - best method with no SSL - don't use if this site requires to maintain 
	//			  cookie-based session to access its order object)
	// "SERVER_PULL" - only use if no SSL and site also requires cookie-based session to access 
	//			  	   its order object
	m_resultDeliveryMethod = "SERVER_PULL";                 
    }

    public String getMerchantID() 
    {
        return m_merchantID;
    }

    public String getPassword() 
    {
        return m_password;
    }

    public String getPaymentProcessorDomain() 
    {
        return m_paymentProcessorDomain;
    }    

    public String getHashMethod()
    {
        return m_hashMethod;
    }
    
    public String getPreSharedKey() 
    {
        return m_preSharedKey;
    }    

    public String getResultDeliveryMethod() 
    {
        return m_resultDeliveryMethod;
    }  
}