package net.mycompanyname;

import java.io.InputStreamReader;
import java.net.URLConnection;
import java.net.URLDecoder;
import java.net.URLEncoder;
import javax.servlet.http.HttpServletRequest;
import java.security.MessageDigest;
import javax.crypto.Mac;
import javax.crypto.spec.SecretKeySpec;
import java.security.Key;
import java.util.Enumeration;
import java.net.URL;
import java.net.URLConnection;
import java.io.DataOutputStream;
import java.io.InputStreamReader;
import java.io.DataInputStream;

public class PaymentFormHelper
{
    public static String getSiteSecureBaseURL(HttpServletRequest request)
    {
        String szReturnString;
        StringBuffer sbString = null;
        int nIndex;
        
        sbString = request.getRequestURL();

        nIndex = sbString.lastIndexOf("/");

        szReturnString = sbString.substring(0, nIndex + 1);

        return (szReturnString);
    }

    public static NameValueList parseNameValueStringIntoArray(String nameValueString, boolean  urlDecodeValues)
    {
        String[] postVariables;
        String[] singleVariable;
        String variable;
        NameValueList parsedVariables;
        String name;
        String value;
        int count;

        // break the reponse into an array
        // first break the variables up using the "&" delimter
        postVariables = nameValueString.split("&");

        parsedVariables = new NameValueList();

        for (count = 0; count < postVariables.length; count++)
        {
            // for each variable, split is again on the "=" delimiter
            // to give name/value pairs
            variable = postVariables[count];
            
            singleVariable = variable.split("=");
            name = singleVariable[0];
            
            if (!urlDecodeValues)
            {
                try
                {
                    value = singleVariable[1];
                }
                catch (Exception e)
                {
                    value = "";
                }
            }
            else
            {
                try
                {
                    value = URLDecoder.decode(singleVariable[1], "UTF-8");
                }
                catch (Exception e)
                {
                    value = "";
                }
            }

            parsedVariables.add(name, value);
        }

        return (parsedVariables);
    }
    
    public static NameValueList parseIntoList(HttpServletRequest request)
    {
        boolean finished = false;
        int count = 0;
        Enumeration parameters;
        String parameterName;
        String parameterValue;
        NameValueList nameValueList;
        
        nameValueList = new NameValueList();
        
        if (request != null)
        {
            parameters = request.getParameterNames();
            
            while (!finished &&
                   parameters.hasMoreElements())
            {
                try
                {
                    parameterName = (String)parameters.nextElement();
                    parameterValue = request.getParameter(parameterName);

                    nameValueList.add(parameterName, parameterValue);
                }
                catch (Exception e)
                {
                    finished = true;
                }
            }
        }
        
        return nameValueList;
    }
            
    public static boolean getTransactionReferenceFromQueryString(NameValueList nameValueList, OutString crossReference, OutString orderID, OutString hashDigest, OutString outputMessage)
    {
        boolean errorOccured;

        hashDigest.output = "";
        outputMessage.output = "";
        errorOccured = false;
        crossReference.output = null;
        orderID.output = null;

        try
        {
            // hash digest
            if (nameValueList.existsInList("HashDigest"))
            {
                hashDigest.output = nameValueList.get("HashDigest").getValue();
            }

            // cross reference of transaction
            if (!nameValueList.existsInList("CrossReference"))
            {
                outputMessage.output = addStringToStringList(outputMessage.output, "Expected variable [CrossReference] not received");
                errorOccured = true;
            }
            else
            {
                crossReference.output = nameValueList.get("CrossReference").getValue();
            }
            // order ID (same as value passed into payment form - echoed back out by payment form)
            if (!nameValueList.existsInList("OrderID"))
            {
                outputMessage.output = addStringToStringList(outputMessage.output, "Expected variable [OrderID] not received");
                errorOccured = true;
            }
            else
            {
                orderID.output = nameValueList.get("OrderID").getValue();;
            }
        }
        catch (Exception e)
        {
            errorOccured = true;
            outputMessage.output = e.getMessage();
        }

        return (!errorOccured);
    }
    public static boolean getTransactionResultFromPostVariables(NameValueList nameValueList, OutTransactionResult transactionResult, OutString hashDigest, OutString outputMessage)
    {
        boolean errorOccured;
        int statusCode = 30;
        String message = null;
        NullableInt previousStatusCode = new NullableInt();
        String previousMessage = null;
        String crossReference = null;
        int amount = 0;
        int currencyCode = 0;   
        String orderID = null;
        String transactionType = null;
        String transactionDateTime = null;
        String orderDescription = null;
        String customerName = null;
        String address1 = null;
        String address2 = null;
        String address3 = null;
        String address4 = null;
        String city = null;
        String state = null;
        String postCode = null;
        NullableInt countryCode = new NullableInt();

        transactionResult.output = null;
        hashDigest.output = "";
        outputMessage.output = "";			
        errorOccured = false;

        try
        {
            // hash digest
            if (nameValueList.existsInList("HashDigest"))
            {
                hashDigest.output = nameValueList.get("HashDigest").getValue();
            }

            // transaction status code
            if (!nameValueList.existsInList("StatusCode"))
            {
                outputMessage.output = addStringToStringList(outputMessage.output, "Expected variable [StatusCode] not received");
                errorOccured = true;
            }
            else
            {
                statusCode = Integer.parseInt(nameValueList.get("StatusCode").getValue());
            }
            // transaction message
            if (!nameValueList.existsInList("Message"))
            {
                outputMessage.output = addStringToStringList(outputMessage.output, "Expected variable [Message] not received");
                errorOccured = true;
            }
            else
            {
                message = nameValueList.get("Message").getValue();
            }
            // status code of original transaction if this transaction was deemed a duplicate
            if (!nameValueList.existsInList("PreviousStatusCode"))
            {
                outputMessage.output = addStringToStringList(outputMessage.output, "Expected variable [PreviousStatusCode] not received");
                errorOccured = true;
            }
            else
            {
                if (!isStringNullOrEmpty(nameValueList.get("PreviousStatusCode").getValue()))
                {
                    previousStatusCode.setValue(Integer.parseInt(nameValueList.get("PreviousStatusCode").getValue()));
                }
            }
            // status code of original transaction if this transaction was deemed a duplicate
            if (!nameValueList.existsInList("PreviousMessage"))
            {
                outputMessage.output = addStringToStringList(outputMessage.output, "Expected variable [PreviousMessage] not received");
                errorOccured = true;
            }
            else
            {
                previousMessage = nameValueList.get("PreviousMessage").getValue();
            }
            // cross reference of transaction
            if (!nameValueList.existsInList("CrossReference"))
            {
                outputMessage.output = addStringToStringList(outputMessage.output, "Expected variable [CrossReference] not received");
                errorOccured = true;
            }
            else
            {
                crossReference = nameValueList.get("CrossReference").getValue();
            }
            // amount (same as value passed into payment form - echoed back out by payment form)
            if (!nameValueList.existsInList("Amount"))
            {
                outputMessage.output = addStringToStringList(outputMessage.output, "Expected variable [Amount] not received");
                errorOccured = true;
            }
            else
            {
                amount = Integer.parseInt(nameValueList.get("Amount").getValue());
            }
            // currency code (same as value passed into payment form - echoed back out by payment form)
            if (!nameValueList.existsInList("CurrencyCode"))
            {
                outputMessage.output = addStringToStringList(outputMessage.output, "Expected variable [CurrencyCode] not received");
                errorOccured = true;
            }
            else
            {
                currencyCode = Integer.parseInt(nameValueList.get("CurrencyCode").getValue());
            }
            // order ID (same as value passed into payment form - echoed back out by payment form)
            if (!nameValueList.existsInList("OrderID"))
            {
                outputMessage.output = addStringToStringList(outputMessage.output, "Expected variable [OrderID] not received");
                errorOccured = true;
            }
            else
            {
                orderID = nameValueList.get("OrderID").getValue();
            }
            // transaction type (same as value passed into payment form - echoed back out by payment form)
            if (!nameValueList.existsInList("TransactionType"))
            {
                outputMessage.output = addStringToStringList(outputMessage.output, "Expected variable [TransactionType] not received");
                errorOccured = true;
            }
            else
            {
                transactionType = nameValueList.get("TransactionType").getValue();
            }
            // transaction date/time (same as value passed into payment form - echoed back out by payment form)
            if (!nameValueList.existsInList("TransactionDateTime"))
            {
                outputMessage.output = addStringToStringList(outputMessage.output, "Expected variable [TransactionDateTime] not received");
                errorOccured = true;
            }
            else
            {
                transactionDateTime = nameValueList.get("TransactionDateTime").getValue();
            }
            // order description (same as value passed into payment form - echoed back out by payment form)
            if (!nameValueList.existsInList("OrderDescription"))
            {
                outputMessage.output = addStringToStringList(outputMessage.output, "Expected variable [OrderDescription] not received");
                errorOccured = true;
            }
            else
            {
                orderDescription = nameValueList.get("OrderDescription").getValue();
            }
            // customer name (not necessarily the same as value passed into payment form - as the customer can change it on the form)
            if (!nameValueList.existsInList("CustomerName"))
            {
                outputMessage.output = addStringToStringList(outputMessage.output, "Expected variable [CustomerName] not received");
                errorOccured = true;
            }
            else
            {
                customerName = nameValueList.get("CustomerName").getValue();
            }
            // address1 (not necessarily the same as value passed into payment form - as the customer can change it on the form)
            if (!nameValueList.existsInList("Address1"))
            {
                outputMessage.output = addStringToStringList(outputMessage.output, "Expected variable [Address1] not received");
                errorOccured = true;
            }
            else
            {
                address1 = nameValueList.get("Address1").getValue();
            }
            // address2 (not necessarily the same as value passed into payment form - as the customer can change it on the form)
            if (!nameValueList.existsInList("Address2"))
            {
                outputMessage.output = addStringToStringList(outputMessage.output, "Expected variable [Address2] not received");
                errorOccured = true;
            }
            else
            {
                address2 = nameValueList.get("Address2").getValue();
            }
            // address3 (not necessarily the same as value passed into payment form - as the customer can change it on the form)
            if (!nameValueList.existsInList("Address3"))
            {
                outputMessage.output = addStringToStringList(outputMessage.output, "Expected variable [Address3] not received");
                errorOccured = true;
            }
            else
            {
                address3 = nameValueList.get("Address3").getValue();
            }
            // address4 (not necessarily the same as value passed into payment form - as the customer can change it on the form)
            if (!nameValueList.existsInList("Address4"))
            {
                outputMessage.output = addStringToStringList(outputMessage.output, "Expected variable [Address4] not received");
                errorOccured = true;
            }
            else
            {
                address4 = nameValueList.get("Address4").getValue();
            }
            // city (not necessarily the same as value passed into payment form - as the customer can change it on the form)
            if (!nameValueList.existsInList("City"))
            {
                outputMessage.output = addStringToStringList(outputMessage.output, "Expected variable [City] not received");
                errorOccured = true;
            }
            else
            {
                city = nameValueList.get("City").getValue();
            }
            // state (not necessarily the same as value passed into payment form - as the customer can change it on the form)
            if (!nameValueList.existsInList("State"))
            {
                outputMessage.output = addStringToStringList(outputMessage.output, "Expected variable [State] not received");
                errorOccured = true;
            }
            else
            {
                state = nameValueList.get("State").getValue();
            }
            // post code (not necessarily the same as value passed into payment form - as the customer can change it on the form)
            if (!nameValueList.existsInList("PostCode"))
            {
                outputMessage.output = addStringToStringList(outputMessage.output, "Expected variable [PostCode] not received");
                errorOccured = true;
            }
            else
            {
                postCode = nameValueList.get("PostCode").getValue();
            }
            // country code (not necessarily the same as value passed into payment form - as the customer can change it on the form)
            if (!nameValueList.existsInList("CountryCode"))
            {
                outputMessage.output = addStringToStringList(outputMessage.output, "Expected variable [CountryCode] not received");
                errorOccured = true;
            }
            else
            {
                if (!isStringNullOrEmpty(nameValueList.get("CountryCode").getValue()))
                {
                    countryCode.setValue(Integer.parseInt(nameValueList.get("CountryCode").getValue()));
                }
            }

            if (!errorOccured)
            {
                transactionResult.output = new TransactionResult();
                transactionResult.output.setStatusCode(statusCode); // transaction status code
                transactionResult.output.setMessage(message); // transaction message
                transactionResult.output.setPreviousStatusCode(previousStatusCode); // status code of original transaction if duplicate transaction
                transactionResult.output.setPreviousMessage(previousMessage); // status code of original transaction if duplicate transaction
                transactionResult.output.setCrossReference(crossReference);	// cross reference of transaction
                transactionResult.output.setAmount(amount); // amount echoed back
                transactionResult.output.setCurrencyCode(currencyCode); // currency code echoed back
                transactionResult.output.setOrderID(orderID); // order ID echoed back
                transactionResult.output.setTransactionType(transactionType); // transaction type echoed back
                transactionResult.output.setTransactionDateTime(transactionDateTime); // transaction date/time echoed back
                transactionResult.output.setOrderDescription(orderDescription); // order description echoed back
                // the customer details that were actually
                // processed  = might be different
                // from those passed to the payment form
                transactionResult.output.setCustomerName(customerName);
                transactionResult.output.setAddress1(address1);
                transactionResult.output.setAddress2(address2);
                transactionResult.output.setAddress3(address3);
                transactionResult.output.setAddress4(address4);
                transactionResult.output.setCity(city);
                transactionResult.output.setState(state);
                transactionResult.output.setPostCode(postCode);
                transactionResult.output.setCountryCode(countryCode);
            }
        }
        catch (Exception e)
        {
            errorOccured = true;
            outputMessage.output = e.getMessage();
        }

        return (!errorOccured);
    }
    public static String addStringToStringList(String existingStringList, String stringToAdd)
    {
        String commaString;
        StringBuffer returnString;

        returnString = new StringBuffer();
        commaString = "";

        if (isStringNullOrEmpty(stringToAdd))
        {
            returnString.append(existingStringList);
        }
        else
        {
            if (!isStringNullOrEmpty(existingStringList))
            {
                commaString = ", ";
            }
            returnString.append(existingStringList);
            returnString.append(commaString);
            returnString.append(stringToAdd);
        }

        return (returnString.toString());
    }
    
    public static boolean isStringNullOrEmpty(String String)
    {
        boolean returnValue = false;
        
        if (String == null || String.equals("") || String.equals("null"))
        {
            returnValue = true;
        }
        return (returnValue);
    }
    
    public static String byteArrayToHexString(byte[] bytes)
    {
        StringBuffer returnString;
        int count;
        
        returnString = new StringBuffer();
        
        for (count = 0; count < bytes.length; count++) 
        {
            returnString.append(Integer.toString((bytes[count] & 0xff) + 0x100, 16).substring(1));
        }
        return returnString.toString();
    }

    public static String calculateHashDigest(String inputString, String preSharedKey, String hashMethod)
    {
        byte[] hashDigest;
        byte[] psk;
        Key key;
        Mac mac;
        MessageDigest messageDigest;
        String returnString;

        try
        {
            if (isStringNullOrEmpty(hashMethod))
            {
                throw new Exception("Invalid hash method");
            }
            
            if (hashMethod.equals("MD5") ||
                hashMethod.equals("SHA1"))
            {
                if (hashMethod.equals("MD5"))
                {
                    messageDigest = MessageDigest.getInstance("MD5");
                }
                else
                {
                    messageDigest = MessageDigest.getInstance("SHA-1");
                }
                
                hashDigest = messageDigest.digest(inputString.getBytes("UTF-8"));
            }
            else
            {
                if (hashMethod.equals("HMACMD5") ||
                    hashMethod.equals("HMACSHA1"))
                {
                    psk = preSharedKey.getBytes("UTF-8");
                    
                    if (hashMethod.equals("HMACMD5"))
                    {
                        key = new SecretKeySpec(psk, 0, psk.length, "HmacMD5");
                        mac = Mac.getInstance("HmacMD5");
                    }
                    else
                    {
                        key = new SecretKeySpec(psk, 0, psk.length, "HmacSHA1");
                        mac = Mac.getInstance("HmacSHA1");
                    }
                    mac.init(key);
                    hashDigest = mac.doFinal(inputString.getBytes("UTF-8"));
                }
                else
                {
                    throw new Exception("Unsupported hash method: " + hashMethod);
                }
            }
            
            returnString = byteArrayToHexString(hashDigest);
        }
        catch (Exception e)
        {
            returnString = e.getMessage();
        }

        return (returnString);
    }
    
    public static String generateStringToHash(String merchantID,
                                              String password,
                                              String amount,
                                              String currencyCode,
                                              String orderID,
                                              String transactionType,
                                              String transactionDateTime,
                                              String callbackURL,
                                              String orderDescription,
                                              String customerName,
                                              String address1,
                                              String address2,
                                              String address3,
                                              String address4,
                                              String city,
                                              String state,
                                              String postCode,
                                              String countryCode,
                                              String cv2Mandatory,
                                              String address1Mandatory,
                                              String cityMandatory,
                                              String postCodeMandatory,
                                              String stateMandatory,
                                              String countryMandatory,
                                              String resultDeliveryMethod,
                                              String serverResultURL,
                                              String paymentFormDisplaysResult,
                                              String preSharedKey,
                                              String hashMethod)
    {
        StringBuffer returnString;

        returnString = new StringBuffer();

        // simple hash methods aren't seeded on initialisation
        // with the PSK, so it's "influence" on the hash digest must
        // be more direct - i.e. it's included in the String to be hashed
        if (!isStringNullOrEmpty(hashMethod) &&
            (hashMethod.equals("MD5") ||
            hashMethod.equals("SHA1")))
        {
            returnString.append("PreSharedKey=");            
            returnString.append(preSharedKey);
            returnString.append("&");
        }
        returnString.append("MerchantID=");
        returnString.append(merchantID);
        returnString.append("&Password=");
        returnString.append(password);
        returnString.append("&Amount=");
        returnString.append(amount);
        returnString.append("&CurrencyCode=");
        returnString.append(currencyCode);
        returnString.append("&OrderID=");
        returnString.append(orderID);
        returnString.append("&TransactionType=");
        returnString.append(transactionType);
        returnString.append("&TransactionDateTime=");
        returnString.append(transactionDateTime);
        returnString.append("&CallbackURL=");
        returnString.append(callbackURL);
        returnString.append("&OrderDescription=");
        returnString.append(orderDescription);
        returnString.append("&CustomerName=");
        returnString.append(customerName);
        returnString.append("&Address1=");
        returnString.append(address1);
        returnString.append("&Address2=");
        returnString.append(address2);
        returnString.append("&Address3=");
        returnString.append(address3);
        returnString.append("&Address4=");
        returnString.append(address4);
        returnString.append("&City=");
        returnString.append(city);
        returnString.append("&State=");
        returnString.append(state);
        returnString.append("&PostCode=");
        returnString.append(postCode);
        returnString.append("&CountryCode=");
        returnString.append(countryCode);
        returnString.append("&CV2Mandatory=");
        returnString.append(cv2Mandatory);
        returnString.append("&Address1Mandatory=");
        returnString.append(address1Mandatory);
        returnString.append("&CityMandatory=");
        returnString.append(cityMandatory);
        returnString.append("&PostCodeMandatory=");
        returnString.append(postCodeMandatory);
        returnString.append("&StateMandatory=");
        returnString.append(stateMandatory);
        returnString.append("&CountryMandatory=");
        returnString.append(countryMandatory);
        returnString.append("&ResultDeliveryMethod=");
        returnString.append(resultDeliveryMethod);
        returnString.append("&ServerResultURL=");
        returnString.append(serverResultURL);
        returnString.append("&PaymentFormDisplaysResult=");
        returnString.append(paymentFormDisplaysResult);
        returnString.append("&ServerResultURLCookieVariables=");
        returnString.append("&ServerResultURLFormVariables=");
        returnString.append("&ServerResultURLQueryStringVariables=");

        return (returnString.toString());
    }
    public static String generateStringToHash(String merchantID,
                                              String password,
                                              TransactionResult transactionResult,
                                              String preSharedKey,
                                              String hashMethod)
    {
        StringBuffer returnString;

        returnString = new StringBuffer();

        // simple hash methods aren't seeded on initialisation
        // with the PSK, so it's "influence" on the hash digest must
        // be more direct - i.e. it's included in the String to be hashed
        if (!isStringNullOrEmpty(hashMethod) &&
            (hashMethod.equals("MD5") ||
            hashMethod.equals("SHA1")))
        {
            returnString.append("PreSharedKey=");            
            returnString.append(preSharedKey);
            returnString.append("&");
        }

        returnString.append("MerchantID=");
        returnString.append(merchantID);
        returnString.append("&Password=");
        returnString.append(password);
        returnString.append("&StatusCode=");
        returnString.append(transactionResult.getStatusCode());
        returnString.append("&Message=");
        returnString.append(transactionResult.getMessage());
        returnString.append("&PreviousStatusCode=");
        if (transactionResult.getPreviousStatusCode().getHasValue())
        {
            try
            {
                returnString.append(transactionResult.getPreviousStatusCode().getValue());
            } 
            catch (Exception e) 
            {
            }
        }
        returnString.append("&PreviousMessage=");
        returnString.append(transactionResult.getPreviousMessage());
        returnString.append("&CrossReference=");
        returnString.append(transactionResult.getCrossReference());
        returnString.append("&Amount=");
        returnString.append(transactionResult.getAmount());
        returnString.append("&CurrencyCode=");
        returnString.append(transactionResult.getCurrencyCode());
        returnString.append("&OrderID=");
        returnString.append(transactionResult.getOrderID());
        returnString.append("&TransactionType=");
        returnString.append(transactionResult.getTransactionType());
        returnString.append("&TransactionDateTime=");
        returnString.append(transactionResult.getTransactionDateTime());
        returnString.append("&OrderDescription=");
        returnString.append(transactionResult.getOrderDescription());
        returnString.append("&CustomerName=");
        returnString.append(transactionResult.getCustomerName());
        returnString.append("&Address1=");
        returnString.append(transactionResult.getAddress1());
        returnString.append("&Address2=");
        returnString.append(transactionResult.getAddress2()); 
        returnString.append("&Address3=");
        returnString.append(transactionResult.getAddress3());
        returnString.append("&Address4=");
        returnString.append(transactionResult.getAddress4());
        returnString.append("&City=");
        returnString.append(transactionResult.getCity());
        returnString.append("&State=");
        returnString.append(transactionResult.getState()); 
        returnString.append("&PostCode=");
        returnString.append(transactionResult.getPostCode());
        returnString.append("&CountryCode=");
        if (transactionResult.getCountryCode().getHasValue())
        {
            try
            {
                returnString.append(transactionResult.getCountryCode().getValue());
            }
            catch (Exception e)
            {
            }
        }

        return (returnString.toString());
    }
    public static String generateStringToHash(String merchantID,
                                              String password,
                                              String crossReference,
                                              String orderID,
                                              String preSharedKey,
                                              String hashMethod)
    {
        StringBuffer returnString;

        returnString = new StringBuffer();

        // simple hash methods aren't seeded on initialisation
        // with the PSK, so it's "influence" on the hash digest must
        // be more direct - i.e. it's included in the String to be hashed
        if (!isStringNullOrEmpty(hashMethod) &&
            (hashMethod.equals("MD5") ||
            hashMethod.equals("SHA1")))
        {
            returnString.append("PreSharedKey=");            
            returnString.append(preSharedKey);
            returnString.append("&");
        }

        returnString.append("MerchantID=");
        returnString.append(merchantID);
        returnString.append("&Password=");
        returnString.append(password);
        returnString.append("&CrossReference=");
        returnString.append(crossReference);
        returnString.append("&OrderID=");
        returnString.append(orderID);

        return (returnString.toString());
    }
    
    public static boolean  validateTransactionResult_POST(String merchantID,
                                                          String password, 
                                                          String preSharedKey, 
                                                          String hashMethod,
                                                          HttpServletRequest request,
                                                          OutTransactionResult transactionResult,
                                                          OutString validateErrorMessage)
    {
        boolean errorOccurred;
        OutString hashDigest;
        OutString outputMessage;
        String stringToHash;
        String calculatedHashDigest;
        NameValueList nameValueList;

        errorOccurred = false;

        validateErrorMessage.output = "";
        transactionResult.output = null;
        hashDigest = new OutString();
        outputMessage = new OutString();                
        
        nameValueList = parseIntoList(request);
        
        // read the transaction result variables from the post variable list
        if (!getTransactionResultFromPostVariables(nameValueList, transactionResult, hashDigest, outputMessage))
        {
            errorOccurred = true;
            validateErrorMessage.output = outputMessage.output;
        }
        else
        {
            // now need to validate the hash digest
            stringToHash = generateStringToHash(merchantID, password, transactionResult.output, preSharedKey,  hashMethod);
            calculatedHashDigest = calculateHashDigest(stringToHash, preSharedKey,  hashMethod);
			
            // does the calculated hash match the one that was passed?
            if (!hashDigest.output.equalsIgnoreCase(calculatedHashDigest))
            {
                errorOccurred = true;
                validateErrorMessage.output = "Hash digests don't match - possible variable tampering";
            }
            else
            {
                errorOccurred = false;
            }
        }

        return (!errorOccurred);
    }
    public static boolean validateTransactionResult_SERVER(String merchantID, 
                                                           String password, 
                                                           String preSharedKey, 
                                                           String hashMethod,
                                                           HttpServletRequest request,
                                                           OutTransactionResult transactionResult,
                                                           OutString validateErrorMessage)
    {
        boolean errorOccurred;
        OutString crossReference;
        OutString orderID;
        OutString hashDigest;
        OutString outputMessage;
        String stringToHash;
        String calculatedHashDigest;
        NameValueList nameValueList;

        errorOccurred = false;

        validateErrorMessage.output = "";
        transactionResult.output = null;
        crossReference = new OutString();
        orderID = new OutString();
        hashDigest = new OutString();
        outputMessage = new OutString();
        
        nameValueList = parseIntoList(request);
        
        // read the transaction reference variables from the query String variable list
        if (!getTransactionReferenceFromQueryString(nameValueList, crossReference, orderID, hashDigest, outputMessage))
        {
            errorOccurred = true;
            validateErrorMessage.output = outputMessage.output;
        }
        else
        {
            // now need to validate the hash digest
            stringToHash = generateStringToHash(merchantID, password, crossReference.output, orderID.output, preSharedKey,  hashMethod);
            calculatedHashDigest = calculateHashDigest(stringToHash, preSharedKey,  hashMethod);
			
            // does the calculated hash match the one that was passed?
            if (!hashDigest.output.equalsIgnoreCase(calculatedHashDigest))
            {
                errorOccurred = true;
                validateErrorMessage.output = "Hash digests don't match - possible variable tampering";
            }
            else
            {
                outputMessage = new OutString();
                
                // use the cross reference and/or the order ID to pull the
                // transaction results out of storage
                if (!getTransactionResultFromStorage(crossReference.output,
                                                     orderID.output,
                                                     transactionResult,
                                                     outputMessage))
                {
                    validateErrorMessage.output = outputMessage.output;
                    errorOccurred = true;
                }
                else
                {
                    errorOccurred = false;
                }
            }
        }

        return (!errorOccurred);
    }
    public static boolean validateTransactionResult_SERVER_PULL(String merchantID, 
                                                                String password, 
                                                                String preSharedKey, 
                                                                String hashMethod,
                                                                HttpServletRequest request,
                                                                String paymentFormResultHandlerURL,
                                                                OutTransactionResult transactionResult,
                                                                OutString validateErrorMessage)
    {
        boolean errorOccurred;
        OutString crossReference;
        OutString orderID;
        OutString hashDigest;
        OutString outputMessage;
        String stringToHash;
        String calculatedHashDigest;
        NameValueList nameValueList;

	errorOccurred = false;

	validateErrorMessage.output = "";
	transactionResult.output = null;
        crossReference = new OutString();
        orderID = new OutString();
        hashDigest = new OutString();
        outputMessage = new OutString();
        
        nameValueList = parseIntoList(request);
        
	// read the transaction reference variables from the query String variable list
        if (!getTransactionReferenceFromQueryString(nameValueList, crossReference, orderID, hashDigest, outputMessage))
        {
            errorOccurred = true;
            validateErrorMessage.output = outputMessage.output;
        }
        else
        {
            // now need to validate the hash digest
            stringToHash = generateStringToHash(merchantID, password, crossReference.output, orderID.output, preSharedKey,  hashMethod);
            calculatedHashDigest = calculateHashDigest(stringToHash, preSharedKey,  hashMethod);
			
            // does the calculated hash match the one that was passed?
            if (!hashDigest.output.equalsIgnoreCase(calculatedHashDigest))
            {
                errorOccurred = true;
                validateErrorMessage.output = "Hash digests don't match - possible variable tampering";
            }
            else
            {
                // use the cross reference and/or the order ID to pull the
                // transaction results out of storage
                outputMessage = new OutString();
                
                if (!getTransactionResultFromPaymentFormHandler(paymentFormResultHandlerURL,
                                                                merchantID, 
                                                                password,
                                                                crossReference.output,
                                                                transactionResult,
                                                                outputMessage))
                {
                    validateErrorMessage.output = "Error querying transaction result (" + crossReference.output + ") from (" + paymentFormResultHandlerURL + "): " + outputMessage.output;
                    errorOccurred = true;
                }
                else
                {
                    errorOccurred = false;
                }
            }
        }

        return (!errorOccurred);
    }
    
    public static boolean getTransactionResultFromPaymentFormHandler(String paymentFormResultHandlerURL,
                                                                     String merchantID,
                                                                     String password,
                                                                     String crossReference,
                                                                     OutTransactionResult transactionResult,
                                                                     OutString outputMessage)
    {
        boolean errorOccurred;
        StringBuffer workingResponse;
        char[] buffer;
        int bytesRead;
        String response;
        StringBuffer postString;
        NameValueList parsedPostVariables;
        NameValueList transactionResultArray;
        OutString errorMessage;
        OutString hashDigest;
        URL url;
        URLConnection urlConnection;
        DataOutputStream outputStream;
        InputStreamReader inputStreamReader;

        errorOccurred = false;
        outputMessage.output = "";
        transactionResult.output = null;

        try
        {				
            // build up the post String
            postString = new StringBuffer();
            postString.append("MerchantID=");
            postString.append(URLEncoder.encode(merchantID, "UTF-8"));
            postString.append("&Password=");
            postString.append(URLEncoder.encode(password, "UTF-8"));            
            postString.append("&CrossReference=");
            postString.append(URLEncoder.encode(crossReference, "UTF-8"));            

            url = new URL(paymentFormResultHandlerURL);
            urlConnection = url.openConnection();
            
            urlConnection.setDoInput(true);
            urlConnection.setDoOutput(true);
            
            urlConnection.setUseCaches(false);
            urlConnection.setRequestProperty("Content-Type", "application/x-www-form-urlencoded");

            outputStream = new DataOutputStream(urlConnection.getOutputStream());
            outputStream.writeBytes(postString.toString());
            outputStream.flush();
            outputStream.close();
               
            inputStreamReader = new InputStreamReader(urlConnection.getInputStream());
            
            buffer = new char[4096];
            workingResponse = new StringBuffer();
            
            bytesRead = inputStreamReader.read(buffer, 0, 4096);
            
            while (bytesRead != -1)
            {
                workingResponse.append(buffer, 0, bytesRead);
                bytesRead = inputStreamReader.read(buffer, 0, 4096);
            }
            inputStreamReader.close();

            response = workingResponse.toString();
            
            if (response == "")
            {
                errorOccurred = true;
                outputMessage.output = "Received empty response from payment form hander";
            }
            else
            {
                try
                {
                    // parse the response into an array
                    parsedPostVariables = parseNameValueStringIntoArray(response, true);

                    if (!parsedPostVariables.existsInList("StatusCode") ||
                        Integer.parseInt(parsedPostVariables.get("StatusCode").getValue()) != 0)
                    {
                        errorOccurred = true;

                        // the message field is expected if the status code is non-zero
                        if (!parsedPostVariables.existsInList("Message"))
                        {
                            outputMessage.output = "Received invalid response from payment form hander (" + response + ")";
                        }
                        else
                        {
                            outputMessage.output = parsedPostVariables.get("Message").getValue();
                        }
                    }
                    else
                    {
                        // status code is 0, so get the transaction result
                        if (!parsedPostVariables.existsInList("TransactionResult"))
                        {
                            errorOccurred = true;
                            outputMessage.output = "No transaction result in response from payment form hander (" + response + ")";
                        }
                        else
                        {
                            // parse the URL decoded transaction result field into a name value array
                            transactionResultArray = parseNameValueStringIntoArray(parsedPostVariables.get("TransactionResult").getValue(), false);

                            // parse this array into a transaction result object
                            hashDigest = new OutString();
                            errorMessage = new OutString();
                            
                            if (!getTransactionResultFromPostVariables(transactionResultArray, transactionResult, hashDigest, errorMessage))
                            {
                                errorOccurred = true;
                                outputMessage.output = "Error (" + errorMessage.output + ") parsing transaction result (" + URLDecoder.decode(parsedPostVariables.get("TransactionResult").getValue(), "UTF-8") + ") in response from payment form hander (" + response + ")";
                            }
                            else
                            {
                                errorOccurred = false;
                            }
                        }
                    }
                }
                catch (Exception e)
                {
                    errorOccurred = true;
                    outputMessage.output = "Exception (" + e.getMessage() + ") when processing response from payment form handler (" + response + ")";
                }
            }
        }
        catch (Exception e)
        {
            errorOccurred = true;
            outputMessage.output = e.getMessage();
        }

        return (!errorOccurred);
    }
  
    // These functions that are run to deal with storing and retrieving the
    // transaction results. They will be specific to the merchant environment, so cannot
    // be generalised. The developer MUST implement these functions

    // This function needs to be able to retrieve the saved transaction resultt
    // so that the result can be displayed to the customer
    public static boolean  getTransactionResultFromStorage(String crossReference,
                                                           String orderID,
                                                           OutTransactionResult transactionResult,
                                                           OutString outputMessage)
    {
        boolean errorOccurred;

        errorOccurred = true;
        outputMessage.output = "Environment specific function getTransactionResultFromStorage() needs to be implemented by merchant developer";
        transactionResult.output = null;

        return (!errorOccurred);
    }

    // You should put your code that does any post transaction tasks
    // (e.g. updates the order object, sends the customer an email etc) in this function
    public static boolean  reportTransactionResults(TransactionResult transactionResult,
                                                    OutString outputMessage)
    {
        boolean errorOccurred;

        errorOccurred = true;
        outputMessage.output = "Environment specific function reportTransactionResults() needs to be implemented by merchant developer";

        try
        {
            switch (transactionResult.getStatusCode())
            {
                // transaction authorised
                case 0:
                    break;
                // card referred (treat as decline)
                case 4:
                    break;
                // transaction declined
                case 5:
                    break;
                // duplicate transaction
                case 20:
                    // need to look at the previous status code to see if the
                    // transaction was successful
                    if (transactionResult.getPreviousStatusCode().getValue() == 0)
                    {
                        // transaction authorised
                    }
                    else
                    {
                        // transaction not authorised
                    }
                    break;
                // error occurred
                case 30:
                    break;
                default:
                    break;
            }

            // put code to update/store the order with the transaction result
        }
        catch (Exception e)
        {
            errorOccurred = true;
            outputMessage.output = e.getMessage();
        }
        return (!errorOccurred);
    }
}