<%@ page import="net.mycompanyname.OutString" %>
<%@ page import="net.mycompanyname.OutTransactionResult" %>
<%@ page import="net.mycompanyname.NameValueList" %>

<jsp:useBean id="global" class="net.mycompanyname.Global" scope="application" />
<jsp:useBean id="paymentFormHelper" class="net.mycompanyname.PaymentFormHelper" scope="page" />
<%
    int outputStatusCode;
    String outputMessage;
    OutString outputMessage2;
    OutString updateOrderMessage;
    boolean errorOccurred;
    OutTransactionResult transactionResult;
    OutString hashDigest;
    NameValueList nameValueList;
    String stringToHash;
    String calculatedHashDigest;

    outputStatusCode = 30;
    outputMessage = "";
    errorOccurred = false;

    transactionResult = new OutTransactionResult();
    hashDigest = new OutString();
    outputMessage2 = new OutString();
    
    try
    {
        nameValueList = paymentFormHelper.parseIntoList(request);
        
        // read in the transaction result variables
        if (!paymentFormHelper.getTransactionResultFromPostVariables(nameValueList, transactionResult, hashDigest, outputMessage2))
        {
            outputStatusCode = 30;
        }
        else
        {
            // need to check the hash digest
            stringToHash = paymentFormHelper.generateStringToHash(global.getMerchantID(), global.getPassword(), transactionResult.output, global.getPreSharedKey(), global.getHashMethod());          
            calculatedHashDigest = paymentFormHelper.calculateHashDigest(stringToHash, global.getPreSharedKey(), global.getHashMethod());
			
            // does the calculated hash match the one that was passed?
            if (!hashDigest.output.equalsIgnoreCase(calculatedHashDigest))
            {
                outputStatusCode = 30;
                outputMessage = "Hash digests don't match - possible variable tampering";
            }
            else
            {
                updateOrderMessage = new OutString();
        
                if (!paymentFormHelper.reportTransactionResults(transactionResult.output,
                                                                updateOrderMessage))
                {
                    outputStatusCode = 30;
                    outputMessage = outputMessage2.output + updateOrderMessage.output;
                }
                else
                {
                    outputStatusCode = 0;
                }
            }
        }
    }
    catch (Exception e)
    {
	outputStatusCode = 30;
        outputMessage = e.getMessage();
    }

    if (outputStatusCode != 0 &&
        outputMessage.equals(""))
    {
        outputMessage = "Unknown error";
    }

    // output the status code and message letting the payment form
    // know whether the transaction result was processed successfully
    response.getWriter().print("StatusCode=" + outputStatusCode + "&Message=" + outputMessage);
    //Response.Write("StatusCode=" & nOutputStatusCode & "&Message=" & szOutputMessage)
%>
