Imports System.Data
Imports System.Configuration
Imports System.Collections.Specialized
Imports System.Web
Imports System.Web.Security
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports System.Web.UI.WebControls.WebParts
Imports System.Web.UI.HtmlControls
Imports System.Security.Cryptography
Imports System.Text
Imports System.Net
Imports System.IO

''' <summary>
''' Summary description for PaymentFormHelper
''' </summary>
Namespace MyCompanyName
    Public Enum RESULT_DELIVERY_METHOD
        UNKNOWN
        POST
        SERVER
        SERVER_PULL
    End Enum
    Public Enum HASH_METHOD
        UNKNOWN
        MD5
        SHA1
        HMACMD5
        HMACSHA1
    End Enum

    Public Class TransactionResult
        Private m_nStatusCode As Integer
        Private m_szMessage As String
        Private m_nPreviousStatusCode As System.Nullable(Of Integer)
        Private m_szPreviousMessage As String
        Private m_szCrossReference As String
        Private m_nAmount As UInt64
        Private m_nCurrencyCode As Integer
        Private m_szOrderID As String
        Private m_szTransactionType As String
        Private m_szTransactionDateTime As String
        Private m_szOrderDescription As String
        Private m_szCustomerName As String
        Private m_szAddress1 As String
        Private m_szAddress2 As String
        Private m_szAddress3 As String
        Private m_szAddress4 As String
        Private m_szCity As String
        Private m_szState As String
        Private m_szPostCode As String
        Private m_nCountryCode As System.Nullable(Of Integer)

        Public Property StatusCode() As Integer
            Get
                Return (m_nStatusCode)
            End Get
            Set(value As Integer)
                m_nStatusCode = value
            End Set
        End Property
        Public Property Message() As String
            Get
                Return (m_szMessage)
            End Get
            Set(value As String)
                m_szMessage = value
            End Set
        End Property
        Public Property PreviousStatusCode() As System.Nullable(Of Integer)
            Get
                Return (m_nPreviousStatusCode)
            End Get
            Set(value As System.Nullable(Of Integer))
                m_nPreviousStatusCode = value
            End Set
        End Property
        Public Property PreviousMessage() As String
            Get
                Return (m_szPreviousMessage)
            End Get
            Set(value As String)
                m_szPreviousMessage = value
            End Set
        End Property
        Public Property CrossReference() As String
            Get
                Return (m_szCrossReference)
            End Get
            Set(value As String)
                m_szCrossReference = value
            End Set
        End Property
        Public Property Amount() As UInt64
            Get
                Return (m_nAmount)
            End Get
            Set(value As UInt64)
                m_nAmount = value
            End Set
        End Property
        Public Property CurrencyCode() As Integer
            Get
                Return (m_nCurrencyCode)
            End Get
            Set(value As Integer)
                m_nCurrencyCode = value
            End Set
        End Property
        Public Property OrderID() As String
            Get
                Return (m_szOrderID)
            End Get
            Set(value As String)
                m_szOrderID = value
            End Set
        End Property
        Public Property TransactionType() As String
            Get
                Return (m_szTransactionType)
            End Get
            Set(value As String)
                m_szTransactionType = value
            End Set
        End Property
        Public Property TransactionDateTime() As String
            Get
                Return (m_szTransactionDateTime)
            End Get
            Set(value As String)
                m_szTransactionDateTime = value
            End Set
        End Property
        Public Property OrderDescription() As String
            Get
                Return (m_szOrderDescription)
            End Get
            Set(value As String)
                m_szOrderDescription = value
            End Set
        End Property
        Public Property CustomerName() As String
            Get
                Return (m_szCustomerName)
            End Get
            Set(value As String)
                m_szCustomerName = value
            End Set
        End Property
        Public Property Address1() As String
            Get
                Return (m_szAddress1)
            End Get
            Set(value As String)
                m_szAddress1 = value
            End Set
        End Property
        Public Property Address2() As String
            Get
                Return (m_szAddress2)
            End Get
            Set(value As String)
                m_szAddress2 = value
            End Set
        End Property
        Public Property Address3() As String
            Get
                Return (m_szAddress3)
            End Get
            Set(value As String)
                m_szAddress3 = value
            End Set
        End Property
        Public Property Address4() As String
            Get
                Return (m_szAddress4)
            End Get
            Set(value As String)
                m_szAddress4 = value
            End Set
        End Property
        Public Property City() As String
            Get
                Return (m_szCity)
            End Get
            Set(value As String)
                m_szCity = value
            End Set
        End Property
        Public Property State() As String
            Get
                Return (m_szState)
            End Get
            Set(value As String)
                m_szState = value
            End Set
        End Property
        Public Property PostCode() As String
            Get
                Return (m_szPostCode)
            End Get
            Set(value As String)
                m_szPostCode = value
            End Set
        End Property
        Public Property CountryCode() As System.Nullable(Of Integer)
            Get
                Return (m_nCountryCode)
            End Get
            Set(value As System.Nullable(Of Integer))
                m_nCountryCode = value
            End Set
        End Property
    End Class

    Public Class PaymentFormHelper
        Public Shared Function GetHashMethod(hmHashMethod As HASH_METHOD) As String
            Return (hmHashMethod.ToString())
        End Function
        Public Shared Function GetHashMethod(szHashMethod As String) As HASH_METHOD
            Dim hmHashMethod As HASH_METHOD = HASH_METHOD.UNKNOWN

            If [String].IsNullOrEmpty(szHashMethod) Then
                Throw New Exception("Hash method must not be null or empty")
            End If
            If szHashMethod.ToUpper() = "MD5" Then
                hmHashMethod = HASH_METHOD.MD5
                GoTo Finished
            End If
            If szHashMethod.ToUpper() = "SHA1" Then
                hmHashMethod = HASH_METHOD.SHA1
                GoTo Finished
            End If
            If szHashMethod.ToUpper() = "HMACMD5" Then
                hmHashMethod = HASH_METHOD.HMACMD5
                GoTo Finished
            End If
            If szHashMethod.ToUpper() = "HMACSHA1" Then
                hmHashMethod = HASH_METHOD.HMACSHA1
                GoTo Finished
            End If
Finished:


            If hmHashMethod = HASH_METHOD.UNKNOWN Then
                Throw New Exception("Invalid hash method: " & szHashMethod)
            End If

            Return (hmHashMethod)
        End Function
        Public Shared Function GetResultDeliveryMethod(rdmResultDeliveryMethod As RESULT_DELIVERY_METHOD) As String
            Return (rdmResultDeliveryMethod.ToString())
        End Function
        Public Shared Function GetResultDeliveryMethod(szResultDeliveryMethod As String) As RESULT_DELIVERY_METHOD
            Dim rdmResultDeliveryMethod As RESULT_DELIVERY_METHOD = RESULT_DELIVERY_METHOD.UNKNOWN

            If [String].IsNullOrEmpty(szResultDeliveryMethod) Then
                Throw New Exception("Result delivery method must not be null or empty")
            End If
            If szResultDeliveryMethod.ToUpper() = "POST" Then
                rdmResultDeliveryMethod = RESULT_DELIVERY_METHOD.POST
                GoTo Finished
            End If
            If szResultDeliveryMethod.ToUpper() = "SERVER" Then
                rdmResultDeliveryMethod = RESULT_DELIVERY_METHOD.SERVER
                GoTo Finished
            End If
            If szResultDeliveryMethod.ToUpper() = "SERVER_PULL" Then
                rdmResultDeliveryMethod = RESULT_DELIVERY_METHOD.SERVER_PULL
                GoTo Finished
            End If
Finished:


            If rdmResultDeliveryMethod = RESULT_DELIVERY_METHOD.UNKNOWN Then
                Throw New Exception("Invalid result delivery method: " & szResultDeliveryMethod)
            End If

            Return (rdmResultDeliveryMethod)
        End Function
        Public Shared Function GetSiteSecureBaseURL(hrHTTPRequest As HttpRequest) As String
            Dim szReturnString As String = Nothing
            Dim nIndex As Integer

            szReturnString = hrHTTPRequest.Url.AbsoluteUri

            nIndex = szReturnString.LastIndexOf("/"c)

            szReturnString = szReturnString.Substring(0, nIndex + 1)

            Return (szReturnString)
        End Function
        Public Shared Function GetTransactionReferenceFromQueryString(nvcQueryStringVariables As NameValueCollection, ByRef szCrossReference As String, ByRef szOrderID As String, ByRef szHashDigest As String, ByRef szOutputMessage As String) As Boolean
            Dim boErrorOccurred As Boolean

            szHashDigest = ""
            szOutputMessage = ""
            boErrorOccurred = False
            szCrossReference = Nothing
            szOrderID = Nothing

            Try
                ' hash digest
                If nvcQueryStringVariables("HashDigest") IsNot Nothing Then
                    szHashDigest = nvcQueryStringVariables("HashDigest")
                End If

                ' cross reference of transaction
                If nvcQueryStringVariables("CrossReference") Is Nothing Then
                    szOutputMessage = AddStringToStringList(szOutputMessage, "Expected variable [CrossReference] not received")
                    boErrorOccurred = True
                Else
                    szCrossReference = nvcQueryStringVariables("CrossReference")
                End If
                ' order ID (same as value passed into payment form - echoed back out by payment form)
                If nvcQueryStringVariables("OrderID") Is Nothing Then
                    szOutputMessage = AddStringToStringList(szOutputMessage, "Expected variable [OrderID] not received")
                    boErrorOccurred = True
                Else
                    szOrderID = nvcQueryStringVariables("OrderID")
                End If
            Catch e As Exception
                boErrorOccurred = True
                szOutputMessage = e.Message
            End Try

            Return (Not boErrorOccurred)
        End Function
        Public Shared Function GetTransactionResultFromPostVariables(nvcFormVariables As NameValueCollection, ByRef trTransactionResult As TransactionResult, ByRef szHashDigest As String, ByRef szOutputMessage As String) As Boolean
            Dim boErrorOccurred As Boolean
            Dim nStatusCode As Integer = 30
            Dim szMessage As String = Nothing
            Dim nPreviousStatusCode As System.Nullable(Of Integer) = Nothing
            Dim szPreviousMessage As String = Nothing
            Dim szCrossReference As String = Nothing
            Dim nAmount As UInt64 = 0
            Dim nCurrencyCode As Integer = 0
            Dim szOrderID As String = Nothing
            Dim szTransactionType As String = Nothing
            Dim szTransactionDateTime As String = Nothing
            Dim szOrderDescription As String = Nothing
            Dim szCustomerName As String = Nothing
            Dim szAddress1 As String = Nothing
            Dim szAddress2 As String = Nothing
            Dim szAddress3 As String = Nothing
            Dim szAddress4 As String = Nothing
            Dim szCity As String = Nothing
            Dim szState As String = Nothing
            Dim szPostCode As String = Nothing
            Dim nCountryCode As System.Nullable(Of Integer) = Nothing

            trTransactionResult = Nothing
            szHashDigest = ""
            szOutputMessage = ""
            boErrorOccurred = False

            Try
                ' hash digest
                If nvcFormVariables("HashDigest") IsNot Nothing Then
                    szHashDigest = nvcFormVariables("HashDigest")
                End If

                ' transaction status code
                If nvcFormVariables("StatusCode") Is Nothing Then
                    szOutputMessage = AddStringToStringList(szOutputMessage, "Expected variable [StatusCode] not received")
                    boErrorOccurred = True
                Else
                    nStatusCode = Convert.ToInt32(nvcFormVariables("StatusCode"))
                End If
                ' transaction message
                If nvcFormVariables("Message") Is Nothing Then
                    szOutputMessage = AddStringToStringList(szOutputMessage, "Expected variable [Message] not received")
                    boErrorOccurred = True
                Else
                    szMessage = nvcFormVariables("Message")
                End If
                ' status code of original transaction if this transaction was deemed a duplicate
                If nvcFormVariables("PreviousStatusCode") Is Nothing Then
                    szOutputMessage = AddStringToStringList(szOutputMessage, "Expected variable [PreviousStatusCode] not received")
                    boErrorOccurred = True
                Else
                    If nvcFormVariables("PreviousStatusCode") = "" Then
                        nPreviousStatusCode = Nothing
                    Else
                        nPreviousStatusCode = Convert.ToInt32(nvcFormVariables("PreviousStatusCode"))
                    End If
                End If
                ' status code of original transaction if this transaction was deemed a duplicate
                If nvcFormVariables("PreviousMessage") Is Nothing Then
                    szOutputMessage = AddStringToStringList(szOutputMessage, "Expected variable [PreviousMessage] not received")
                    boErrorOccurred = True
                Else
                    szPreviousMessage = nvcFormVariables("PreviousMessage")
                End If
                ' cross reference of transaction
                If nvcFormVariables("CrossReference") Is Nothing Then
                    szOutputMessage = AddStringToStringList(szOutputMessage, "Expected variable [CrossReference] not received")
                    boErrorOccurred = True
                Else
                    szCrossReference = nvcFormVariables("CrossReference")
                End If
                ' amount (same as value passed into payment form - echoed back out by payment form)
                If nvcFormVariables("Amount") Is Nothing Then
                    szOutputMessage = AddStringToStringList(szOutputMessage, "Expected variable [Amount] not received")
                    boErrorOccurred = True
                Else
                    nAmount = Convert.ToUInt64(nvcFormVariables("Amount"))
                End If
                ' currency code (same as value passed into payment form - echoed back out by payment form)
                If nvcFormVariables("CurrencyCode") Is Nothing Then
                    szOutputMessage = AddStringToStringList(szOutputMessage, "Expected variable [CurrencyCode] not received")
                    boErrorOccurred = True
                Else
                    nCurrencyCode = Convert.ToInt32(nvcFormVariables("CurrencyCode"))
                End If
                ' order ID (same as value passed into payment form - echoed back out by payment form)
                If nvcFormVariables("OrderID") Is Nothing Then
                    szOutputMessage = AddStringToStringList(szOutputMessage, "Expected variable [OrderID] not received")
                    boErrorOccurred = True
                Else
                    szOrderID = nvcFormVariables("OrderID")
                End If
                ' transaction type (same as value passed into payment form - echoed back out by payment form)
                If nvcFormVariables("TransactionType") Is Nothing Then
                    szOutputMessage = AddStringToStringList(szOutputMessage, "Expected variable [TransactionType] not received")
                    boErrorOccurred = True
                Else
                    szTransactionType = nvcFormVariables("TransactionType")
                End If
                ' transaction date/time (same as value passed into payment form - echoed back out by payment form)
                If nvcFormVariables("TransactionDateTime") Is Nothing Then
                    szOutputMessage = AddStringToStringList(szOutputMessage, "Expected variable [TransactionDateTime] not received")
                    boErrorOccurred = True
                Else
                    szTransactionDateTime = nvcFormVariables("TransactionDateTime")
                End If
                ' order description (same as value passed into payment form - echoed back out by payment form)
                If nvcFormVariables("OrderDescription") Is Nothing Then
                    szOutputMessage = AddStringToStringList(szOutputMessage, "Expected variable [OrderDescription] not received")
                    boErrorOccurred = True
                Else
                    szOrderDescription = nvcFormVariables("OrderDescription")
                End If
                ' customer name (not necessarily the same as value passed into payment form - as the customer can change it on the form)
                If nvcFormVariables("CustomerName") Is Nothing Then
                    szOutputMessage = AddStringToStringList(szOutputMessage, "Expected variable [CustomerName] not received")
                    boErrorOccurred = True
                Else
                    szCustomerName = nvcFormVariables("CustomerName")
                End If
                ' address1 (not necessarily the same as value passed into payment form - as the customer can change it on the form)
                If nvcFormVariables("Address1") Is Nothing Then
                    szOutputMessage = AddStringToStringList(szOutputMessage, "Expected variable [Address1] not received")
                    boErrorOccurred = True
                Else
                    szAddress1 = nvcFormVariables("Address1")
                End If
                ' address2 (not necessarily the same as value passed into payment form - as the customer can change it on the form)
                If nvcFormVariables("Address2") Is Nothing Then
                    szOutputMessage = AddStringToStringList(szOutputMessage, "Expected variable [Address2] not received")
                    boErrorOccurred = True
                Else
                    szAddress2 = nvcFormVariables("Address2")
                End If
                ' address3 (not necessarily the same as value passed into payment form - as the customer can change it on the form)
                If nvcFormVariables("Address3") Is Nothing Then
                    szOutputMessage = AddStringToStringList(szOutputMessage, "Expected variable [Address3] not received")
                    boErrorOccurred = True
                Else
                    szAddress3 = nvcFormVariables("Address3")
                End If
                ' address4 (not necessarily the same as value passed into payment form - as the customer can change it on the form)
                If nvcFormVariables("Address4") Is Nothing Then
                    szOutputMessage = AddStringToStringList(szOutputMessage, "Expected variable [Address4] not received")
                    boErrorOccurred = True
                Else
                    szAddress4 = nvcFormVariables("Address4")
                End If
                ' city (not necessarily the same as value passed into payment form - as the customer can change it on the form)
                If nvcFormVariables("City") Is Nothing Then
                    szOutputMessage = AddStringToStringList(szOutputMessage, "Expected variable [City] not received")
                    boErrorOccurred = True
                Else
                    szCity = nvcFormVariables("City")
                End If
                ' state (not necessarily the same as value passed into payment form - as the customer can change it on the form)
                If nvcFormVariables("State") Is Nothing Then
                    szOutputMessage = AddStringToStringList(szOutputMessage, "Expected variable [State] not received")
                    boErrorOccurred = True
                Else
                    szState = nvcFormVariables("State")
                End If
                ' post code (not necessarily the same as value passed into payment form - as the customer can change it on the form)
                If nvcFormVariables("PostCode") Is Nothing Then
                    szOutputMessage = AddStringToStringList(szOutputMessage, "Expected variable [PostCode] not received")
                    boErrorOccurred = True
                Else
                    szPostCode = nvcFormVariables("PostCode")
                End If
                ' country code (not necessarily the same as value passed into payment form - as the customer can change it on the form)
                If nvcFormVariables("CountryCode") Is Nothing Then
                    szOutputMessage = AddStringToStringList(szOutputMessage, "Expected variable [CountryCode] not received")
                    boErrorOccurred = True
                Else
                    If nvcFormVariables("CountryCode") = "" Then
                        nCountryCode = Nothing
                    Else
                        nCountryCode = Convert.ToInt32(nvcFormVariables("CountryCode"))
                    End If
                End If

                If Not boErrorOccurred Then
                    trTransactionResult = New TransactionResult()
                    trTransactionResult.StatusCode = nStatusCode
                    ' transaction status code
                    trTransactionResult.Message = szMessage
                    ' transaction message
                    trTransactionResult.PreviousStatusCode = nPreviousStatusCode
                    ' status code of original transaction if duplicate transaction
                    trTransactionResult.PreviousMessage = szPreviousMessage
                    ' status code of original transaction if duplicate transaction
                    trTransactionResult.CrossReference = szCrossReference
                    ' cross reference of transaction
                    trTransactionResult.Amount = nAmount
                    ' amount echoed back
                    trTransactionResult.CurrencyCode = nCurrencyCode
                    ' currency code echoed back
                    trTransactionResult.OrderID = szOrderID
                    ' order ID echoed back
                    trTransactionResult.TransactionType = szTransactionType
                    ' transaction type echoed back
                    trTransactionResult.TransactionDateTime = szTransactionDateTime
                    ' transaction date/time echoed back
                    trTransactionResult.OrderDescription = szOrderDescription
                    ' order description echoed back
                    ' the customer details that were actually
                    ' processed  = might be different
                    ' from those passed to the payment form
                    trTransactionResult.CustomerName = szCustomerName
                    trTransactionResult.Address1 = szAddress1
                    trTransactionResult.Address2 = szAddress2
                    trTransactionResult.Address3 = szAddress3
                    trTransactionResult.Address4 = szAddress4
                    trTransactionResult.City = szCity
                    trTransactionResult.State = szState
                    trTransactionResult.PostCode = szPostCode
                    trTransactionResult.CountryCode = nCountryCode
                End If
            Catch e As Exception
                boErrorOccurred = True
                szOutputMessage = e.Message
            End Try

            Return (Not boErrorOccurred)
        End Function
        Public Shared Function AddStringToStringList(szExistingStringList As String, szStringToAdd As String) As String
            Dim szCommaString As String
            Dim sbReturnString As StringBuilder

            sbReturnString = New StringBuilder()
            szCommaString = ""

            If [String].IsNullOrEmpty(szStringToAdd) Then
                sbReturnString.Append(szExistingStringList)
            Else
                If Not [String].IsNullOrEmpty(szExistingStringList) Then
                    szCommaString = ", "
                End If
                sbReturnString.AppendFormat("{0}{1}{2}", szExistingStringList, szCommaString, szStringToAdd)
            End If

            Return (sbReturnString.ToString())
        End Function



        Public Shared Function StringToByteArray(szString As String) As Byte()
            Dim encoding As New System.Text.UTF8Encoding()
            Return encoding.GetBytes(szString)
        End Function
        Public Shared Function ByteArrayToHexString(aByte As Byte()) As String
            Dim sbStringBuilder As StringBuilder
            Dim nCount As Integer = 0

            sbStringBuilder = New StringBuilder()
            For nCount = 0 To aByte.Length - 1
                sbStringBuilder.Append(aByte(nCount).ToString("x2"))
            Next

            Return (sbStringBuilder.ToString())
        End Function
        Public Shared Function CalculateHashDigest(szString As String, szPreSharedKey As String, eHashMethod As HASH_METHOD) As String
            Dim abKey As Byte()
            Dim abBytes As Byte()
            Dim abHashDigest As Byte()
            Dim md5 As MD5
            Dim sha1 As SHA1
            Dim hmacMD5 As HMACMD5
            Dim hmacSHA1 As HMACSHA1

            abKey = StringToByteArray(szPreSharedKey)
            abBytes = StringToByteArray(szString)

            Select Case eHashMethod
                Case HASH_METHOD.HMACMD5
                    hmacMD5 = New HMACMD5(abKey)
                    abHashDigest = hmacMD5.ComputeHash(abBytes)
                    Exit Select
                Case HASH_METHOD.HMACSHA1
                    hmacSHA1 = New HMACSHA1(abKey)
                    abHashDigest = hmacSHA1.ComputeHash(abBytes)
                    Exit Select
                Case HASH_METHOD.MD5
                    md5 = New MD5CryptoServiceProvider()
                    abHashDigest = md5.ComputeHash(abBytes)
                    Exit Select
                Case HASH_METHOD.SHA1
                    sha1 = New SHA1CryptoServiceProvider()
                    abHashDigest = sha1.ComputeHash(abBytes)
                    Exit Select
                Case Else
                    Throw New Exception("Invalid hash method: " & eHashMethod.ToString())
            End Select

            Return (ByteArrayToHexString(abHashDigest))
        End Function
        Public Shared Function GenerateStringToHash(szMerchantID As String, szPassword As String, szAmount As String, szCurrencyCode As String, szOrderID As String, szTransactionType As String, _
         szTransactionDateTime As String, szCallbackURL As String, szOrderDescription As String, szCustomerName As String, szAddress1 As String, szAddress2 As String, _
         szAddress3 As String, szAddress4 As String, szCity As String, szState As String, szPostCode As String, szCountryCode As String, _
         szCV2Mandatory As String, szAddress1Mandatory As String, szCityMandatory As String, szPostCodeMandatory As String, szStateMandatory As String, szCountryMandatory As String, _
         szResultDeliveryMethod As String, szServerResultURL As String, szPaymentFormDisplaysResult As String, szPreSharedKey As String, hmHashMethod As HASH_METHOD) As String
            Dim sbReturnString As StringBuilder
            Dim boIncludePreSharedKeyInString As Boolean = False

            sbReturnString = New StringBuilder()

            Select Case hmHashMethod
                Case HASH_METHOD.MD5
                    boIncludePreSharedKeyInString = True
                    Exit Select
                Case HASH_METHOD.SHA1
                    boIncludePreSharedKeyInString = True
                    Exit Select
                Case HASH_METHOD.HMACMD5
                    boIncludePreSharedKeyInString = False
                    Exit Select
                Case HASH_METHOD.HMACSHA1
                    boIncludePreSharedKeyInString = False
                    Exit Select
            End Select

            If boIncludePreSharedKeyInString Then
                sbReturnString.AppendFormat("PreSharedKey={0}&", szPreSharedKey)
            End If

            sbReturnString.AppendFormat("MerchantID={0}&Password={1}&Amount={2}&CurrencyCode={3}&OrderID={4}&TransactionType={5}" & "&TransactionDateTime={6}&CallbackURL={7}&OrderDescription={8}&CustomerName={9}" & "&Address1={10}&Address2={11}&Address3={12}&Address4={13}&City={14}&State={15}&PostCode={16}" & "&CountryCode={17}&CV2Mandatory={18}&Address1Mandatory={19}&CityMandatory={20}" & "&PostCodeMandatory={21}&StateMandatory={22}&CountryMandatory={23}&ResultDeliveryMethod={24}" & "&ServerResultURL={25}&PaymentFormDisplaysResult={26}&ServerResultURLCookieVariables=" & "&ServerResultURLFormVariables=&ServerResultURLQueryStringVariables=", szMerchantID, szPassword, szAmount, szCurrencyCode, szOrderID, _
             szTransactionType, szTransactionDateTime, szCallbackURL, szOrderDescription, szCustomerName, szAddress1, _
             szAddress2, szAddress3, szAddress4, szCity, szState, szPostCode, _
             szCountryCode, szCV2Mandatory, szAddress1Mandatory, szCityMandatory, szPostCodeMandatory, szStateMandatory, _
             szCountryMandatory, szResultDeliveryMethod, szServerResultURL, szPaymentFormDisplaysResult)

            Return (sbReturnString.ToString())
        End Function
        Public Shared Function GenerateStringToHash(szMerchantID As String, szPassword As String, trTransactionResult As TransactionResult, szPreSharedKey As String, hmHashMethod As HASH_METHOD) As String
            Dim sbReturnString As StringBuilder
            Dim boIncludePreSharedKeyInString As Boolean = False

            sbReturnString = New StringBuilder()

            Select Case hmHashMethod
                Case HASH_METHOD.MD5
                    boIncludePreSharedKeyInString = True
                    Exit Select
                Case HASH_METHOD.SHA1
                    boIncludePreSharedKeyInString = True
                    Exit Select
                Case HASH_METHOD.HMACMD5
                    boIncludePreSharedKeyInString = False
                    Exit Select
                Case HASH_METHOD.HMACSHA1
                    boIncludePreSharedKeyInString = False
                    Exit Select
            End Select

            If boIncludePreSharedKeyInString Then
                sbReturnString.AppendFormat("PreSharedKey={0}&", szPreSharedKey)
            End If

            sbReturnString.AppendFormat("MerchantID={0}&Password={1}&StatusCode={2}&Message={3}" & "&PreviousStatusCode={4}&PreviousMessage={5}&CrossReference={6}" & "&Amount={7}&CurrencyCode={8}&OrderID={9}&TransactionType={10}" & "&TransactionDateTime={11}&OrderDescription={12}&CustomerName={13}" & "&Address1={14}&Address2={15}&Address3={16}&Address4={17}&City={18}" & "&State={19}&PostCode={20}&CountryCode={21}", szMerchantID, szPassword, trTransactionResult.StatusCode, trTransactionResult.Message, trTransactionResult.PreviousStatusCode, _
             trTransactionResult.PreviousMessage, trTransactionResult.CrossReference, trTransactionResult.Amount, trTransactionResult.CurrencyCode, trTransactionResult.OrderID, trTransactionResult.TransactionType, _
             trTransactionResult.TransactionDateTime, trTransactionResult.OrderDescription, trTransactionResult.CustomerName, trTransactionResult.Address1, trTransactionResult.Address2, trTransactionResult.Address3, _
             trTransactionResult.Address4, trTransactionResult.City, trTransactionResult.State, trTransactionResult.PostCode, trTransactionResult.CountryCode)

            Return (sbReturnString.ToString())
        End Function
        Public Shared Function GenerateStringToHash(szMerchantID As String, szPassword As String, szCrossReference As String, szOrderID As String, szPreSharedKey As String, hmHashMethod As HASH_METHOD) As String
            Dim sbReturnString As StringBuilder
            Dim boIncludePreSharedKeyInString As Boolean = False

            sbReturnString = New StringBuilder()

            Select Case hmHashMethod
                Case HASH_METHOD.MD5
                    boIncludePreSharedKeyInString = True
                    Exit Select
                Case HASH_METHOD.SHA1
                    boIncludePreSharedKeyInString = True
                    Exit Select
                Case HASH_METHOD.HMACMD5
                    boIncludePreSharedKeyInString = False
                    Exit Select
                Case HASH_METHOD.HMACSHA1
                    boIncludePreSharedKeyInString = False
                    Exit Select
            End Select

            If boIncludePreSharedKeyInString Then
                sbReturnString.AppendFormat("PreSharedKey={0}&", szPreSharedKey)
            End If

            sbReturnString.AppendFormat("MerchantID={0}&Password={1}&CrossReference={2}&OrderID={3}", szMerchantID, szPassword, szCrossReference, szOrderID)

            Return (sbReturnString.ToString())
        End Function
        Public Shared Function ValidateTransactionResult_POST(szMerchantID As String, szPassword As String, szPreSharedKey As String, hmHashMethod As HASH_METHOD, aPostVariables As NameValueCollection, ByRef trTransactionResult As TransactionResult, _
         ByRef szValidateErrorMessage As String) As Boolean
            Dim boErrorOccurred As Boolean
            Dim szHashDigest As String
            Dim szOutputMessage As String
            Dim szStringToHash As String
            Dim szCalculatedHashDigest As String

            boErrorOccurred = False

            szValidateErrorMessage = ""
            trTransactionResult = Nothing

            ' read the transaction result variables from the post variable list
            If Not GetTransactionResultFromPostVariables(aPostVariables, trTransactionResult, szHashDigest, szOutputMessage) Then
                boErrorOccurred = True
                szValidateErrorMessage = szOutputMessage
            Else
                ' now need to validate the hash digest
                szStringToHash = GenerateStringToHash(szMerchantID, szPassword, trTransactionResult, szPreSharedKey, hmHashMethod)
                szCalculatedHashDigest = CalculateHashDigest(szStringToHash, szPreSharedKey, hmHashMethod)

                ' does the calculated hash match the one that was passed?
                If szHashDigest.ToUpper() <> szCalculatedHashDigest.ToUpper() Then
                    boErrorOccurred = True
                    szValidateErrorMessage = "Hash digests don't match - possible variable tampering"
                Else
                    boErrorOccurred = False
                End If
            End If

            Return (Not boErrorOccurred)
        End Function
        Public Shared Function ValidateTransactionResult_SERVER(szMerchantID As String, szPassword As String, szPreSharedKey As String, hmHashMethod As HASH_METHOD, nvcQueryStringVariables As NameValueCollection, ByRef trTransactionResult As TransactionResult, _
         ByRef szValidateErrorMessage As String) As Boolean
            Dim boErrorOccurred As Boolean
            Dim szCrossReference As String
            Dim szOrderID As String
            Dim szHashDigest As String
            Dim szOutputMessage As String
            Dim szStringToHash As String
            Dim szCalculatedHashDigest As String

            boErrorOccurred = False

            szValidateErrorMessage = ""
            trTransactionResult = Nothing

            ' read the transaction reference variables from the query string variable list
            If Not GetTransactionReferenceFromQueryString(nvcQueryStringVariables, szCrossReference, szOrderID, szHashDigest, szOutputMessage) Then
                boErrorOccurred = True
                szValidateErrorMessage = szOutputMessage
            Else
                ' now need to validate the hash digest
                szStringToHash = GenerateStringToHash(szMerchantID, szPassword, szCrossReference, szOrderID, szPreSharedKey, hmHashMethod)
                szCalculatedHashDigest = CalculateHashDigest(szStringToHash, szPreSharedKey, hmHashMethod)

                ' does the calculated hash match the one that was passed?
                If szHashDigest.ToUpper() <> szCalculatedHashDigest.ToUpper() Then
                    boErrorOccurred = True
                    szValidateErrorMessage = "Hash digests don't match - possible variable tampering"
                Else
                    ' use the cross reference and/or the order ID to pull the
                    ' transaction results out of storage
                    If Not GetTransactionResultFromStorage(szCrossReference, szOrderID, trTransactionResult, szOutputMessage) Then
                        szValidateErrorMessage = szOutputMessage
                        boErrorOccurred = True
                    Else
                        boErrorOccurred = False
                    End If
                End If
            End If

            Return (Not boErrorOccurred)
        End Function
        Public Shared Function ValidateTransactionResult_SERVER_PULL(szMerchantID As String, szPassword As String, szPreSharedKey As String, hmHashMethod As HASH_METHOD, nvcQueryStringVariables As NameValueCollection, szPaymentFormResultHandlerURL As String, _
         ByRef trTransactionResult As TransactionResult, ByRef szValidateErrorMessage As String) As Boolean
            Dim boErrorOccurred As Boolean
            Dim szCrossReference As String
            Dim szOrderID As String
            Dim szHashDigest As String
            Dim szOutputMessage As String
            Dim szStringToHash As String
            Dim szCalculatedHashDigest As String

            boErrorOccurred = False

            szValidateErrorMessage = ""
            trTransactionResult = Nothing

            ' read the transaction reference variables from the query string variable list
            If Not GetTransactionReferenceFromQueryString(nvcQueryStringVariables, szCrossReference, szOrderID, szHashDigest, szOutputMessage) Then
                boErrorOccurred = True
                szValidateErrorMessage = szOutputMessage
            Else
                ' now need to validate the hash digest
                szStringToHash = GenerateStringToHash(szMerchantID, szPassword, szCrossReference, szOrderID, szPreSharedKey, hmHashMethod)
                szCalculatedHashDigest = CalculateHashDigest(szStringToHash, szPreSharedKey, hmHashMethod)

                ' does the calculated hash match the one that was passed?
                If szHashDigest.ToUpper() <> szCalculatedHashDigest.ToUpper() Then
                    boErrorOccurred = True
                    szValidateErrorMessage = "Hash digests don't match - possible variable tampering"
                Else
                    ' use the cross reference and/or the order ID to pull the
                    ' transaction results out of storage
                    If Not GetTransactionResultFromPaymentFormHandler(szPaymentFormResultHandlerURL, szMerchantID, szPassword, szCrossReference, trTransactionResult, szOutputMessage) Then
                        szValidateErrorMessage = "Error querying transaction result (" & szCrossReference & ") from (" & szPaymentFormResultHandlerURL & "): " & szOutputMessage
                        boErrorOccurred = True
                    Else
                        boErrorOccurred = False
                    End If
                End If
            End If

            Return (Not boErrorOccurred)
        End Function
        Public Shared Function ParseNameValueStringIntoArray(szNameValueString As String, boURLDecodeValues As Boolean) As NameValueCollection
            Dim aszPostVariables As String()
            Dim aszSingleVariable As String()
            Dim nvcParsedVariables As NameValueCollection
            Dim szName As String
            Dim szValue As String

            ' break the reponse into an array
            ' first break the variables up using the "&" delimter
            aszPostVariables = szNameValueString.Split("&"c)

            nvcParsedVariables = New NameValueCollection()

            For Each szVariable As String In aszPostVariables
                ' for each variable, split is again on the "=" delimiter
                ' to give name/value pairs
                aszSingleVariable = szVariable.Split("="c)
                szName = aszSingleVariable(0)
                If Not boURLDecodeValues Then
                    szValue = aszSingleVariable(1)
                Else
                    szValue = HttpUtility.UrlDecode(aszSingleVariable(1))
                End If

                nvcParsedVariables.Add(szName, szValue)
            Next

            Return (nvcParsedVariables)
        End Function
        Public Shared Function GetTransactionResultFromPaymentFormHandler(szPaymentFormResultHandlerURL As String, szMerchantID As String, szPassword As String, szCrossReference As String, ByRef trTransactionResult As TransactionResult, ByRef szOutputMessage As String) As Boolean
            Dim boErrorOccurred As Boolean
            Dim szResponse As String
            Dim sbPostString As StringBuilder
            Dim nvcParsedPostVariables As NameValueCollection
            Dim nvcTransactionResultArray As NameValueCollection
            Dim szErrorMessage As String
            Dim szHashDigest As String
            Dim wrRequest As HttpWebRequest
            Dim wrResponse As WebResponse
            Dim swStreamWriter As StreamWriter
            Dim sResponseStream As Stream
            Dim srStreamReader As StreamReader
            Dim sRequestStream As Stream

            boErrorOccurred = False
            szOutputMessage = ""
            trTransactionResult = Nothing

            Try
                ' build up the post string
                sbPostString = New StringBuilder()
                sbPostString.AppendFormat("MerchantID={0}&Password={1}&CrossReference={2}", HttpUtility.UrlEncode(szMerchantID), HttpUtility.UrlEncode(szPassword), HttpUtility.UrlEncode(szCrossReference))

                wrRequest = DirectCast(WebRequest.Create(szPaymentFormResultHandlerURL), HttpWebRequest)
                wrRequest.Method = "POST"
                wrRequest.ContentType = "application/x-www-form-urlencoded"
                wrRequest.KeepAlive = False

                sRequestStream = wrRequest.GetRequestStream()
                swStreamWriter = New StreamWriter(sRequestStream)
                swStreamWriter.Write(sbPostString.ToString())
                swStreamWriter.Flush()
                sRequestStream.Close()

                wrResponse = wrRequest.GetResponse()
                sResponseStream = wrResponse.GetResponseStream()
                srStreamReader = New StreamReader(sResponseStream)
                szResponse = srStreamReader.ReadToEnd()
                sResponseStream.Close()

                If szResponse = "" Then
                    boErrorOccurred = True
                    szOutputMessage = "Received empty response from payment form hander"
                Else
                    Try
                        ' parse the response into an array
                        nvcParsedPostVariables = ParseNameValueStringIntoArray(szResponse, True)

                        If nvcParsedPostVariables("StatusCode") Is Nothing OrElse Convert.ToInt32(nvcParsedPostVariables("StatusCode")) <> 0 Then
                            boErrorOccurred = True

                            ' the message field is expected if the status code is non-zero
                            If nvcParsedPostVariables("Message") Is Nothing Then
                                szOutputMessage = "Received invalid response from payment form hander (" & szResponse & ")"
                            Else
                                szOutputMessage = nvcParsedPostVariables("Message")
                            End If
                        Else
                            ' status code is 0, so	get the transaction result
                            If nvcParsedPostVariables("TransactionResult") Is Nothing Then
                                boErrorOccurred = True
                                szOutputMessage = "No transaction result in response from payment form hander (" & szResponse & ")"
                            Else
                                ' parse the URL decoded transaction result field into a name value array
                                nvcTransactionResultArray = ParseNameValueStringIntoArray(HttpUtility.UrlDecode(nvcParsedPostVariables("TransactionResult")), False)

                                ' parse this array into a transaction result object
                                If Not GetTransactionResultFromPostVariables(nvcTransactionResultArray, trTransactionResult, szHashDigest, szErrorMessage) Then
                                    boErrorOccurred = True
                                    szOutputMessage = "Error (" & szErrorMessage & ") parsing transaction result (" & HttpUtility.UrlDecode(nvcParsedPostVariables("TransactionResult")) & ") in response from payment form hander (" & szResponse & ")"
                                Else
                                    boErrorOccurred = False
                                End If
                            End If
                        End If
                    Catch e As Exception
                        boErrorOccurred = True
                        szOutputMessage = "Exception (" & e.Message & ") when processing response from payment form handler (" & szResponse & ")"
                    End Try
                End If
            Catch e As Exception
                boErrorOccurred = True
                szOutputMessage = e.Message
            End Try

            Return (Not boErrorOccurred)
        End Function

        ' These functions that are run to deal with storing and retrieving the
        ' transaction results. They will be specific to the merchant environment, so cannot
        ' be generalised. The developer MUST implement these functions

        ' This function needs to be able to retrieve the saved transaction resultt
        ' so that the result can be displayed to the customer
        Public Shared Function GetTransactionResultFromStorage(szCrossReference As String, szOrderID As String, ByRef trTransactionResult As TransactionResult, ByRef szOutputMessage As String) As Boolean
            Dim boErrorOccurred As Boolean

            boErrorOccurred = True
            szOutputMessage = "Environment specific function GetTransactionResultFromStorage() needs to be implemented by merchant developer"
            trTransactionResult = Nothing

            Return (Not boErrorOccurred)
        End Function

        ' You should put your code that does any post transaction tasks
        ' (e.g. updates the order object, sends the customer an email etc) in this function
        Public Shared Function ReportTransactionResults(trTransactionResult As TransactionResult, ByRef szOutputMessage As String) As Boolean
            Dim boErrorOccurred As Boolean

            boErrorOccurred = True
            szOutputMessage = "Environment specific function ReportTransactionResults() needs to be implemented by merchant developer"

            Try
                Select Case trTransactionResult.StatusCode
                    ' transaction authorised
                    Case 0
                        Exit Select
                        ' card referred (treat as decline)
                    Case 4
                        Exit Select
                        ' transaction declined
                    Case 5
                        Exit Select
                        ' duplicate transaction
                    Case 20
                        ' need to look at the previous status code to see if the
                        ' transaction was successful
                        ' transaction authorised
                        If trTransactionResult.PreviousStatusCode.Value = 0 Then
                            ' transaction not authorised
                        Else
                        End If
                        Exit Select
                        ' error occurred
                    Case 30
                        Exit Select
                    Case Else
                        Exit Select

                        ' put code to update/store the order with the transaction result
                End Select
            Catch e As Exception
                boErrorOccurred = True
                szOutputMessage = e.Message
            End Try
            Return (Not boErrorOccurred)
        End Function
    End Class
End Namespace