Imports System.Data
Imports System.Configuration
Imports System.Collections
Imports System.Web
Imports System.Web.Security
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports System.Web.UI.WebControls.WebParts
Imports System.Web.UI.HtmlControls
Imports MyCompanyName

Partial Public Class DisplayTransactionResult
    Inherits System.Web.UI.Page
    Protected Sub Page_Load(sender As Object, e As EventArgs)
        Dim trTransactionResult As TransactionResult
        Dim szMessage As String
        Dim szMessageClass As String
        Dim boResultValidationSuccessful As Boolean
        Dim szValidateErrorMessage As String
        Dim boDuplicateTransaction As Boolean
        Dim szPreviousTransactionMessage As String
        Dim szPaymentFormResultHandler As String
        Dim szOutputMessage As String

        ' what we do here depends on the ResultDeliveryMethod
        boDuplicateTransaction = False
        szPreviousTransactionMessage = ""
        boResultValidationSuccessful = False
        szValidateErrorMessage = Nothing
        trTransactionResult = Nothing

        Select Case [Global].ResultDeliveryMethod
            Case RESULT_DELIVERY_METHOD.POST
                ' the results will be delivered via POST variables to this
                ' page	
                boResultValidationSuccessful = PaymentFormHelper.ValidateTransactionResult_POST([Global].MerchantID, [Global].Password, [Global].PreSharedKey, [Global].HashMethod, Request.Form, trTransactionResult, _
                 szValidateErrorMessage)
                ' the results need to be stored here as this is the first time
                ' they will have touched this system
                If boResultValidationSuccessful Then
                    ' handle the case where the results aren't stored correctly
                    If Not PaymentFormHelper.ReportTransactionResults(trTransactionResult, szOutputMessage) Then
                    End If
                End If
                Exit Select
            Case RESULT_DELIVERY_METHOD.SERVER
                ' the results have already been delivered via a server-to-server
                ' call from the payment form to the ServerResultURL
                ' need to query these transaction results to display
                boResultValidationSuccessful = PaymentFormHelper.ValidateTransactionResult_SERVER([Global].MerchantID, [Global].Password, [Global].PreSharedKey, [Global].HashMethod, Request.QueryString, trTransactionResult, _
                 szValidateErrorMessage)
                Exit Select
            Case RESULT_DELIVERY_METHOD.SERVER_PULL
                ' need to query the results from the payment form using the passed
                ' cross reference
                szPaymentFormResultHandler = "https://mms." + [Global].PaymentProcessorDomain & "/Pages/PublicPages/PaymentFormResultHandler.ashx"

                boResultValidationSuccessful = PaymentFormHelper.ValidateTransactionResult_SERVER_PULL([Global].MerchantID, [Global].Password, [Global].PreSharedKey, [Global].HashMethod, Request.QueryString, szPaymentFormResultHandler, _
                 trTransactionResult, szValidateErrorMessage)
                ' the results need to be stored here as this is the first time
                ' they will have touched this system
                If boResultValidationSuccessful Then
                    ' handle the case where the results aren't stored correctly
                    If Not PaymentFormHelper.ReportTransactionResults(trTransactionResult, szOutputMessage) Then
                    End If
                End If
                Exit Select
        End Select

        ' display an error message if the transaction result couldn't be validated
        If Not boResultValidationSuccessful Then
            szMessageClass = "ErrorMessage"
            szMessage = szValidateErrorMessage
        Else
            Select Case trTransactionResult.StatusCode
                Case 0
                    szMessageClass = "SuccessMessage"
                    Exit Select
                Case 4
                    szMessageClass = "ErrorMessage"
                    Exit Select
                Case 5
                    szMessageClass = "ErrorMessage"
                    Exit Select
                Case 20
                    boDuplicateTransaction = True
                    If trTransactionResult.PreviousStatusCode.Value = 0 Then
                        szMessageClass = "SuccessMessage"
                    Else
                        szMessageClass = "ErrorMessage"
                    End If
                    szPreviousTransactionMessage = trTransactionResult.PreviousMessage
                    Exit Select
                Case 30
                    szMessageClass = "ErrorMessage"
                    Exit Select
                Case Else
                    szMessageClass = "ErrorMessage"
                    Exit Select
            End Select

            szMessage = trTransactionResult.Message
        End If
        lbMessage.Text = szMessage
        pnMessagePanel.CssClass = szMessageClass

        If boDuplicateTransaction Then
            pnDuplicateTransactionPanel.Visible = True
            lbPreviousTransactionMessage.Text = szPreviousTransactionMessage
        End If
    End Sub
End Class