<%@ Page Language="VB" AutoEventWireup="true" CodeFile="StartHere.aspx.vb" Inherits="MyCompanyName.StartHere" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title>Untitled Page</title>
    <link href="CSS/StyleSheet.css" rel="stylesheet" type="text/css" />
</head>
<body>
    <form id="form1" runat="server">
    <div style="width:800px;margin:auto">
        <div class="ContentRight">
	        <div class="ContentHeader">
		        Posting The Data Securely To The Payment Form
	        </div>
	        <div class="ContentBodyText">
		        <p>
			        This page demonstrates how to post the transactional data across to the payment page in a <b>secure</b> 
			        manner. The transaction data <b>MUST</b> be protected as it is being delivered to the payment form
			        via the customer's browser. The data is protected by the use of Hashing. Hashing is used to produce 
			        a unique "signature" for the data being passed (it is generated using not only the data being 
			        transmitted, but also secret data that is not transmitted, so the fraudster cannot recreate the 
			        hash digest with the data that is passed via their browser). The hash signature is then 
			        re-calculated on receipt of the transmitted data, and <b>if it does not match</b> the hash 
			        signature that was transmitted with the data, then <b>the data has been tampered with</b>, and 
			        the transaction will stop with an error message. The same process (in reverse) should be carried
			        out by this site on receipt of the transaction results.
		        </p>
		        <p>
			        The worst kinds of customer tampering could be lowering the transaction price (say from 100.00 down
			        to 1.00), or making a failed transaction look like an authorised one. This is called a "man-in-the-
			        middle" attack.
		        </p>
		        <p>
			        This page is analogous to the place in shopping cart where you need to jump across to the payment
			        form.
		        </p>
	        </div>

	        <div class="FormItem">
		        <div class="FormLabel">
			        Amount:
		        </div>
		        <div class="FormInputTextOnly">
			        <asp:Label ID="lbAmount" runat="server" />
		        </div>
	        </div>				
	        <div class="FormItem">
		        <div class="FormLabel">
			        Currency:
		        </div>
		        <div class="FormInputTextOnly">
			        <asp:Label ID="lbCurrency" runat="server" />
		        </div>
	        </div>				
	        <div class="FormItem">
		        <div class="FormLabel">
			        Order ID:
		        </div>
		        <div class="FormInputTextOnly">
			        <asp:Label ID="lbOrderID" runat="server" />
		        </div>
	        </div>				
	        <div class="FormItem">
		        <div class="FormLabel">
			        Order Description:
		        </div>
		        <div class="FormInputTextOnly">
			        <asp:Label ID="lbOrderDescription" runat="server" />
		        </div>
	        </div>				
        </div>
    </div>
    </form>
    <form method="post" action="<%= m_szFormAction %>">
	    <input type="hidden" name="HashDigest" value="<%= m_szHashDigest %>" />
	    <input type="hidden" name="MerchantID" value="<%= m_szMerchantID %>" />
	    <input type="hidden" name="Amount" value="<%= m_szAmount %>" />
	    <input type="hidden" name="CurrencyCode" value="<%= m_szCurrencyCode %>" />
	    <input type="hidden" name="OrderID" value="<%= m_szOrderID %>" />
	    <input type="hidden" name="TransactionType" value="<%= m_szTransactionType %>" />
	    <input type="hidden" name="TransactionDateTime" value="<%= m_szTransactionDateTime %>" />
	    <input type="hidden" name="CallbackURL" value="<%= m_szCallbackURL %>" />
	    <input type="hidden" name="OrderDescription" value="<%= m_szOrderDescription %>" />
	    <input type="hidden" name="CustomerName" value="<%= m_szCustomerName %>" />
	    <input type="hidden" name="Address1" value="<%= m_szAddress1 %>" />
	    <input type="hidden" name="Address2" value="<%= m_szAddress2 %>" />
	    <input type="hidden" name="Address3" value="<%= m_szAddress3 %>" />
	    <input type="hidden" name="Address4" value="<%= m_szAddress4 %>" />
	    <input type="hidden" name="City" value="<%= m_szCity %>" />
	    <input type="hidden" name="State" value="<%= m_szState %>" />
	    <input type="hidden" name="PostCode" value="<%= m_szPostCode %>" />
	    <input type="hidden" name="CountryCode" value="<%= m_szCountryCode %>" />
	    <input type="hidden" name="CV2Mandatory" value="<%= m_szCV2Mandatory %>" />
	    <input type="hidden" name="Address1Mandatory" value="<%= m_szAddress1Mandatory %>" />
	    <input type="hidden" name="CityMandatory" value="<%= m_szCityMandatory %>" />
	    <input type="hidden" name="PostCodeMandatory" value="<%= m_szPostCodeMandatory %>" />
	    <input type="hidden" name="StateMandatory" value="<%= m_szStateMandatory %>" />
	    <input type="hidden" name="CountryMandatory" value="<%= m_szCountryMandatory %>" />
	    <input type="hidden" name="ResultDeliveryMethod" value="<%= m_szResultDeliveryMethod %>" />
	    <input type="hidden" name="ServerResultURL" value="<%= m_szServerResultURL %>" />
	    <input type="hidden" name="PaymentFormDisplaysResult" value="<%= m_szPaymentFormDisplaysResult %>" />
	    <input type="hidden" name="ServerResultURLCookieVariables" value="<%= m_szServerResultURLCookieVariables %>" />
	    <input type="hidden" name="ServerResultURLFormVariables" value="<%= m_szServerResultURLFormVariables %>" />
	    <input type="hidden" name="ServerResultURLQueryStringVariables" value="<%= m_szServerResultURLQueryStringVariables %>" />
	    
	    <div class="FormItem">
            <div class="FormItem">
		        <div class="FormSubmit">
			        <input type="submit" value="Post Data To Payment Form" />
		        </div>
	        </div>	    
	    </div>
    </form>
</body>
</html>
