Imports System.Data
Imports System.Configuration
Imports System.Collections
Imports System.Web
Imports System.Web.Security
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports System.Web.UI.WebControls.WebParts
Imports System.Web.UI.HtmlControls

Namespace MyCompanyName
    Partial Public Class StartHere
        Inherits System.Web.UI.Page
        Protected m_szFormAction As String
        Protected m_szHashDigest As String
        Protected m_szMerchantID As String
        Protected m_szAmount As String
        Protected m_szCurrencyCode As String
        Protected m_szOrderID As String
        Protected m_szTransactionType As String
        Protected m_szTransactionDateTime As String
        Protected m_szCallbackURL As String
        Protected m_szOrderDescription As String
        Protected m_szCustomerName As String
        Protected m_szAddress1 As String
        Protected m_szAddress2 As String
        Protected m_szAddress3 As String
        Protected m_szAddress4 As String
        Protected m_szCity As String
        Protected m_szState As String
        Protected m_szPostCode As String
        Protected m_szCountryCode As String
        Protected m_szCV2Mandatory As String
        Protected m_szAddress1Mandatory As String
        Protected m_szCityMandatory As String
        Protected m_szPostCodeMandatory As String
        Protected m_szStateMandatory As String
        Protected m_szCountryMandatory As String
        Protected m_szResultDeliveryMethod As String
        Protected m_szServerResultURL As String
        Protected m_szPaymentFormDisplaysResult As String
        Protected m_szServerResultURLCookieVariables As String
        Protected m_szServerResultURLFormVariables As String
        Protected m_szServerResultURLQueryStringVariables As String

        Protected Sub Page_Load(sender As Object, e As EventArgs)
            Dim szStringToHash As String

            m_szMerchantID = [Global].MerchantID
            m_szResultDeliveryMethod = PaymentFormHelper.GetResultDeliveryMethod([Global].ResultDeliveryMethod)

            m_szFormAction = "https://mms." + [Global].PaymentProcessorDomain & "/Pages/PublicPages/PaymentForm.aspx"

            ' the amount in *minor* currency (i.e. 10.00 passed as "1000")
            m_szAmount = Convert.ToString(1000)
            ' the currency	- ISO 4217 3-digit numeric (e.g. GBP = 826)
            m_szCurrencyCode = Convert.ToString(826)
            ' order ID
            m_szOrderID = "Order-1234"
            ' the transaction type - can be SALE or PREAUTH
            m_szTransactionType = "SALE"
            ' the GMT/UTC relative date/time for the transaction (MUST either be in GMT/UTC 
            ' or MUST include the correct timezone offset)
            m_szTransactionDateTime = DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss zzz")
            ' order description
            m_szOrderDescription = "A Test Order"
            ' these variables allow the payment form to be "seeded" with initial values
            m_szCustomerName = "A Customer"
            m_szAddress1 = "14 Some Address"
            m_szAddress2 = ""
            m_szAddress3 = ""
            m_szAddress4 = ""
            m_szCity = "Some City"
            m_szState = "Some State"
            m_szPostCode = "PO57 0DE"
            ' the country code - ISO 3166-1  3-digit numeric (e.g. UK = 826)
            m_szCountryCode = Convert.ToString(826)
            ' use these to control which fields on the hosted payment form are
            ' mandatory
            m_szCV2Mandatory = Convert.ToString(True)
            m_szAddress1Mandatory = Convert.ToString(False)
            m_szCityMandatory = Convert.ToString(False)
            m_szPostCodeMandatory = Convert.ToString(False)
            m_szStateMandatory = Convert.ToString(False)
            m_szCountryMandatory = Convert.ToString(False)
            ' the URL on this system that the payment form will push the results to (only applicable for 
            ' ResultDeliveryMethod = "SERVER")
            If [Global].ResultDeliveryMethod <> RESULT_DELIVERY_METHOD.SERVER Then
                m_szServerResultURL = ""
            Else
                m_szServerResultURL = PaymentFormHelper.GetSiteSecureBaseURL(Request) & "ReceiveTransactionResult.aspx"
            End If
            ' set this to true if you want the hosted payment form to display the transaction result
            ' to the customer (only applicable for ResultDeliveryMethod = "SERVER")
            If [Global].ResultDeliveryMethod <> RESULT_DELIVERY_METHOD.SERVER Then
                m_szPaymentFormDisplaysResult = ""
            Else
                m_szPaymentFormDisplaysResult = Convert.ToString(False)
            End If
            ' the callback URL on this site that will display the transaction result to the customer
            ' (always required unless ResultDeliveryMethod = "SERVER" and PaymentFormDisplaysResult = "true")
            If [Global].ResultDeliveryMethod = RESULT_DELIVERY_METHOD.SERVER AndAlso Convert.ToBoolean(m_szPaymentFormDisplaysResult) Then
                m_szCallbackURL = ""
            Else
                m_szCallbackURL = PaymentFormHelper.GetSiteSecureBaseURL(Request) & "DisplayTransactionResult.aspx"
            End If

            ' get the string to be hashed
            szStringToHash = PaymentFormHelper.GenerateStringToHash([Global].MerchantID, [Global].Password, m_szAmount, m_szCurrencyCode, m_szOrderID, m_szTransactionType, _
             m_szTransactionDateTime, m_szCallbackURL, m_szOrderDescription, m_szCustomerName, m_szAddress1, m_szAddress2, _
             m_szAddress3, m_szAddress4, m_szCity, m_szState, m_szPostCode, m_szCountryCode, _
             m_szCV2Mandatory, m_szAddress1Mandatory, m_szCityMandatory, m_szPostCodeMandatory, m_szStateMandatory, m_szCountryMandatory, _
             PaymentFormHelper.GetResultDeliveryMethod([Global].ResultDeliveryMethod), m_szServerResultURL, m_szPaymentFormDisplaysResult, [Global].PreSharedKey, [Global].HashMethod)

            ' pass this string into the hash function to create the hash digest
            m_szHashDigest = PaymentFormHelper.CalculateHashDigest(szStringToHash, [Global].PreSharedKey, [Global].HashMethod)

            lbAmount.Text = m_szAmount
            lbCurrency.Text = m_szCurrencyCode
            lbOrderID.Text = m_szOrderID
            lbOrderDescription.Text = m_szOrderDescription
        End Sub
    End Class
End Namespace