<?php
	require_once ("PaymentFormHelper.php");
	include ("Config.php");

	$Width = 800;
	$FormAction = "https://mms.".$PaymentProcessorDomain."/Pages/PublicPages/PaymentForm.aspx";
	include ("Templates/FormHeader.tpl");

	// the amount in *minor* currency (i.e. �10.00 passed as "1000")
	$szAmount = strval(1000);
	// the currency	- ISO 4217 3-digit numeric (e.g. GBP = 826)
	$szCurrencyCode = strval(826);
    $szEchoAVSCheckResult = PaymentFormHelper::boolToString(true);
    $szEchoCV2CheckResult = PaymentFormHelper::boolToString(true);
    $szEchoThreeDSecureAuthenticationCheckResult = PaymentFormHelper::boolToString(true);
    $szEchoCardType = PaymentFormHelper::boolToString(true);
	// order ID
	$szOrderID = "Order-1234";
	// the transaction type - can be SALE or PREAUTH
	$szTransactionType = "SALE";
	// the GMT/UTC relative date/time for the transaction (MUST either be in GMT/UTC 
	// or MUST include the correct timezone offset)
	$szTransactionDateTime = date('Y-m-d H:i:s P');
	// order description
	$szOrderDescription = "A Test Order";
	// these variables allow the payment form to be "seeded" with initial values
	$szCustomerName = "A Customer";
	$szAddress1 = "14 Some Address";
	$szAddress2 = "";
	$szAddress3 = "";
	$szAddress4 = "";
	$szCity = "Some City";
	$szState = "Some State";
	$szPostCode = "PO57 0DE";
	// the country code - ISO 3166-1  3-digit numeric (e.g. UK = 826)
	$szCountryCode = strval(826);
    // use these to control which fields on the hosted payment form are
	// mandatory
	$szCV2Mandatory = PaymentFormHelper::boolToString(true);
	$szAddress1Mandatory = PaymentFormHelper::boolToString(false);
	$szCityMandatory = PaymentFormHelper::boolToString(false);
	$szPostCodeMandatory = PaymentFormHelper::boolToString(false);
	$szStateMandatory = PaymentFormHelper::boolToString(false);
	$szCountryMandatory = PaymentFormHelper::boolToString(false);
	// the URL on this system that the payment form will push the results to (only applicable for 
	// ResultDeliveryMethod = "SERVER")
	if ($ResultDeliveryMethod != "SERVER")
	{
		$szServerResultURL = "";
	}
	else
	{
		$szServerResultURL = PaymentFormHelper::getSiteSecureBaseURL()."ReceiveTransactionResult.php";
	}
	// set this to true if you want the hosted payment form to display the transaction result
	// to the customer (only applicable for ResultDeliveryMethod = "SERVER")
	if ($ResultDeliveryMethod != "SERVER")
	{
		$szPaymentFormDisplaysResult = "";
	}
	else
	{
		$szPaymentFormDisplaysResult = PaymentFormHelper::boolToString(false);
	}
	// the callback URL on this site that will display the transaction result to the customer
	// (always required unless ResultDeliveryMethod = "SERVER" and PaymentFormDisplaysResult = "true")
	if ($ResultDeliveryMethod == "SERVER" &&
		PaymentFormHelper::stringToBool($szPaymentFormDisplaysResult) == true)
	{
		$szCallbackURL = "";
	}
	else
	{
		$szCallbackURL = PaymentFormHelper::getSiteSecureBaseURL()."DisplayTransactionResult.php"; 
	}

	// get the string to be hashed
	$szStringToHash = PaymentFormHelper::generateStringToHash($MerchantID,
			        										  $Password,
			        										  $szAmount,
															  $szCurrencyCode,
                                                              $szEchoAVSCheckResult,
                                                              $szEchoCV2CheckResult,
                                                              $szEchoThreeDSecureAuthenticationCheckResult,
                                                              $szEchoCardType,
															  $szOrderID,
															  $szTransactionType,
															  $szTransactionDateTime,
															  $szCallbackURL,
															  $szOrderDescription,
															  $szCustomerName,
															  $szAddress1,
															  $szAddress2,
															  $szAddress3,
															  $szAddress4,
															  $szCity,
															  $szState,
															  $szPostCode,
															  $szCountryCode,
															  $szCV2Mandatory,
															  $szAddress1Mandatory,
															  $szCityMandatory,
															  $szPostCodeMandatory,
															  $szStateMandatory,
															  $szCountryMandatory,
															  $ResultDeliveryMethod,
															  $szServerResultURL,
															  $szPaymentFormDisplaysResult,
			         		                                  $PreSharedKey,
			         		                                  $HashMethod);

	// pass this string into the hash function to create the hash digest
	$szHashDigest = PaymentFormHelper::calculateHashDigest($szStringToHash,
                        								   $PreSharedKey, 
                        								   $HashMethod);

	include ("Templates/StartHereForm.tpl");
	include ("Templates/FormFooter.tpl");
?>