<div class="ContentRight">
	<div class="ContentHeader">
		Posting The Data Securely To The Payment Form
	</div>
	<div class="ContentBodyText">
		<p>
			This page demonstrates how to post the transactional data across to the payment page in a <b>secure</b> 
			manner. The transaction data <b>MUST</b> be protected as it is being delivered to the payment form
			via the customer's browser. The data is protected by the use of Hashing. Hashing is used to produce 
			a unique "signature" for the data being passed (it is generated using not only the data being 
			transmitted, but also secret data that is not transmitted, so the fraudster cannot recreate the 
			hash digest with the data that is passed via their browser). The hash signature is then 
			re-calculated on receipt of the transmitted data, and <b>if it does not match</b> the hash 
			signature that was transmitted with the data, then <b>the data has been tampered with</b>, and 
			the transaction will stop with an error message. The same process (in reverse) should be carried
			out by this site on receipt of the transaction results.
		</p>
		<p>
			The worst kinds of customer tampering could be lowering the transaction price (say from &pound;100.00 down
			to &pound;1.00), or making a failed transaction look like an authorised one. This is called a "man-in-the-
			middle" attack.
		</p>
		<p>
			This page is analogous to the place in shopping cart where you need to jump across to the payment
			form.
		</p>
	</div>

	<input type="hidden" name="HashDigest" value="<?php echo($szHashDigest); ?>" />
	<input type="hidden" name="MerchantID" value="<?php echo($MerchantID); ?>" />
	<input type="hidden" name="Amount" value="<?php echo($szAmount); ?>" />
	<input type="hidden" name="CurrencyCode" value="<?php echo($szCurrencyCode); ?>" />
    <input type="hidden" name="EchoAVSCheckResult" value="<?php echo($szEchoAVSCheckResult); ?>" />
    <input type="hidden" name="EchoCV2CheckResult" value="<?php echo($szEchoCV2CheckResult); ?>" />
    <input type="hidden" name="EchoThreeDSecureAuthenticationCheckResult" value="<?php echo($szEchoThreeDSecureAuthenticationCheckResult); ?>" />
    <input type="hidden" name="EchoCardType" value="<?php echo($szEchoCardType); ?>" />
    <input type="hidden" name="OrderID" value="<?php echo($szOrderID); ?>" />
	<input type="hidden" name="TransactionType" value="<?php echo($szTransactionType); ?>" />
	<input type="hidden" name="TransactionDateTime" value="<?php echo($szTransactionDateTime); ?>" />
	<input type="hidden" name="CallbackURL" value="<?php echo($szCallbackURL); ?>" />
	<input type="hidden" name="OrderDescription" value="<?php echo($szOrderDescription); ?>" />
	<input type="hidden" name="CustomerName" value="<?php echo($szCustomerName); ?>" />
	<input type="hidden" name="Address1" value="<?php echo($szAddress1); ?>" />
	<input type="hidden" name="Address2" value="<?php echo($szAddress2); ?>" />
	<input type="hidden" name="Address3" value="<?php echo($szAddress3); ?>" />
	<input type="hidden" name="Address4" value="<?php echo($szAddress4); ?>" />
	<input type="hidden" name="City" value="<?php echo($szCity); ?>" />
	<input type="hidden" name="State" value="<?php echo($szState); ?>" />
	<input type="hidden" name="PostCode" value="<?php echo($szPostCode); ?>" />
	<input type="hidden" name="CountryCode" value="<?php echo($szCountryCode); ?>" />
    <input type="hidden" name="CV2Mandatory" value="<?php echo($szCV2Mandatory); ?>" />
	<input type="hidden" name="Address1Mandatory" value="<?php echo($szAddress1Mandatory); ?>" />
	<input type="hidden" name="CityMandatory" value="<?php echo($szCityMandatory); ?>" />
	<input type="hidden" name="PostCodeMandatory" value="<?php echo($szPostCodeMandatory); ?>" />
	<input type="hidden" name="StateMandatory" value="<?php echo($szStateMandatory); ?>" />
	<input type="hidden" name="CountryMandatory" value="<?php echo($szCountryMandatory); ?>" />
	<input type="hidden" name="ResultDeliveryMethod" value="<?php echo($ResultDeliveryMethod); ?>" />
	<input type="hidden" name="ServerResultURL" value="<?php echo($szServerResultURL); ?>" />
	<input type="hidden" name="PaymentFormDisplaysResult" value="<?php echo($szPaymentFormDisplaysResult); ?>" />
	<input type="hidden" name="ServerResultURLCookieVariables" value="" />
	<input type="hidden" name="ServerResultURLFormVariables" value="" />
	<input type="hidden" name="ServerResultURLQueryStringVariables" value="" />
	
	<div class="FormItem">
		<div class="FormLabel">
			Amount:
		</div>
		<div class="FormInputTextOnly">
			<?php echo($szAmount); ?>
		</div>
	</div>				
	<div class="FormItem">
		<div class="FormLabel">
			Currency:
		</div>
		<div class="FormInputTextOnly">
			<?php echo($szCurrencyCode); ?>
		</div>
	</div>				
	<div class="FormItem">
		<div class="FormLabel">
			Order ID:
		</div>
		<div class="FormInputTextOnly">
			<?php echo($szOrderID); ?>
		</div>
	</div>				
	<div class="FormItem">
		<div class="FormLabel">
			Order Description:
		</div>
		<div class="FormInputTextOnly">
			<?php echo($szOrderDescription); ?>
		</div>
	</div>				
	<div class="FormItem">
		<div class="FormSubmit">
			<input type="submit" value="Post Data To Payment Form" />
		</div>
	</div>
</div>