<%
    Dim IncomingHashDigest
    Dim HashDigest
    Dim SiteSecureBaseURL

	Dim CardName
	Dim CardNumber
	Dim ExpiryDateMonth
	Dim ExpiryDateYear 
	Dim StartDateMonth 
	Dim StartDateYear
	Dim IssueNumber
	Dim CV2
	Dim Address1
	Dim Address2
	Dim Address3
	Dim Address4
	Dim City
	Dim State
	Dim PostCode
	Dim CountryCode
	Dim	ResetFormVariables
	Dim	BodyAttributes
	Dim FormAttributes
	Dim FormAction
	Dim FormMode
	Dim NextFormMode
	Dim LoopIndex
	Dim Message
	Dim TransactionSuccessful
	Dim ThisYear
	Dim ThisYearPlusTen
	Dim DisplayMonth
	Dim ShortYear
	Dim FirstZeroPriorityGroup
	Dim Amount
	Dim CurrencyCode
	Dim OrderID
	Dim OrderDescription
	Dim PaREQ
    Dim ACSURL
	Dim CrossReference
	Dim PaRES
	Dim DuplicateTransaction
	Dim PreviousTransactionMessage
	Dim MessageClass
    Dim TransactionType
    Dim TransactionDateTime
    Dim CallbackURL
    Dim TermURL

	
	ResetFormVariables = False
	BodyAttributes = ""
	FormAttributes = ""
	FormAction = "PaymentForm.asp"

    SiteSecureBaseURL = pfhPaymentFormHelper.GetSiteSecureBaseURL()
    
    FormMode = Request.Form("FormMode")

    If (Request.Form.Count = 0) Then
        NextFormMode = FORM_MODE.RESULTS
        
        MessageClass = "ErrorMessage"
        Message.Text = "No input variables passed"
    
	Else

        If (Not IsEmpty(Request.Form("ShoppingCartHashDigest"))) Then
            If (Not pfhPaymentFormHelper.CheckIntegrityOfIncomingVariables("SHOPPING_CART_CHECKOUT", Request.Form)) Then

                NextFormMode = "RESULTS"

                MessageClass = "ErrorMessage"
                Message = "Variable tampering detected"

            Else
                   
                NextFormMode = "PAYMENT_FORM"
                FormAction = "https://mms." + PaymentProcessorDomain + "/Pages/PublicPages/TransparentRedirect.aspx"

                Amount = Request.Form("Amount")
                OrderID = Request.Form("OrderID")
                OrderDescription = Request.Form("OrderDescription")
                CurrencyCode = Request.Form("CurrencyCode")     

                ' the transaction type - can be SALE or PREAUTH
                TransactionType = Request.Form("TransactionType")

                ' the GMT/UTC relative date/time for the transaction (MUST either be in GMT/UTC 
                ' or MUST include the correct timezone offset)
                TransactionDateTime = Request.Form("TransactionDateTime")

                CallbackURL = Request.Form("CallbackURL")

                ' these variables allow the payment form to be "seeded" with initial values
                CardName = Request.Form("CustomerName")
                Address1 = Request.Form("Address1")
                Address2 = Request.Form("Address2")
                Address3 = Request.Form("Address3")
                Address4 = Request.Form("Address4")
                City = Request.Form("City")
                State = Request.Form("State")
                PostCode = Request.Form("PostCode")
                CountryCode = Request.Form("CountryCode")
            End If
                
        Else
                
            If (Not IsEmpty(Request.Form("HashDigest"))) Then
                    
                If (Not IsEmpty(Request.Form("PaREQ"))) Then
                         
                    If (Not pfhPaymentFormHelper.CheckIntegrityOfIncomingVariables("THREE_D_SECURE_AUTHENTICATION_REQUIRED", Request.Form)) Then

                        NextFormMode = "RESULTS"

                        MessageClass = "ErrorMessage"
                        Message = "Variable tampering detected"
                            
                    Else
                            
                        NextFormMode = "THREE_D_SECURE_AUTHENTICATION_REQUIRED"

                        BodyAttributes = " onload=""document.Form.submit();"""
                        FormAttributes = " target=""ACSFrame"""

                        FormAction = pfhPaymentFormHelper.trTransactionResult.ACSURL
                        PaREQ = pfhPaymentFormHelper.trTransactionResult.PaREQ
                        'ACSURL = pfhPaymentFormHelper.trTransactionResult.ACSURL
                        CrossReference = pfhPaymentFormHelper.trTransactionResult.CrossReference
                        TermURL = pfhPaymentFormHelper.GetSiteSecureBaseURL() + "ThreeDSecureLandingPage.asp"

                    End If
                        
                Else
                        
                    NextFormMode = "RESULTS"

                    If ( Not pfhPaymentFormHelper.CheckIntegrityOfIncomingVariables("RESULTS", Request.Form)) Then
                            
                        MessageClass = "ErrorMessage"
                        Message = "Variable tampering detected"
                    
                    Else

                        Dim OutputMessage

                        If ( Not pfhPaymentFormHelper.ReportTransactionResult(pfhPaymentFormHelper.trTransactionResult, OutputMessage)) Then
                                
                            ' handle the case where the results aren't stored correctly
                            MessageClass = "ErrorMessage"

                            ' You might want to display the actual exception message during testing
                            ' If so, comment and uncomment out the two lines below as necessary
                            Message = "An error has occured"
                            'Message = OutputMessage
                        
                        Else
                            
                            Select Case pfhPaymentFormHelper.trTransactionResult.StatusCode
                                case 0
                                    MessageClass = "SuccessMessage"
                                    TransactionSuccessful = true

                                case 4

                                    MessageClass = "ErrorMessage"

                                case 5

                                    MessageClass = "ErrorMessage"

                                case 20

                                    DuplicateTransaction = true

                                    If (pfhPaymentFormHelper.trTransactionResult.PreviousStatusCode = 0) Then

                                        MessageClass = "SuccessMessage"
                                        TransactionSuccessful = true

                                    Else

                                        MessageClass = "ErrorMessage"

                                    End If
                                
                                    PreviousTransactionMessage = pfhPaymentFormHelper.trTransactionResult.PreviousMessage

                                case 30 :
                                    MessageClass = "ErrorMessage"
                            End Select

                            Message = pfhPaymentFormHelper.trTransactionResult.Message
                        End If
                    End If
                End IF
            End If
        End If                
    End If

	' Reset the form variables if required 
	If ResetFormVariables = True Then
		CardName = ""
		CardNumber = ""
		ExpiryDateMonth = ""
		ExpiryDateYear = ""
		StartDateMonth = ""
		StartDateYear = ""
		IssueNumber = ""
		CV2 = ""
		Address1 = ""
		Address2 = ""
		Address3 = ""
		Address4 = ""
		City = ""
		State = ""
		PostCode = ""
		CountryISOCode = ""
	End If

%>
