<cfinclude template="PaymentFormHelper.cfm" />

<cfscript>
	ResetFormVariables = false;
	SuppressFormDisplay = false;
	BodyAttributes = "";
	FormAction = "";
	FormAttributes = "";
	
	NextFormMode = "PAYMENT_FORM";
	
	MessageClass = "";
	Message = "";
	DuplicateTransaction = false;
	PreviousTransactionMessage = "";
	
	aVariables = ArrayNew(1);

	if (isDefined("form.fieldnames") NEQ true)
	{
		NextFormMode = "PAYMENT_FORM";
		Message = "No input variables passed";
		MessageClass = "ErrorMessage";
		SuppressFormDisplay = true;
	
	} else {
		if (isDefined("form.ShoppingCartHashDigest"))
		{
			if (CheckIntegrityOfIncomingVariables("SHOPPING_CART_CHECKOUT", FORM, HashMethod, SecretKey, MerchantID, Password) EQ true)
			{
				NextFormMode = "PAYMENT_FORM";
		        FormAction = "https://mms." & PaymentProcessorDomain & "/Pages/PublicPages/TransparentRedirect.aspx";
				
				Amount = Form.Amount;
				CurrencyCode = Form.CurrencyCode;
				OrderID = Form.OrderID;
                TransactionType = Form.TransactionType;
                TransactionDateTime = Form.TransactionDateTime;
                CallbackURL = Form.CallbackURL;
				OrderDescription = Form.OrderDescription;
				
				CardName = Form.CustomerName;
				CardNumber = "";
				IssueNumber = "";
				CV2 = "";
				
                Address1 = Form.Address1;
                Address2 = Form.Address2;
                Address3 = Form.Address3;
                Address4 = Form.Address4;
                City = Form.City;
                State = Form.State;
                PostCode = Form.PostCode;
                CurrencyCode = Form.CurrencyCode;
			}
			else
			{
				NextFormMode = "PAYMENT_FORM";
				Message = "Variable tampering detected";
				MessageClass = "ErrorMessage";
				SuppressFormDisplay = true;
			}
		} else if (isDefined("HashDigest"))
	    {
	        if (isDefined("PaREQ"))
	        {
       	        if (CheckIntegrityOfIncomingVariables("THREE_D_SECURE_AUTHENTICATION_REQUIRED", FORM, HashMethod, PreSharedKey, MerchantID, Password) EQ true)
                {
                    NextFormMode = "THREE_D_SECURE_AUTHENTICATION_REQUIRED";

		            BodyAttributes = " onload=""document.Form.submit();""";
		            FormAction = ACSURL;
		            FormAttributes = " target=""ACSFrame""";
                }
                else
                {
                    NextFormMode = "PAYMENT_FORM";
                    Message = "Variable tampering detected";
					MessageClass = "ErrorMessage";
                    SuppressFormDisplay = true;
                }
	        }
	        else
	        {
	            NextFormMode = "RESULTS";
	            FormAction = "PaymentForm.php";
	            
	            if (CheckIntegrityOfIncomingVariables("RESULTS", FORM, HashMethod, PreSharedKey, MerchantID, Password) EQ true)
                {
                    OutMessage = StructNew();
                    
					if (ReportTransactionResult(trTransactionResult, OutMessage) NEQ true)
					{
						// handle the case where the results aren't stored correctly
                        MessageClass = "ErrorMessage";
                        

                        // You might want to display the actual exception message during testing
                        // If so, comment and uncomment out the two lines below as necessary
                        Message = "An error has occured";
                        //Message = OutMessage.Value;
					}
					else
					{
						switch (trTransactionResult.StatusCode)
			            {
			                // transaction authorised
			                case 0:
			                    MessageClass = "SuccessMessage";
			                    break;
			                // transaction declined
			                case 5:
			                    MessageClass = "ErrorMessage";
			                    break;
			                // duplicate transaction
			                case 20:
			                    DuplicateTransaction = true;
			    
			                    // need to look at the previous status code to see if the
			                    // transaction was successful
			                    if (trTransactionResult.PreviousStatusCode EQ 0)
			                    {
			                        // transaction authorised
			                        MessageClass = "SuccessMessage";
			                    }
			                    else
			                    {
			                        // transaction not authorised
			                        MessageClass = "ErrorMessage";
			                    }
			                    PreviousTransactionMessage = trTransactionResult.PreviousMessage;
			    
			                    break;
			                // error occurred
			                case 30:
			                    MessageClass = "ErrorMessage";
			                    break;
			                default:
			                    MessageClass = "ErrorMessage";
			                    break;
			            }
			            Message = trTransactionResult.Message;	
					}
                    
                } else {
					NextFormMode = "PAYMENT_FORM";
                    Message = "Variable tampering detected";
					MessageClass = "ErrorMessage";
                    SuppressFormDisplay = true;
                }
	        }
	    } else { 
			FormMode = "PAYMENT_FORM";
			Message = "No input variables passed";
			MessageClass = "ErrorMessage";
			SuppressFormDisplay = true;	
	    }
	}
	

	// Reset the form variables if required 
	if (ResetFormVariables EQ true)
	{
		CardName = "";
		CardNumber = "";
		ExpiryDateMonth = "";
		ExpiryDateYear = "";
		StartDateMonth = "";
		StartDateYear = "";
		IssueNumber = "";
		CV2 = "";
		Address1 = "";
		Address2 = "";
		Address3 = "";
		Address4 = "";
		City = "";
		State = "";
		PostCode = "";
		CountryShort = "";
	}
</cfscript>