<cfinclude template="PaymentFormHelper.cfm">

<cfscript>
	Width = 800;
	BodyAttributes = "";
	FormAttributes = "";
	FormAction = "PaymentForm.cfm";

	IncludeTemplate("Templates/FormHeader.tpl");

    // the amount in *minor* currency (i.e. �10.00 passed as "1000")
	Amount = 1000;
	// the currency	- ISO 4217 3-digit numeric (e.g. GBP = 826)
	CurrencyCode = 826;
	// order ID
	OrderID = "Order-1234";
	// the transaction type - can be SALE or PREAUTH
	TransactionType = "SALE";
	// the GMT/UTC relative date/time for the transaction (MUST either be in GMT/UTC 
	// or MUST include the correct timezone offset)
	TransactionDateTime = DateFormat(now(), "yyyy-mm-dd") & " " & TimeFormat(now(), "HH:mm:ss") & " " & GetTimeZoneOffset();
	// callback URL
	CallbackURL = GetSiteSecureBaseURL() & "PaymentForm.cfm";
	// order description
	OrderDescription = "A Test Order";
	// these variables allow the payment form to be "seeded" with initial values
	CustomerName = "A Customer";
	Address1 = "14 Some Address";
	Address2 = "";
	Address3 = "";
	Address4 = "";
	City = "Some City";
	State = "Some State";
	PostCode = "PO57 0DE";
	// the country code - ISO 3166-1  3-digit numeric (e.g. UK = 826)
	// PLease Note: This needs to remain as ISO Country Code 826 at present in the StartHere form sample code
	CountryCode = 826;

	// get the string to be hashed
	StringToHash = GenerateStringToHash(	Amount,
											CurrencyCode,
											OrderID,
											TransactionType,
											TransactionDateTime,
											CallbackURL,
											OrderDescription,
											CustomerName,
											Address1,
											Address2,
											Address3,
											Address4,
											City,
											State,
											PostCode,
											CountryCode,
											SecretKey);

	// pass this string into the hash function to create the hash digest
	HashDigest = CalculateHashDigest(StringToHash, 
									SecretKey, 
									HashMethod);

	IncludeTemplate("Templates/StartHereForm.tpl");
	IncludeTemplate("Templates/FormFooter.tpl");
</cfscript>