package net.mycompanyname;

import java.util.*;
import java.lang.Exception;

public class NameValueList 
{
    private ArrayList m_nameValueList;

    public int getCount() { return (m_nameValueList.size()); }
    
    public NameValue getAt(int index) throws Exception
    {  
        if (index < 0 || index >= m_nameValueList.size())
        {
            throw  new Exception("Array index out of bounds");
        }
        return ((NameValue)m_nameValueList.get(index));
    }

    public NameValue get(String name)
    {  
        int count = 0;
        boolean found = false;
        NameValue nameValue = null;
        NameValue returnNameValue = null;
        
        while (!found &&
               count < this.getCount())
        {
            try
            {
                nameValue = this.getAt(count);
            }
            catch (Exception e)
            {
                nameValue = null;
            }
            
            if (nameValue != null &&
                nameValue.getName().equalsIgnoreCase(name))
            {
                found = true;
                returnNameValue = nameValue;
            }
            count++;
        }
        
        return (returnNameValue);
    }
    public boolean existsInList(String name)
    {  
        int count = 0;
        boolean found = false;
        NameValue nameValue = null;
        
        while (!found &&
               count < this.getCount())
        {
            try
            {
                nameValue = this.getAt(count);
            }
            catch (Exception e)
            {
                nameValue = null;
            }
            
            if (nameValue != null &&
                nameValue.getName().equalsIgnoreCase(name))
            {
                found = true;
            }
            count++;
        }
        
        return (found);
    }
    
    public void add(NameValue nameValue)
    {
	m_nameValueList.add(nameValue);
    }
    
    public void add(String name, String value)
    {
        NameValue nameValue;
        
        nameValue = new NameValue(name);
        nameValue.setValue(value);
        
	m_nameValueList.add(nameValue);
    }
    
    public NameValueList()
    {
        m_nameValueList =  new ArrayList();
    }
}