package net.mycompanyname;

import java.io.InputStreamReader;
import java.net.URLConnection;
import java.net.URLDecoder;
import java.net.URLEncoder;
import javax.servlet.http.HttpServletRequest;
import java.security.MessageDigest;
import javax.crypto.Mac;
import javax.crypto.spec.SecretKeySpec;
import java.security.Key;
import java.util.Enumeration;
import java.net.URL;
import java.net.URLConnection;
import java.io.DataOutputStream;
import java.io.InputStreamReader;
import java.io.DataInputStream;
import java.util.HashSet;
import java.util.Set;

public class PaymentFormHelper {

    public static String getSiteSecureBaseURL(HttpServletRequest request) {
        String szReturnString;
        StringBuffer sbString = null;
        int nIndex;

        sbString = request.getRequestURL();

        nIndex = sbString.lastIndexOf("/");

        szReturnString = sbString.substring(0, nIndex + 1);

        return (szReturnString);
    }

    public static ListItemCollection createExpiryDateMonthListItemList(String expiryDateMonth) {
        ListItemCollection expiryDateMonthList;
        int loopIndex;
        StringBuffer displayMonth;

        expiryDateMonthList = new ListItemCollection();

        for (loopIndex = 1; loopIndex <= 12; loopIndex++) {
            displayMonth = new StringBuffer();

            if (loopIndex < 10) {
                displayMonth.append("0");
                displayMonth.append(loopIndex);
            } else {
                displayMonth.append(loopIndex);
            }
            if (expiryDateMonth != null
                    && !expiryDateMonth.equals("")
                    && expiryDateMonth.equals(displayMonth.toString())) {
                expiryDateMonthList.add(displayMonth.toString(), displayMonth.toString(), true);
            } else {
                expiryDateMonthList.add(displayMonth.toString(), displayMonth.toString(), false);
            }
        }

        return (expiryDateMonthList);
    }

    public static ListItemCollection createExpiryDateYearListItemList(String expiryDateYear) {
        ListItemCollection expiryDateYearList;
        int loopIndex;
        StringBuffer yearName;
        String yearValue;
        StringBuffer shortYear;
        int thisYear;
        int thisYearPlusTen;
        java.util.Calendar calendar;

        calendar = java.util.Calendar.getInstance();

        thisYear = calendar.get(java.util.Calendar.YEAR);
        thisYearPlusTen = thisYear + 10;

        expiryDateYearList = new ListItemCollection();

        for (loopIndex = thisYear; loopIndex <= thisYearPlusTen; loopIndex++) {
            yearName = new StringBuffer();

            yearName.append(loopIndex);
            yearValue = yearName.substring(yearName.length() - 2, yearName.length());

            if (expiryDateYear != null
                    && !expiryDateYear.equals("")
                    && expiryDateYear.equals(yearValue)) {
                expiryDateYearList.add(yearName.toString(), yearValue, true);
            } else {
                expiryDateYearList.add(yearName.toString(), yearValue, false);
            }
        }

        return (expiryDateYearList);
    }

    public static ListItemCollection createStartDateMonthListItemList(String startDateMonth) {
        ListItemCollection startDateMonthList;
        int loopIndex;
        StringBuffer displayMonth;

        startDateMonthList = new ListItemCollection();

        for (loopIndex = 1; loopIndex <= 12; loopIndex++) {
            displayMonth = new StringBuffer();

            if (loopIndex < 10) {
                displayMonth.append("0");
                displayMonth.append(loopIndex);
            } else {
                displayMonth.append(loopIndex);
            }
            if (startDateMonth != null
                    && !startDateMonth.equals("")
                    && startDateMonth.equals(displayMonth.toString())) {
                startDateMonthList.add(displayMonth.toString(), displayMonth.toString(), true);
            } else {
                startDateMonthList.add(displayMonth.toString(), displayMonth.toString(), false);
            }
        }

        return (startDateMonthList);
    }

    public static ListItemCollection createStartDateYearListItemList(String startDateYear) {
        ListItemCollection startDateYearList;
        int loopIndex;
        StringBuffer yearName;
        String yearValue;
        StringBuffer shortYear;
        int thisYear;
        java.util.Calendar calendar;

        calendar = java.util.Calendar.getInstance();

        thisYear = calendar.get(java.util.Calendar.YEAR);

        startDateYearList = new ListItemCollection();

        for (loopIndex = 2000; loopIndex <= thisYear; loopIndex++) {
            yearName = new StringBuffer();

            yearName.append(loopIndex);
            yearValue = yearName.substring(yearName.length() - 2, yearName.length());

            if (startDateYear != null
                    && !startDateYear.equals("")
                    && startDateYear.equals(yearValue)) {
                startDateYearList.add(yearName.toString(), yearValue, true);
            } else {
                startDateYearList.add(yearName.toString(), yearValue, false);
            }
        }

        return (startDateYearList);
    }

    public static ListItemCollection createISOCountryListItemList() {

        ListItemCollection ISOCountryList;
        ISOCountryList = new ListItemCollection();

        ISOCountryList.add("United Kingdom", "826", true);

        // TODO ISOCOUNTRY LOOP

        return (ISOCountryList);
    }

    public static NameValueList parseNameValueStringIntoArray(String nameValueString, boolean urlDecodeValues) {
        String[] postVariables;
        String[] singleVariable;
        String variable;
        NameValueList parsedVariables;
        String name;
        String value;
        int count;

        // break the reponse into an array
        // first break the variables up using the "&" delimter
        postVariables = nameValueString.split("&");

        parsedVariables = new NameValueList();

        for (count = 0; count < postVariables.length; count++) {
            // for each variable, split is again on the "=" delimiter
            // to give name/value pairs
            variable = postVariables[count];

            singleVariable = variable.split("=");
            name = singleVariable[0];

            if (!urlDecodeValues) {
                try {
                    value = singleVariable[1];
                } catch (Exception e) {
                    value = "";
                }
            } else {
                try {
                    value = URLDecoder.decode(singleVariable[1], "UTF-8");
                } catch (Exception e) {
                    value = "";
                }
            }

            parsedVariables.add(name, value);
        }

        return (parsedVariables);
    }

    public static NameValueList parseIntoList(HttpServletRequest request) {
        boolean finished = false;
        int count = 0;
        Enumeration parameters;
        String parameterName;
        String parameterValue;
        NameValueList nameValueList;

        nameValueList = new NameValueList();

        if (request != null) {
            parameters = request.getParameterNames();

            while (!finished
                    && parameters.hasMoreElements()) {
                try {
                    parameterName = (String) parameters.nextElement();
                    parameterValue = request.getParameter(parameterName);

                    nameValueList.add(parameterName, parameterValue);
                } catch (Exception e) {
                    finished = true;
                }
            }
        }

        return nameValueList;
    }

    public static String GenerateStringToHashInitial(String szMerchantID,
            String szPassword,
            String szAmount,
            int nCurrencyCode,
            String szOrderID,
            String szTransactionType,
            String szTransactionDateTime,
            String szCallbackURL,
            String szOrderDescription,
            String szPreSharedKey,
            String szHashMethod) {
        StringBuilder sbReturnString;
        sbReturnString = new StringBuilder();

        // simple hash methods aren't seeded on initialisation
        // with the PSK, so it's "influence" on the hash digest must
        // be more direct - i.e. it's included in the String to be hashed
        if (!isStringNullOrEmpty(szHashMethod)
                && (szHashMethod.equals("MD5")
                || szHashMethod.equals("SHA1"))) {
            sbReturnString.append("PreSharedKey=");
            sbReturnString.append(szPreSharedKey);
            sbReturnString.append("&");
        }

        sbReturnString.append("MerchantID=");
        sbReturnString.append(szMerchantID);
        sbReturnString.append("&");

        sbReturnString.append("Password=");
        sbReturnString.append(szPassword);
        sbReturnString.append("&");

        sbReturnString.append("Amount=");
        sbReturnString.append(szAmount);
        sbReturnString.append("&");

        sbReturnString.append("CurrencyCode=");
        sbReturnString.append(nCurrencyCode);
        sbReturnString.append("&");

        sbReturnString.append("OrderID=");
        sbReturnString.append(szOrderID);
        sbReturnString.append("&");

        sbReturnString.append("TransactionType=");
        sbReturnString.append(szTransactionType);
        sbReturnString.append("&");

        sbReturnString.append("TransactionDateTime=");
        sbReturnString.append(szTransactionDateTime);
        sbReturnString.append("&");

        sbReturnString.append("CallbackURL=");
        sbReturnString.append(szCallbackURL);
        sbReturnString.append("&");

        sbReturnString.append("OrderDescription=");
        sbReturnString.append(szOrderDescription);

        return (sbReturnString.toString());
    }

    public static String GenerateStringToHash3DSecureAuthenticationRequired(String szMerchantID,
            String szPassword,
            TransactionResult trTransactionResult,
            String szPreSharedKey,
            String szHashMethod) {
        StringBuilder sbReturnString;
        sbReturnString = new StringBuilder();

        // simple hash methods aren't seeded on initialisation
        // with the PSK, so it's "influence" on the hash digest must
        // be more direct - i.e. it's included in the String to be hashed
        if (!isStringNullOrEmpty(szHashMethod)
                && (szHashMethod.equals("MD5")
                || szHashMethod.equals("SHA1"))) {
            sbReturnString.append("PreSharedKey=");
            sbReturnString.append(szPreSharedKey);
            sbReturnString.append("&");
        }

        sbReturnString.append("MerchantID=");
        sbReturnString.append(szMerchantID);

        sbReturnString.append("&Password=");
        sbReturnString.append(szPassword);

        sbReturnString.append("&StatusCode=");
        sbReturnString.append(trTransactionResult.getStatusCode());

        sbReturnString.append("&Message=");
        sbReturnString.append(trTransactionResult.getMessage());

        sbReturnString.append("&CrossReference=");
        sbReturnString.append(trTransactionResult.getCrossReference());

        sbReturnString.append("&OrderID=");
        sbReturnString.append(trTransactionResult.getOrderID());

        sbReturnString.append("&TransactionDateTime=");
        sbReturnString.append(trTransactionResult.getTransactionDateTime());

        sbReturnString.append("&ACSURL=");
        sbReturnString.append(trTransactionResult.getACSURL());

        sbReturnString.append("&PaREQ=");
        sbReturnString.append(trTransactionResult.getPaREQ());

        return (sbReturnString.toString());
    }

    public static String GenerateStringToHash3DSecurePostAuthentication(String szMerchantID,
            String szPassword,
            String szCrossReference,
            String szTransactionDateTime,
            String szCallbackURL,
            String szPaRES,
            String szPreSharedKey,
            String szHashMethod) {
        StringBuilder sbReturnString;
        sbReturnString = new StringBuilder();

        // simple hash methods aren't seeded on initialisation
        // with the PSK, so it's "influence" on the hash digest must
        // be more direct - i.e. it's included in the String to be hashed
        if (!isStringNullOrEmpty(szHashMethod)
                && (szHashMethod.equals("MD5")
                || szHashMethod.equals("SHA1"))) {
            sbReturnString.append("PreSharedKey=");
            sbReturnString.append(szPreSharedKey);
            sbReturnString.append("&");
        }

        sbReturnString.append("MerchantID=");
        sbReturnString.append(szMerchantID);

        sbReturnString.append("&Password=");
        sbReturnString.append(szPassword);

        sbReturnString.append("&CrossReference=");
        sbReturnString.append(szCrossReference);

        sbReturnString.append("&TransactionDateTime=");
        sbReturnString.append(szTransactionDateTime);

        sbReturnString.append("&CallbackURL=");
        sbReturnString.append(szCallbackURL);

        sbReturnString.append("&PaRES=");
        sbReturnString.append(szPaRES);

        return (sbReturnString.toString());
    }

    public static String GenerateStringToHashPaymentComplete(String szMerchantID,
            String szPassword,
            TransactionResult trTransactionResult,
            String szPreSharedKey,
            String szHashMethod) {
        StringBuilder sbReturnString;
        sbReturnString = new StringBuilder();

        // simple hash methods aren't seeded on initialisation
        // with the PSK, so it's "influence" on the hash digest must
        // be more direct - i.e. it's included in the String to be hashed
        if (!isStringNullOrEmpty(szHashMethod)
                && (szHashMethod.equals("MD5")
                || szHashMethod.equals("SHA1"))) {
            sbReturnString.append("PreSharedKey=");
            sbReturnString.append(szPreSharedKey);
            sbReturnString.append("&");
        }

        sbReturnString.append("MerchantID=");
        sbReturnString.append(szMerchantID);

        sbReturnString.append("&Password=");
        sbReturnString.append(szPassword);

        sbReturnString.append("&StatusCode=");
        sbReturnString.append(trTransactionResult.getStatusCode());

        sbReturnString.append("&Message=");
        sbReturnString.append(trTransactionResult.getMessage());

        sbReturnString.append("&PreviousStatusCode=");
        if (trTransactionResult.getPreviousStatusCode().getHasValue()) {
            try {
                sbReturnString.append(trTransactionResult.getPreviousStatusCode().getValue());
            } catch (Exception e) {
            }
        }

        sbReturnString.append("&PreviousMessage=");
        sbReturnString.append(trTransactionResult.getPreviousMessage());

        sbReturnString.append("&CrossReference=");
        sbReturnString.append(trTransactionResult.getCrossReference());

        sbReturnString.append("&AddressNumericCheckResult=");
        sbReturnString.append(trTransactionResult.getAddressNumericCheckResult());

        sbReturnString.append("&PostCodeCheckResult=");
        sbReturnString.append(trTransactionResult.getPostCodeCheckResult());

        sbReturnString.append("&CV2CheckResult=");
        sbReturnString.append(trTransactionResult.getCV2CheckResult());

        sbReturnString.append("&ThreeDSecureAuthenticationCheckResult=");
        sbReturnString.append(trTransactionResult.getThreeDSecureAuthenticationCheckResult());

        sbReturnString.append("&CardType=");
        sbReturnString.append(trTransactionResult.getCardType());

        sbReturnString.append("&CardClass=");
        sbReturnString.append(trTransactionResult.getCardClass());

        sbReturnString.append("&CardIssuer=");
        sbReturnString.append(trTransactionResult.getCardIssuer());

        sbReturnString.append("&CardIssuerCountryCode=");
        if (trTransactionResult.getCardIssuerCountryCode().getHasValue()) {
            try {
                sbReturnString.append(trTransactionResult.getCardIssuerCountryCode().getValue());
            } catch (Exception e) {
            }
        }

        sbReturnString.append("&Amount=");
        sbReturnString.append(trTransactionResult.getAmount());

        sbReturnString.append("&CurrencyCode=");
        if (trTransactionResult.getCurrencyCode().getHasValue()) {
            try {
                sbReturnString.append(trTransactionResult.getCurrencyCode().getValue());
            } catch (Exception e) {
            }
        }

        sbReturnString.append("&OrderID=");
        sbReturnString.append(trTransactionResult.getOrderID());

        sbReturnString.append("&TransactionType=");
        sbReturnString.append(trTransactionResult.getTransactionType());

        sbReturnString.append("&TransactionDateTime=");
        sbReturnString.append(trTransactionResult.getTransactionDateTime());

        sbReturnString.append("&OrderDescription=");
        sbReturnString.append(trTransactionResult.getOrderDescription());

        sbReturnString.append("&Address1=");
        sbReturnString.append(trTransactionResult.getAddress1());

        sbReturnString.append("&Address2=");
        sbReturnString.append(trTransactionResult.getAddress2());

        sbReturnString.append("&Address3=");
        sbReturnString.append(trTransactionResult.getAddress3());

        sbReturnString.append("&Address4=");
        sbReturnString.append(trTransactionResult.getAddress4());

        sbReturnString.append("&City=");
        sbReturnString.append(trTransactionResult.getCity());

        sbReturnString.append("&State=");
        sbReturnString.append(trTransactionResult.getState());

        sbReturnString.append("&PostCode=");
        sbReturnString.append(trTransactionResult.getPostCode());

        sbReturnString.append("&CountryCode=");
        if (trTransactionResult.getCountryCode().getHasValue()) {
            try {
                sbReturnString.append(trTransactionResult.getCountryCode().getValue());
            } catch (Exception e) {
            }
        }

        sbReturnString.append("&EmailAddress=");
        sbReturnString.append(trTransactionResult.getEmailAddress());

        sbReturnString.append("&PhoneNumber=");
        sbReturnString.append(trTransactionResult.getPhoneNumber());

        return (sbReturnString.toString());
    }
    public static boolean Get3DSecureAuthenticationRequiredFromPostVariables(NameValueList nameValueList,
            OutTransactionResult otrOutTransactionResult,
            OutString szHashDigest,
            OutString szOutputMessage) {
        boolean boErrorOccurred;

        otrOutTransactionResult.output = new TransactionResult();
        szHashDigest.output = null;
        szOutputMessage.output = null;

        boErrorOccurred = false;

        try {
            // hash digest
            if (nameValueList.existsInList("HashDigest")) {
                szHashDigest.output = nameValueList.get("HashDigest").getValue();
            }

            // transaction status code
            if (!nameValueList.existsInList("StatusCode")) {
                szOutputMessage.output = addStringToStringList(szOutputMessage.output, "Expected variable [StatusCode] not received");
                boErrorOccurred = true;
            } else {
                otrOutTransactionResult.output.setStatusCode(Integer.parseInt(nameValueList.get("StatusCode").getValue()));
            }
            // transaction message
            if (!nameValueList.existsInList("Message")) {
                szOutputMessage.output = addStringToStringList(szOutputMessage.output, "Expected variable [Message] not received");
                boErrorOccurred = true;
            } else {
                otrOutTransactionResult.output.setMessage(nameValueList.get("Message").getValue());
            }
            // cross reference of transaction
            if (!nameValueList.existsInList("CrossReference")) {
                szOutputMessage.output = addStringToStringList(szOutputMessage.output, "Expected variable [CrossReference] not received");
                boErrorOccurred = true;
            } else {
                otrOutTransactionResult.output.setCrossReference(nameValueList.get("CrossReference").getValue());
            }
            // order ID (same as value passed into payment form - echoed back out by payment form)
            if (!nameValueList.existsInList("OrderID")) {
                szOutputMessage.output = addStringToStringList(szOutputMessage.output, "Expected variable [OrderID] not received");
                boErrorOccurred = true;
            } else {
                otrOutTransactionResult.output.setOrderID(nameValueList.get("OrderID").getValue());
            }
            // transaction date/time (same as value passed into payment form - echoed back out by payment form)
            if (!nameValueList.existsInList("TransactionDateTime")) {
                szOutputMessage.output = addStringToStringList(szOutputMessage.output, "Expected variable [TransactionDateTime] not received");
                boErrorOccurred = true;
            } else {
                otrOutTransactionResult.output.setTransactionDateTime(nameValueList.get("TransactionDateTime").getValue());
            }
            // order description (same as value passed into payment form - echoed back out by payment form)
            if (!nameValueList.existsInList("ACSURL")) {
                szOutputMessage.output = addStringToStringList(szOutputMessage.output, "Expected variable [ACSURL] not received");
                boErrorOccurred = true;
            } else {
                otrOutTransactionResult.output.setACSURL(nameValueList.get("ACSURL").getValue());
            }
            // address1 (not necessarily the same as value passed into payment form - as the customer can change it on the form)
            if (!nameValueList.existsInList("PaREQ")) {
                szOutputMessage.output = addStringToStringList(szOutputMessage.output, "Expected variable [PaREQ] not received");
                boErrorOccurred = true;
            } else {
                otrOutTransactionResult.output.setPaREQ(nameValueList.get("PaREQ").getValue());
            }

            if (boErrorOccurred) {
                otrOutTransactionResult = null;
            }
        } catch (Exception e) {
            boErrorOccurred = true;
            szOutputMessage.output = e.getMessage();
        }

        return (!boErrorOccurred);
    }

    public static boolean GetTransactionCompleteResultFromPostVariables(NameValueList nameValueList,
            OutTransactionResult otrOutTransactionResult,
            OutString szHashDigest,
            OutString szOutputMessage) {
        boolean boErrorOccurred;


        otrOutTransactionResult.output = new TransactionResult();
        szHashDigest.output = null;
        szOutputMessage.output = null;

        NullableInt nCurrencyCode = new NullableInt();
        NullableInt nCountryCode = new NullableInt();
        NullableInt nPreviousStatusCode = new NullableInt();
        NullableInt nCardIssuerCountryCode = new NullableInt();

        boErrorOccurred = false;

        try {
            // hash digest
            if (nameValueList.existsInList("HashDigest")) {
                szHashDigest.output = nameValueList.get("HashDigest").getValue();
            }

            // transaction status code
            if (!nameValueList.existsInList("StatusCode")) {
                szOutputMessage.output = addStringToStringList(szOutputMessage.output, "Expected variable [StatusCode] not received");
                boErrorOccurred = true;
            } else {
                otrOutTransactionResult.output.setStatusCode(Integer.parseInt(nameValueList.get("StatusCode").getValue()));
            }
            // transaction message
            if (!nameValueList.existsInList("Message")) {
                szOutputMessage.output = addStringToStringList(szOutputMessage.output, "Expected variable [Message] not received");
                boErrorOccurred = true;
            } else {
                otrOutTransactionResult.output.setMessage(nameValueList.get("Message").getValue());
            }
            // status code of original transaction if this transaction was deemed a duplicate
            if (!nameValueList.existsInList("PreviousStatusCode")) {
                szOutputMessage.output = addStringToStringList(szOutputMessage.output, "Expected variable [PreviousStatusCode] not received");
                boErrorOccurred = true;
            } else {
                if (!isStringNullOrEmpty(nameValueList.get("PreviousStatusCode").getValue())) {
                    nPreviousStatusCode.setValue(Integer.parseInt(nameValueList.get("PreviousStatusCode").getValue()));
                    otrOutTransactionResult.output.setPreviousStatusCode(nPreviousStatusCode);
                }
            }
            // status code of original transaction if this transaction was deemed a duplicate
            if (!nameValueList.existsInList("PreviousMessage")) {
                szOutputMessage.output = addStringToStringList(szOutputMessage.output, "Expected variable [PreviousMessage] not received");
                boErrorOccurred = true;
            } else {
                otrOutTransactionResult.output.setPreviousMessage(nameValueList.get("PreviousMessage").getValue());
            }
            // cross reference of transaction
            if (!nameValueList.existsInList("CrossReference")) {
                szOutputMessage.output = addStringToStringList(szOutputMessage.output, "Expected variable [CrossReference] not received");
                boErrorOccurred = true;
            } else {
                otrOutTransactionResult.output.setCrossReference(nameValueList.get("CrossReference").getValue());
            }
            // amount (same as value passed into payment form - echoed back out by payment form)
            if (!nameValueList.existsInList("Amount")) {
                szOutputMessage.output = addStringToStringList(szOutputMessage.output, "Expected variable [Amount] not received");
                boErrorOccurred = true;
            } else {
                otrOutTransactionResult.output.setAmount(Integer.parseInt(nameValueList.get("Amount").getValue()));
            }
            // currency code (same as value passed into payment form - echoed back out by payment form)
            if (!nameValueList.existsInList("CurrencyCode")) {
                szOutputMessage.output = addStringToStringList(szOutputMessage.output, "Expected variable [CurrencyCode] not received");
                boErrorOccurred = true;
            } else {
                if (!isStringNullOrEmpty(nameValueList.get("CurrencyCode").getValue())) {
                    nCurrencyCode.setValue(Integer.parseInt(nameValueList.get("CurrencyCode").getValue()));
                    otrOutTransactionResult.output.setCurrencyCode(nCurrencyCode);
                }
            }
            // order ID (same as value passed into payment form - echoed back out by payment form)
            if (!nameValueList.existsInList("OrderID")) {
                szOutputMessage.output = addStringToStringList(szOutputMessage.output, "Expected variable [OrderID] not received");
                boErrorOccurred = true;
            } else {
                otrOutTransactionResult.output.setOrderID(nameValueList.get("OrderID").getValue());
            }
            // transaction type (same as value passed into payment form - echoed back out by payment form)
            if (!nameValueList.existsInList("TransactionType")) {
                szOutputMessage.output = addStringToStringList(szOutputMessage.output, "Expected variable [TransactionType] not received");
                boErrorOccurred = true;
            } else {
                otrOutTransactionResult.output.setTransactionType(nameValueList.get("TransactionType").getValue());
            }
            // transaction date/time (same as value passed into payment form - echoed back out by payment form)
            if (!nameValueList.existsInList("TransactionDateTime")) {
                szOutputMessage.output = addStringToStringList(szOutputMessage.output, "Expected variable [TransactionDateTime] not received");
                boErrorOccurred = true;
            } else {
                otrOutTransactionResult.output.setTransactionDateTime(nameValueList.get("TransactionDateTime").getValue());
            }
            // order description (same as value passed into payment form - echoed back out by payment form)
            if (!nameValueList.existsInList("OrderDescription")) {
                szOutputMessage.output = addStringToStringList(szOutputMessage.output, "Expected variable [OrderDescription] not received");
                boErrorOccurred = true;
            } else {
                otrOutTransactionResult.output.setOrderDescription(nameValueList.get("OrderDescription").getValue());
            }
            // address1 (not necessarily the same as value passed into payment form - as the customer can change it on the form)
            if (!nameValueList.existsInList("Address1")) {
                szOutputMessage.output = addStringToStringList(szOutputMessage.output, "Expected variable [Address1] not received");
                boErrorOccurred = true;
            } else {
                otrOutTransactionResult.output.setAddress1(nameValueList.get("Address1").getValue());
            }
            // address2 (not necessarily the same as value passed into payment form - as the customer can change it on the form)
            if (!nameValueList.existsInList("Address2")) {
                szOutputMessage.output = addStringToStringList(szOutputMessage.output, "Expected variable [Address2] not received");
                boErrorOccurred = true;
            } else {
                otrOutTransactionResult.output.setAddress2(nameValueList.get("Address2").getValue());
            }
            // address3 (not necessarily the same as value passed into payment form - as the customer can change it on the form)
            if (!nameValueList.existsInList("Address3")) {
                szOutputMessage.output = addStringToStringList(szOutputMessage.output, "Expected variable [Address3] not received");
                boErrorOccurred = true;
            } else {
                otrOutTransactionResult.output.setAddress3(nameValueList.get("Address3").getValue());
            }
            // address4 (not necessarily the same as value passed into payment form - as the customer can change it on the form)
            if (!nameValueList.existsInList("Address4")) {
                szOutputMessage.output = addStringToStringList(szOutputMessage.output, "Expected variable [Address4] not received");
                boErrorOccurred = true;
            } else {
                otrOutTransactionResult.output.setAddress4(nameValueList.get("Address4").getValue());
            }
            // city (not necessarily the same as value passed into payment form - as the customer can change it on the form)
            if (!nameValueList.existsInList("City")) {
                szOutputMessage.output = addStringToStringList(szOutputMessage.output, "Expected variable [City] not received");
                boErrorOccurred = true;
            } else {
                otrOutTransactionResult.output.setCity(nameValueList.get("City").getValue());
            }
            // state (not necessarily the same as value passed into payment form - as the customer can change it on the form)
            if (!nameValueList.existsInList("State")) {
                szOutputMessage.output = addStringToStringList(szOutputMessage.output, "Expected variable [State] not received");
                boErrorOccurred = true;
            } else {
                otrOutTransactionResult.output.setState(nameValueList.get("State").getValue());
            }
            // post code (not necessarily the same as value passed into payment form - as the customer can change it on the form)
            if (!nameValueList.existsInList("PostCode")) {
                szOutputMessage.output = addStringToStringList(szOutputMessage.output, "Expected variable [PostCode] not received");
                boErrorOccurred = true;
            } else {
                otrOutTransactionResult.output.setPostCode(nameValueList.get("PostCode").getValue());
            }
            // country code (not necessarily the same as value passed into payment form - as the customer can change it on the form)
            if (!nameValueList.existsInList("CountryCode")) {
                szOutputMessage.output = addStringToStringList(szOutputMessage.output, "Expected variable [CountryCode] not received");
                boErrorOccurred = true;
            } else {
                if (!isStringNullOrEmpty(nameValueList.get("CountryCode").getValue())) {
                    nCountryCode.setValue(Integer.parseInt(nameValueList.get("CountryCode").getValue()));
                    otrOutTransactionResult.output.setCountryCode(nCountryCode);
                }
            }



            // Address check result - response from bank
            if (!nameValueList.existsInList("AddressNumericCheckResult")) {
                szOutputMessage.output = addStringToStringList(szOutputMessage.output, "Expected variable [AddressNumericCheckResult] not received");
                boErrorOccurred = true;
            } else {
                if (!isStringNullOrEmpty(nameValueList.get("AddressNumericCheckResult").getValue())) {
                    otrOutTransactionResult.output.setAddressNumericCheckResult(nameValueList.get("AddressNumericCheckResult").getValue());
                } else {
                    otrOutTransactionResult.output.setAddressNumericCheckResult("");
                }
            }
            // PostCode check result - response from bank
            if (!nameValueList.existsInList("PostCodeCheckResult")) {
                szOutputMessage.output = addStringToStringList(szOutputMessage.output, "Expected variable [PostCodeCheckResult] not received");
                boErrorOccurred = true;
            } else {
                if (!isStringNullOrEmpty(nameValueList.get("PostCodeCheckResult").getValue())) {
                    otrOutTransactionResult.output.setPostCodeCheckResult(nameValueList.get("PostCodeCheckResult").getValue());
                } else {
                    otrOutTransactionResult.output.setPostCodeCheckResult("");
                }
            }
            // CV2 check result - response from bank
            if (!nameValueList.existsInList("CV2CheckResult")) {
                szOutputMessage.output = addStringToStringList(szOutputMessage.output, "Expected variable [CV2CheckResult] not received");
                boErrorOccurred = true;
            } else {
                if (!isStringNullOrEmpty(nameValueList.get("CV2CheckResult").getValue())) {
                    otrOutTransactionResult.output.setCV2CheckResult(nameValueList.get("CV2CheckResult").getValue());
                } else {
                    otrOutTransactionResult.output.setCV2CheckResult("");
                }
            }
            // 3D Secure Authentication check result - response from bank
            if (!nameValueList.existsInList("ThreeDSecureAuthenticationCheckResult")) {
                szOutputMessage.output = addStringToStringList(szOutputMessage.output, "Expected variable [ThreeDSecureAuthenticationCheckResult] not received");
                boErrorOccurred = true;
            } else {
                if (!isStringNullOrEmpty(nameValueList.get("ThreeDSecureAuthenticationCheckResult").getValue())) {
                    otrOutTransactionResult.output.setThreeDSecureAuthenticationCheckResult(
                            nameValueList.get("ThreeDSecureAuthenticationCheckResult").getValue());
                } else {
                    otrOutTransactionResult.output.setThreeDSecureAuthenticationCheckResult("");
                }
            }
            // Card Type - response from bank
            if (!nameValueList.existsInList("CardType")) {
                szOutputMessage.output = addStringToStringList(szOutputMessage.output, "Expected variable [CardType] not received");
                boErrorOccurred = true;
            } else {
                if (!isStringNullOrEmpty(nameValueList.get("CardType").getValue())) {
                    otrOutTransactionResult.output.setCardType(nameValueList.get("CardType").getValue());
                } else {
                    otrOutTransactionResult.output.setCardType("");
                }
            }
            // Card Class - response from bank
            if (!nameValueList.existsInList("CardClass")) {
                szOutputMessage.output = addStringToStringList(szOutputMessage.output, "Expected variable [CardClass] not received");
                boErrorOccurred = true;
            } else {
                if (!isStringNullOrEmpty(nameValueList.get("CardClass").getValue())) {
                    otrOutTransactionResult.output.setCardClass(nameValueList.get("CardClass").getValue());
                } else {
                    otrOutTransactionResult.output.setCardClass("");
                }
            }
            // Card Issuer - response from bank
            if (!nameValueList.existsInList("CardIssuer")) {
                szOutputMessage.output = addStringToStringList(szOutputMessage.output, "Expected variable [CardIssuer] not received");
                boErrorOccurred = true;
            } else {
                if (!isStringNullOrEmpty(nameValueList.get("CardIssuer").getValue())) {
                    otrOutTransactionResult.output.setCardIssuer(nameValueList.get("CardIssuer").getValue());
                } else {
                    otrOutTransactionResult.output.setCardIssuer("");
                }
            }
            // Card Issuer Country Code - response from bank
            if (!nameValueList.existsInList("CardIssuerCountryCode")) {
                szOutputMessage.output = addStringToStringList(szOutputMessage.output, "Expected variable [CardIssuerCountryCode] not received");
                boErrorOccurred = true;
            } else {
                if (!isStringNullOrEmpty(nameValueList.get("CardIssuerCountryCode").getValue())) {
                    nCardIssuerCountryCode.setValue(Integer.parseInt(nameValueList.get("CardIssuerCountryCode").getValue()));
                    otrOutTransactionResult.output.setCardIssuerCountryCode(nCardIssuerCountryCode);
                }
            }
            // Email Address (not necessarily the same as value passed into payment form - as the customer can change it on the form)
            if (!nameValueList.existsInList("EmailAddress")) {
                szOutputMessage.output = addStringToStringList(szOutputMessage.output, "Expected variable [EmailAddress] not received");
                boErrorOccurred = true;
            } else {
                if (!isStringNullOrEmpty(nameValueList.get("EmailAddress").getValue())) {
                    otrOutTransactionResult.output.setEmailAddress(nameValueList.get("EmailAddress").getValue());
                } else {
                    otrOutTransactionResult.output.setEmailAddress("");
                }
            }
            // Phone Number (not necessarily the same as value passed into payment form - as the customer can change it on the form)
            if (!nameValueList.existsInList("PhoneNumber")) {
                szOutputMessage.output = addStringToStringList(szOutputMessage.output, "Expected variable [PhoneNumber] not received");
                boErrorOccurred = true;
            } else {
                if (!isStringNullOrEmpty(nameValueList.get("PhoneNumber").getValue())) {
                    otrOutTransactionResult.output.setPhoneNumber(nameValueList.get("PhoneNumber").getValue());
                } else {
                    otrOutTransactionResult.output.setPhoneNumber("");
                }
            }

            if (boErrorOccurred) {
                otrOutTransactionResult = null;
            }
        } catch (Exception e) {
            boErrorOccurred = true;
            szOutputMessage.output = e.getMessage();
        }

        return (!boErrorOccurred);
    }

    public static String addStringToStringList(String existingStringList, String stringToAdd) {
        String commaString;
        StringBuffer returnString;

        returnString = new StringBuffer();
        commaString = "";

        if (isStringNullOrEmpty(stringToAdd)) {
            returnString.append(existingStringList);
        } else {
            if (!isStringNullOrEmpty(existingStringList)) {
                commaString = ", ";
            }
            returnString.append(existingStringList);
            returnString.append(commaString);
            returnString.append(stringToAdd);
        }

        return (returnString.toString());
    }

    public static boolean isStringNullOrEmpty(String String) {
        boolean returnValue = false;

        if (String == null || String.equals("") || String.equals("null")) {
            returnValue = true;
        }
        return (returnValue);
    }

    public static String byteArrayToHexString(byte[] bytes) {
        StringBuffer returnString;
        int count;

        returnString = new StringBuffer();

        for (count = 0; count < bytes.length; count++) {
            returnString.append(Integer.toString((bytes[count] & 0xff) + 0x100, 16).substring(1));
        }
        return returnString.toString();
    }

    public static String calculateHashDigest(String inputString, String preSharedKey, String hashMethod) {
        byte[] hashDigest;
        byte[] psk;
        Key key;
        Mac mac;
        MessageDigest messageDigest;
        String returnString;

        try {
            if (isStringNullOrEmpty(hashMethod)) {
                throw new Exception("Invalid hash method");
            }

            if (hashMethod.equals("MD5")
                    || hashMethod.equals("SHA1")) {
                if (hashMethod.equals("MD5")) {
                    messageDigest = MessageDigest.getInstance("MD5");
                } else {
                    messageDigest = MessageDigest.getInstance("SHA-1");
                }

                hashDigest = messageDigest.digest(inputString.getBytes("UTF-8"));
            } else {
                if (hashMethod.equals("HMACMD5")
                        || hashMethod.equals("HMACSHA1")) {
                    psk = preSharedKey.getBytes("UTF-8");

                    if (hashMethod.equals("HMACMD5")) {
                        key = new SecretKeySpec(psk, 0, psk.length, "HmacMD5");
                        mac = Mac.getInstance("HmacMD5");
                    } else {
                        key = new SecretKeySpec(psk, 0, psk.length, "HmacSHA1");
                        mac = Mac.getInstance("HmacSHA1");
                    }
                    mac.init(key);
                    hashDigest = mac.doFinal(inputString.getBytes("UTF-8"));
                } else {
                    throw new Exception("Unsupported hash method: " + hashMethod);
                }
            }

            returnString = byteArrayToHexString(hashDigest);
        } catch (Exception e) {
            returnString = e.getMessage();
        }

        return (returnString);
    }

    public static String generateStringToHash(  String amount,
                                                String currencyCode,
                                                String orderID,
                                                String transactionType,
                                                String transactionDateTime,
                                                String callbackURL,
                                                String orderDescription,
                                                String customerName,
                                                String address1,
                                                String address2,
                                                String address3,
                                                String address4,
                                                String city,
                                                String state,
                                                String postCode,
                                                String countryCode,
                                                String secretKey) {
        StringBuffer returnString;

        returnString = new StringBuffer();

        returnString.append("&Amount=");
        returnString.append(amount);
        returnString.append("&CurrencyCode=");
        returnString.append(currencyCode);
        returnString.append("&OrderID=");
        returnString.append(orderID);
        returnString.append("&TransactionType=");
        returnString.append(transactionType);
        returnString.append("&TransactionDateTime=");
        returnString.append(transactionDateTime);
        returnString.append("&CallbackURL=");
        returnString.append(callbackURL);
        returnString.append("&OrderDescription=");
        returnString.append(orderDescription);
        returnString.append("&CustomerName=");
        returnString.append(customerName);
        returnString.append("&Address1=");
        returnString.append(address1);
        returnString.append("&Address2=");
        returnString.append(address2);
        returnString.append("&Address3=");
        returnString.append(address3);
        returnString.append("&Address4=");
        returnString.append(address4);
        returnString.append("&City=");
        returnString.append(city);
        returnString.append("&State=");
        returnString.append(state);
        returnString.append("&PostCode=");
        returnString.append(postCode);
        returnString.append("&CountryCode=");
        returnString.append(countryCode);
        returnString.append("&SecretKey=");
        returnString.append(secretKey);

        return (returnString.toString());
    }
    // This is a "hook" function that is run when the results of the transaction are known.
    // You should put your code that does any post transaction tasks
    // (e.g. updates the order object, sends the customer an email etc) in this function
    public static boolean  reportTransactionResults(TransactionResult transactionResult,
                                                    OutString outputMessage)
    {
        boolean errorOccurred;

        errorOccurred = false;
        outputMessage.output = "Environment specific function reportTransactionResults() needs to be implemented by merchant developer";

        try
        {
            switch (transactionResult.getStatusCode())
            {
                // transaction authorised
                case 0:
                    break;
                // card referred (treat as decline)
                case 4:
                    break;
                // transaction declined
                case 5:
                    break;
                // duplicate transaction
                case 20:
                    // need to look at the previous status code to see if the
                    // transaction was successful
                    if (transactionResult.getPreviousStatusCode().getValue() == 0)
                    {
                        // transaction authorised
                    }
                    else
                    {
                        // transaction not authorised
                    }
                    break;
                // error occurred
                case 30:
                    break;
                default:
                    break;
            }

            // put code to update/store the order with the transaction result
        }
        catch (Exception e)
        {
            errorOccurred = true;
            outputMessage.output = e.getMessage();
        }
        return (!errorOccurred);
    }
}