<%@ page import="java.text.SimpleDateFormat" %>
<%@ page import="java.util.Date" %>

<jsp:useBean id="global" class="net.mycompanyname.Global" scope="application" />
<jsp:useBean id="paymentFormHelper" class="net.mycompanyname.PaymentFormHelper" scope="page" />
<%
    int width;
    String bodyAttributes;
    String formAttributes;
    String formAction;
    String amount;
    String currencyCode;
    String orderID;
    String transactionType;
    String transactionDateTime;
    SimpleDateFormat dateFormat;
    String orderDescription;
    String callbackURL;
    String customerName;
    String address1;
    String address2;
    String address3;
    String address4;
    String city;
    String state;
    String postCode;
    String countryCode;
    String stringToHash;
    String hashDigest;

    width = 800;
    bodyAttributes = "";
    formAttributes = "";
    formAction = "PaymentForm.jsp";
%>
<%@ include file="Templates/FormHeader.tpl" %>
<%
    // the amount in *minor* currency (i.e. 10.00 passed as "1000")
    amount = Integer.toString(1000);
    // the currency - ISO 4217 3-digit numeric (e.g. GBP = 826)
    currencyCode = Integer.toString(826);
    // order ID
    orderID = "Order-1234";
    // the transaction type - can be SALE or PREAUTH
    transactionType = "SALE";
    // the GMT/UTC relative date/time for the transaction (MUST either be in GMT/UTC
    // or MUST include the correct timezone offset)
    dateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss Z");
    transactionDateTime = dateFormat.format(new Date());
    // the callback URL
    callbackURL = paymentFormHelper.getSiteSecureBaseURL(request) + "PaymentForm.jsp";
    // order description
    orderDescription = "A Test Order";
    // these variables allow the payment form to be "seeded" with initial values
    customerName = "A Customer";
    address1 = "14 Some Address";
    address2 = "";
    address3 = "";
    address4 = "";
    city = "Some City";
    state = "Some State";
    postCode = "PO57 0DE";
    // the country code - ISO 3166-1  3-digit numeric (e.g. UK = 826)
    countryCode = Integer.toString(826);

    // get the string to be hashed
    stringToHash = paymentFormHelper.generateStringToHash(amount,
                                                          currencyCode,
                                                          orderID,
                                                          transactionType,
                                                          transactionDateTime,
                                                          callbackURL,
                                                          orderDescription,
                                                          customerName,
                                                          address1,
                                                          address2,
                                                          address3,
                                                          address4,
                                                          city,
                                                          state,
                                                          postCode,
                                                          countryCode,
                                                          global.getSecretKey());

    hashDigest = paymentFormHelper.calculateHashDigest( stringToHash,
                                                        global.getSecretKey(),
                                                        global.getHashMethod());
%>
<%@ include file="Templates/StartHereForm.tpl" %>
<%@ include file="Templates/FormFooter.tpl" %>