using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

namespace MyCompanyName
{
    public partial class StartHere : System.Web.UI.Page
    {
        protected string m_szFormAction;
        protected string m_szHashDigest;
        protected string m_szMerchantID;
        protected string m_szAmount;
        protected string m_szCurrencyCode;
        protected string m_szOrderID;
        protected string m_szTransactionType;
        protected string m_szTransactionDateTime;
        protected string m_szCallbackURL;
        protected string m_szOrderDescription;
        protected string m_szCustomerName;
        protected string m_szAddress1;
        protected string m_szAddress2;
        protected string m_szAddress3;
        protected string m_szAddress4;
        protected string m_szCity;
        protected string m_szState;
        protected string m_szPostCode;
        protected string m_szCountryCode;

        protected void Page_Load(object sender, EventArgs e)
        {
            string szStringToHash;

            m_szFormAction = PaymentFormHelper.GetSiteSecureBaseURL(Request) + "PaymentForm.aspx";

            m_szMerchantID = Global.MerchantID;

            // the amount in *minor* currency (i.e. 10.00 passed as "1000")
            m_szAmount = Convert.ToString(1000);
            // the currency	- ISO 4217 3-digit numeric (e.g. GBP = 826)
            m_szCurrencyCode = Convert.ToString(826);
            // order ID
            m_szOrderID = "Order-1234";
            // order description
            m_szOrderDescription = "A Test Order";
            // the transaction type - can be SALE or PREAUTH
            m_szTransactionType = "SALE";
            // the GMT/UTC relative date/time for the transaction (MUST either be in GMT/UTC 
            // or MUST include the correct timezone offset)
            m_szTransactionDateTime = DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss zzz");

            m_szCallbackURL = PaymentFormHelper.GetSiteSecureBaseURL(Request) + "PaymentForm.aspx";

            // these variables allow the payment form to be "seeded" with initial values
            m_szCustomerName = "A Customer";
            m_szAddress1 = "14 Some Address";
            m_szAddress2 = "";
            m_szAddress3 = "";
            m_szAddress4 = "";
            m_szCity = "Some City";
            m_szState = "Some State";
            m_szPostCode = "PO57 0DE";

            // the country code - ISO 3166-1  3-digit numeric (e.g. UK = 826)
            // PLEASE NOTE: Currently, do not change this from the value of 826.
            m_szCountryCode = Convert.ToString(826);

            // get the string to be hashed
            szStringToHash = PaymentFormHelper.GenerateStringToHash(m_szAmount,
                                                                   m_szCurrencyCode,
                                                                   m_szOrderID,
                                                                   m_szTransactionType,
                                                                   m_szTransactionDateTime,
                                                                   m_szCallbackURL,
                                                                   m_szOrderDescription,
                                                                   m_szCustomerName,
                                                                   m_szAddress1,
                                                                   m_szAddress2,
                                                                   m_szAddress3,
                                                                   m_szAddress4,
                                                                   m_szCity,
                                                                   m_szState,
                                                                   m_szPostCode,
                                                                   m_szCountryCode,
                                                                   Global.SecretKey);

            // pass this string into the hash function to create the hash digest
            m_szHashDigest = PaymentFormHelper.CalculateHashDigest(szStringToHash,
                                                                   Global.SecretKey,
                                                                   Global.HashMethod);

            lbAmount.Text = m_szAmount;
            lbCurrency.Text = m_szCurrencyCode;
            lbOrderID.Text = m_szOrderID;
            lbOrderDescription.Text = m_szOrderDescription;

        }
    }
}
