using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

namespace MyCompanyName
{
    public partial class ThreeDSecureLandingPage : System.Web.UI.Page
    {
        protected internal string m_szFormAction;

        protected internal string m_szHashDigest;
        protected internal string m_szMerchantID;
        protected internal string m_szCrossReference;
        protected internal string m_szTransactionDateTime;
        protected internal string m_szCallbackURL;
        protected internal string m_szPaRES;

        protected void Page_Load(object sender, EventArgs e)
        {
            string szStringToHash;

            if (Request.Form["MD"] != null &&
                Request.Form["PaRes"] != null)
            {
                m_szFormAction = "https://mms." + Global.PaymentProcessorDomain + "/Pages/PublicPages/TransparentRedirect.aspx";

                m_szMerchantID = Global.MerchantID;
                m_szPaRES = MyCompanyName.PaymentFormHelper.StripAllWhitespace(Request.Form["PaRes"]);
                m_szCrossReference = Request.Form["MD"];
                m_szTransactionDateTime = DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss zzz");
                m_szCallbackURL = MyCompanyName.PaymentFormHelper.GetSiteSecureBaseURL(Request) + "PaymentForm.aspx";

                szStringToHash = MyCompanyName.PaymentFormHelper.GenerateStringToHash3DSecurePostAuthentication(Global.MerchantID, Global.Password, m_szCrossReference, m_szTransactionDateTime, m_szCallbackURL, m_szPaRES, MyCompanyName.Global.PreSharedKey, MyCompanyName.Global.HashMethod);

                m_szHashDigest = MyCompanyName.PaymentFormHelper.CalculateHashDigest(szStringToHash, Global.PreSharedKey, Global.HashMethod);

                BodyTag.Attributes.Add("onload", "document.Form.submit();");
            }
            else
            {
                pnMessagePanel.Visible = true;
                lbMessageLabel.Text = "There were errors collecting the responses back from the ACS";
            }
        }
    }
}
