Imports System.Data
Imports System.Configuration
Imports System.Collections.Specialized
Imports System.Web
Imports System.Web.Security
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports System.Web.UI.WebControls.WebParts
Imports System.Web.UI.HtmlControls
Imports System.Security.Cryptography
Imports System.Text
Imports System.Net
Imports System.IO

''' <summary>
''' Summary description for PaymentFormHelper
''' </summary>
Namespace MyCompanyName
	Public Enum HASH_METHOD
		UNKNOWN
		MD5
		SHA1
		HMACMD5
		HMACSHA1
	End Enum

	Public Class TransactionResult
		Private m_nStatusCode As Integer
		Private m_szMessage As String
		Private m_nPreviousStatusCode As System.Nullable(Of Integer)
		Private m_szPreviousMessage As String
		Private m_szCrossReference As String
		Private m_nAmount As UInt64
		Private m_nCurrencyCode As Integer
		Private m_szOrderID As String
		Private m_szTransactionType As String
		Private m_szTransactionDateTime As String
		Private m_szOrderDescription As String
		Private m_szCustomerName As String
		Private m_szAddress1 As String
		Private m_szAddress2 As String
		Private m_szAddress3 As String
		Private m_szAddress4 As String
		Private m_szCity As String
		Private m_szState As String
		Private m_szPostCode As String
		Private m_nCountryCode As System.Nullable(Of Integer)

		Private m_szAddressNumericCheckResult As String
		Private m_szPostCodeCheckResult As String
		Private m_szCV2CheckResult As String
		Private m_szThreeDSecureAuthenticationCheckResult As String
		Private m_szCardType As String
		Private m_szCardClass As String
		Private m_szCardIssuer As String
		Private m_nCardIssuerCountryCode As System.Nullable(Of Integer)
		Private m_szEmailAddress As String
		Private m_szPhoneNumber As String

		Private m_szACSUrl As String
		Private m_szPaREQ As String
		Private m_szPaRES As String
		Private m_szCallbackUrl As String

		Public Property StatusCode() As Integer
			Get
				Return (m_nStatusCode)
			End Get
			Set
				m_nStatusCode = value
			End Set
		End Property
		Public Property Message() As String
			Get
				Return (m_szMessage)
			End Get
			Set
				m_szMessage = value
			End Set
		End Property
		Public Property PreviousStatusCode() As System.Nullable(Of Integer)
			Get
				Return (m_nPreviousStatusCode)
			End Get
			Set
				m_nPreviousStatusCode = value
			End Set
		End Property
		Public Property PreviousMessage() As String
			Get
				Return (m_szPreviousMessage)
			End Get
			Set
				m_szPreviousMessage = value
			End Set
		End Property
		Public Property CrossReference() As String
			Get
				Return (m_szCrossReference)
			End Get
			Set
				m_szCrossReference = value
			End Set
		End Property
		Public Property Amount() As UInt64
			Get
				Return (m_nAmount)
			End Get
			Set
				m_nAmount = value
			End Set
		End Property
		Public Property CurrencyCode() As Integer
			Get
				Return (m_nCurrencyCode)
			End Get
			Set
				m_nCurrencyCode = value
			End Set
		End Property
		Public Property OrderID() As String
			Get
				Return (m_szOrderID)
			End Get
			Set
				m_szOrderID = value
			End Set
		End Property
		Public Property TransactionType() As String
			Get
				Return (m_szTransactionType)
			End Get
			Set
				m_szTransactionType = value
			End Set
		End Property
		Public Property TransactionDateTime() As String
			Get
				Return (m_szTransactionDateTime)
			End Get
			Set
				m_szTransactionDateTime = value
			End Set
		End Property
		Public Property OrderDescription() As String
			Get
				Return (m_szOrderDescription)
			End Get
			Set
				m_szOrderDescription = value
			End Set
		End Property
		Public Property CustomerName() As String
			Get
				Return (m_szCustomerName)
			End Get
			Set
				m_szCustomerName = value
			End Set
		End Property
		Public Property Address1() As String
			Get
				Return (m_szAddress1)
			End Get
			Set
				m_szAddress1 = value
			End Set
		End Property
		Public Property Address2() As String
			Get
				Return (m_szAddress2)
			End Get
			Set
				m_szAddress2 = value
			End Set
		End Property
		Public Property Address3() As String
			Get
				Return (m_szAddress3)
			End Get
			Set
				m_szAddress3 = value
			End Set
		End Property
		Public Property Address4() As String
			Get
				Return (m_szAddress4)
			End Get
			Set
				m_szAddress4 = value
			End Set
		End Property
		Public Property City() As String
			Get
				Return (m_szCity)
			End Get
			Set
				m_szCity = value
			End Set
		End Property
		Public Property State() As String
			Get
				Return (m_szState)
			End Get
			Set
				m_szState = value
			End Set
		End Property
		Public Property PostCode() As String
			Get
				Return (m_szPostCode)
			End Get
			Set
				m_szPostCode = value
			End Set
		End Property
		Public Property CountryCode() As System.Nullable(Of Integer)
			Get
				Return (m_nCountryCode)
			End Get
			Set
				m_nCountryCode = value
			End Set
		End Property


		Public Property AddressNumericCheckResult() As String
			Get
				Return (m_szAddressNumericCheckResult)
			End Get
			Set
				m_szAddressNumericCheckResult = value
			End Set
		End Property
		Public Property PostCodeCheckResult() As String
			Get
				Return (m_szPostCodeCheckResult)
			End Get
			Set
				m_szPostCodeCheckResult = value
			End Set
		End Property
		Public Property CV2CheckResult() As String
			Get
				Return (m_szCV2CheckResult)
			End Get
			Set
				m_szCV2CheckResult = value
			End Set
		End Property
		Public Property ThreeDSecureAuthenticationCheckResult() As String
			Get
				Return (m_szThreeDSecureAuthenticationCheckResult)
			End Get
			Set
				m_szThreeDSecureAuthenticationCheckResult = value
			End Set
		End Property
		Public Property CardType() As String
			Get
				Return (m_szCardType)
			End Get
			Set
				m_szCardType = value
			End Set
		End Property
		Public Property CardClass() As String
			Get
				Return (m_szCardClass)
			End Get
			Set
				m_szCardClass = value
			End Set
		End Property
		Public Property CardIssuer() As String
			Get
				Return (m_szCardIssuer)
			End Get
			Set
				m_szCardIssuer = value
			End Set
		End Property
		Public Property CardIssuerCountryCode() As System.Nullable(Of Integer)
			Get
				Return (m_nCardIssuerCountryCode)
			End Get
			Set
				m_nCardIssuerCountryCode = value
			End Set
		End Property
		Public Property EmailAddress() As String
			Get
				Return (m_szEmailAddress)
			End Get
			Set
				m_szEmailAddress = value
			End Set
		End Property
		Public Property PhoneNumber() As String
			Get
				Return (m_szPhoneNumber)
			End Get
			Set
				m_szPhoneNumber = value
			End Set
		End Property

		Public Property ACSUrl() As String
			Get
				Return (m_szACSUrl)
			End Get
			Set
				m_szACSUrl = value
			End Set
		End Property
		Public Property PaREQ() As String
			Get
				Return (m_szPaREQ)
			End Get
			Set
				m_szPaREQ = value
			End Set
		End Property
		Public Property PaRES() As String
			Get
				Return (m_szPaRES)
			End Get
			Set
				m_szPaRES = value
			End Set
		End Property
		Public Property CallbackUrl() As String
			Get
				Return (m_szCallbackUrl)
			End Get
			Set
				m_szCallbackUrl = value
			End Set
		End Property
	End Class

	Public Class PaymentFormHelper
		Public Shared Function GetHashMethod(hmHashMethod As HASH_METHOD) As String
			Return (hmHashMethod.ToString())
		End Function
		Public Shared Function GetHashMethod(szHashMethod As String) As HASH_METHOD
			Dim hmHashMethod As HASH_METHOD = HASH_METHOD.UNKNOWN

			If [String].IsNullOrEmpty(szHashMethod) Then
				Throw New Exception("Hash method must not be null or empty")
			End If
			If szHashMethod.ToUpper() = "MD5" Then
				hmHashMethod = HASH_METHOD.MD5
				GoTo Finished
			End If
			If szHashMethod.ToUpper() = "SHA1" Then
				hmHashMethod = HASH_METHOD.SHA1
				GoTo Finished
			End If
			If szHashMethod.ToUpper() = "HMACMD5" Then
				hmHashMethod = HASH_METHOD.HMACMD5
				GoTo Finished
			End If
			If szHashMethod.ToUpper() = "HMACSHA1" Then
				hmHashMethod = HASH_METHOD.HMACSHA1
				GoTo Finished
			End If
			Finished:
			

			If hmHashMethod = HASH_METHOD.UNKNOWN Then
				Throw New Exception("Invalid hash method: " & szHashMethod)
			End If

			Return (hmHashMethod)
		End Function

		Public Shared Function GetSiteSecureBaseURL(hrHTTPRequest As HttpRequest) As String
			Dim szReturnString As String = Nothing
			Dim nIndex As Integer

			szReturnString = hrHTTPRequest.Url.AbsoluteUri

			nIndex = szReturnString.LastIndexOf("/"C)

			szReturnString = szReturnString.Substring(0, nIndex + 1)

			Return (szReturnString)
		End Function



		Public Shared Function getTransactionCompleteResultFromPostVariables(nvcFormVariables As NameValueCollection, ByRef trTransactionResult As TransactionResult, ByRef szHashDigest As String, ByRef szOutputMessage As String) As Boolean
			Dim boErrorOccurred As Boolean


			trTransactionResult = Nothing
			szHashDigest = ""
			szOutputMessage = ""
			boErrorOccurred = False

			Try
				trTransactionResult = New TransactionResult()

				' hash digest
				If nvcFormVariables("HashDigest") IsNot Nothing Then
					szHashDigest = nvcFormVariables("HashDigest")
				End If

				' transaction status code
				If nvcFormVariables("StatusCode") Is Nothing Then
					szOutputMessage = AddStringToStringList(szOutputMessage, "Expected variable [StatusCode] not received")
					boErrorOccurred = True
				Else
					trTransactionResult.StatusCode = Convert.ToInt32(nvcFormVariables("StatusCode"))
				End If
				' transaction message
				If nvcFormVariables("Message") Is Nothing Then
					szOutputMessage = AddStringToStringList(szOutputMessage, "Expected variable [Message] not received")
					boErrorOccurred = True
				Else
					trTransactionResult.Message = nvcFormVariables("Message")
				End If
				' status code of original transaction if this transaction was deemed a duplicate
				If nvcFormVariables("PreviousStatusCode") Is Nothing Then
					szOutputMessage = AddStringToStringList(szOutputMessage, "Expected variable [PreviousStatusCode] not received")
					boErrorOccurred = True
				Else
					If nvcFormVariables("PreviousStatusCode") = "" Then
						trTransactionResult.PreviousStatusCode = Nothing
					Else
						trTransactionResult.PreviousStatusCode = Convert.ToInt32(nvcFormVariables("PreviousStatusCode"))
					End If
				End If
				' status code of original transaction if this transaction was deemed a duplicate
				If nvcFormVariables("PreviousMessage") Is Nothing Then
					szOutputMessage = AddStringToStringList(szOutputMessage, "Expected variable [PreviousMessage] not received")
					boErrorOccurred = True
				Else
					trTransactionResult.PreviousMessage = nvcFormVariables("PreviousMessage")
				End If
				' cross reference of transaction
				If nvcFormVariables("CrossReference") Is Nothing Then
					szOutputMessage = AddStringToStringList(szOutputMessage, "Expected variable [CrossReference] not received")
					boErrorOccurred = True
				Else
					trTransactionResult.CrossReference = nvcFormVariables("CrossReference")
				End If
				' amount (same as value passed into payment form - echoed back out by payment form)
				If nvcFormVariables("Amount") Is Nothing Then
					szOutputMessage = AddStringToStringList(szOutputMessage, "Expected variable [Amount] not received")
					boErrorOccurred = True
				Else
					trTransactionResult.Amount = Convert.ToUInt64(nvcFormVariables("Amount"))
				End If
				' currency code (same as value passed into payment form - echoed back out by payment form)
				If nvcFormVariables("CurrencyCode") Is Nothing Then
					szOutputMessage = AddStringToStringList(szOutputMessage, "Expected variable [CurrencyCode] not received")
					boErrorOccurred = True
				Else
					trTransactionResult.CurrencyCode = Convert.ToInt32(nvcFormVariables("CurrencyCode"))
				End If
				' order ID (same as value passed into payment form - echoed back out by payment form)
				If nvcFormVariables("OrderID") Is Nothing Then
					szOutputMessage = AddStringToStringList(szOutputMessage, "Expected variable [OrderID] not received")
					boErrorOccurred = True
				Else
					trTransactionResult.OrderID = nvcFormVariables("OrderID")
				End If
				' transaction type (same as value passed into payment form - echoed back out by payment form)
				If nvcFormVariables("TransactionType") Is Nothing Then
					szOutputMessage = AddStringToStringList(szOutputMessage, "Expected variable [TransactionType] not received")
					boErrorOccurred = True
				Else
					trTransactionResult.TransactionType = nvcFormVariables("TransactionType")
				End If
				' transaction date/time (same as value passed into payment form - echoed back out by payment form)
				If nvcFormVariables("TransactionDateTime") Is Nothing Then
					szOutputMessage = AddStringToStringList(szOutputMessage, "Expected variable [TransactionDateTime] not received")
					boErrorOccurred = True
				Else
					trTransactionResult.TransactionDateTime = nvcFormVariables("TransactionDateTime")
				End If
				' order description (same as value passed into payment form - echoed back out by payment form)
				If nvcFormVariables("OrderDescription") Is Nothing Then
					szOutputMessage = AddStringToStringList(szOutputMessage, "Expected variable [OrderDescription] not received")
					boErrorOccurred = True
				Else
					trTransactionResult.OrderDescription = nvcFormVariables("OrderDescription")
				End If
				' address1 (not necessarily the same as value passed into payment form - as the customer can change it on the form)
				If nvcFormVariables("Address1") Is Nothing Then
					szOutputMessage = AddStringToStringList(szOutputMessage, "Expected variable [Address1] not received")
					boErrorOccurred = True
				Else
					trTransactionResult.Address1 = nvcFormVariables("Address1")
				End If
				' address2 (not necessarily the same as value passed into payment form - as the customer can change it on the form)
				If nvcFormVariables("Address2") Is Nothing Then
					szOutputMessage = AddStringToStringList(szOutputMessage, "Expected variable [Address2] not received")
					boErrorOccurred = True
				Else
					trTransactionResult.Address2 = nvcFormVariables("Address2")
				End If
				' address3 (not necessarily the same as value passed into payment form - as the customer can change it on the form)
				If nvcFormVariables("Address3") Is Nothing Then
					szOutputMessage = AddStringToStringList(szOutputMessage, "Expected variable [Address3] not received")
					boErrorOccurred = True
				Else
					trTransactionResult.Address3 = nvcFormVariables("Address3")
				End If
				' address4 (not necessarily the same as value passed into payment form - as the customer can change it on the form)
				If nvcFormVariables("Address4") Is Nothing Then
					szOutputMessage = AddStringToStringList(szOutputMessage, "Expected variable [Address4] not received")
					boErrorOccurred = True
				Else
					trTransactionResult.Address4 = nvcFormVariables("Address4")
				End If
				' city (not necessarily the same as value passed into payment form - as the customer can change it on the form)
				If nvcFormVariables("City") Is Nothing Then
					szOutputMessage = AddStringToStringList(szOutputMessage, "Expected variable [City] not received")
					boErrorOccurred = True
				Else
					trTransactionResult.City = nvcFormVariables("City")
				End If
				' state (not necessarily the same as value passed into payment form - as the customer can change it on the form)
				If nvcFormVariables("State") Is Nothing Then
					szOutputMessage = AddStringToStringList(szOutputMessage, "Expected variable [State] not received")
					boErrorOccurred = True
				Else
					trTransactionResult.State = nvcFormVariables("State")
				End If
				' post code (not necessarily the same as value passed into payment form - as the customer can change it on the form)
				If nvcFormVariables("PostCode") Is Nothing Then
					szOutputMessage = AddStringToStringList(szOutputMessage, "Expected variable [PostCode] not received")
					boErrorOccurred = True
				Else
					trTransactionResult.PostCode = nvcFormVariables("PostCode")
				End If
				' country code (not necessarily the same as value passed into payment form - as the customer can change it on the form)
				If nvcFormVariables("CountryCode") Is Nothing Then
					szOutputMessage = AddStringToStringList(szOutputMessage, "Expected variable [CountryCode] not received")
					boErrorOccurred = True
				Else
					If nvcFormVariables("CountryCode") = "" Then
						trTransactionResult.CountryCode = Nothing
					Else
						trTransactionResult.CountryCode = Convert.ToInt32(nvcFormVariables("CountryCode"))
					End If
				End If



				' Address check result - response from bank
				If nvcFormVariables("AddressNumericCheckResult") Is Nothing Then
					szOutputMessage = AddStringToStringList(szOutputMessage, "Expected variable [AddressNumericCheckResult] not received")
					boErrorOccurred = True
				Else
					If nvcFormVariables("AddressNumericCheckResult") = "" Then
						trTransactionResult.AddressNumericCheckResult = Nothing
					Else
						trTransactionResult.AddressNumericCheckResult = nvcFormVariables("AddressNumericCheckResult")
					End If
				End If
				' PostCode check result - response from bank
				If nvcFormVariables("PostCodeCheckResult") Is Nothing Then
					szOutputMessage = AddStringToStringList(szOutputMessage, "Expected variable [PostCodeCheckResult] not received")
					boErrorOccurred = True
				Else
					If nvcFormVariables("PostCodeCheckResult") = "" Then
						trTransactionResult.PostCodeCheckResult = Nothing
					Else
						trTransactionResult.PostCodeCheckResult = nvcFormVariables("PostCodeCheckResult")
					End If
				End If
				' CV2 check result - response from bank
				If nvcFormVariables("CV2CheckResult") Is Nothing Then
					szOutputMessage = AddStringToStringList(szOutputMessage, "Expected variable [CV2CheckResult] not received")
					boErrorOccurred = True
				Else
					If nvcFormVariables("CV2CheckResult") = "" Then
						trTransactionResult.CV2CheckResult = Nothing
					Else
						trTransactionResult.CV2CheckResult = nvcFormVariables("CV2CheckResult")
					End If
				End If
				' 3D Secure Authentication check result - response from bank
				If nvcFormVariables("ThreeDSecureAuthenticationCheckResult") Is Nothing Then
					szOutputMessage = AddStringToStringList(szOutputMessage, "Expected variable [ThreeDSecureAuthenticationCheckResult] not received")
					boErrorOccurred = True
				Else
					If nvcFormVariables("ThreeDSecureAuthenticationCheckResult") = "" Then
						trTransactionResult.ThreeDSecureAuthenticationCheckResult = Nothing
					Else
						trTransactionResult.ThreeDSecureAuthenticationCheckResult = nvcFormVariables("ThreeDSecureAuthenticationCheckResult")
					End If
				End If
				' Card Type - response from bank
				If nvcFormVariables("CardType") Is Nothing Then
					szOutputMessage = AddStringToStringList(szOutputMessage, "Expected variable [CardType] not received")
					boErrorOccurred = True
				Else
					If nvcFormVariables("CardType") = "" Then
						trTransactionResult.CardType = Nothing
					Else
						trTransactionResult.CardType = nvcFormVariables("CardType")
					End If
				End If
				' Card Class - response from bank
				If nvcFormVariables("CardClass") Is Nothing Then
					szOutputMessage = AddStringToStringList(szOutputMessage, "Expected variable [CardClass] not received")
					boErrorOccurred = True
				Else
					If nvcFormVariables("CardClass") = "" Then
						trTransactionResult.CardClass = Nothing
					Else
						trTransactionResult.CardClass = nvcFormVariables("CardClass")
					End If
				End If
				' Card Issuer - response from bank
				If nvcFormVariables("CardIssuer") Is Nothing Then
					szOutputMessage = AddStringToStringList(szOutputMessage, "Expected variable [CardIssuer] not received")
					boErrorOccurred = True
				Else
					If nvcFormVariables("CardIssuer") = "" Then
						trTransactionResult.CardIssuer = Nothing
					Else
						trTransactionResult.CardIssuer = nvcFormVariables("CardIssuer")
					End If
				End If
				' Card Issuer Country Code - response from bank
				If nvcFormVariables("CardIssuerCountryCode") Is Nothing Then
					szOutputMessage = AddStringToStringList(szOutputMessage, "Expected variable [CardIssuerCountryCode] not received")
					boErrorOccurred = True
				Else
					If nvcFormVariables("CardIssuerCountryCode") = "" Then
						trTransactionResult.CardIssuerCountryCode = Nothing
					Else
						trTransactionResult.CardIssuerCountryCode = Convert.ToInt32(nvcFormVariables("CardIssuerCountryCode"))
					End If
				End If
				' Email Address (not necessarily the same as value passed into payment form - as the customer can change it on the form)
				If nvcFormVariables("EmailAddress") Is Nothing Then
					szOutputMessage = AddStringToStringList(szOutputMessage, "Expected variable [EmailAddress] not received")
					boErrorOccurred = True
				Else
					If nvcFormVariables("EmailAddress") = "" Then
						trTransactionResult.EmailAddress = Nothing
					Else
						trTransactionResult.EmailAddress = nvcFormVariables("EmailAddress")
					End If
				End If
				' Phone Number (not necessarily the same as value passed into payment form - as the customer can change it on the form)
				If nvcFormVariables("PhoneNumber") Is Nothing Then
					szOutputMessage = AddStringToStringList(szOutputMessage, "Expected variable [PhoneNumber] not received")
					boErrorOccurred = True
				Else
					If nvcFormVariables("PhoneNumber") = "" Then
						trTransactionResult.PhoneNumber = Nothing
					Else
						trTransactionResult.PhoneNumber = nvcFormVariables("PhoneNumber")
					End If
				End If




				If boErrorOccurred Then
					trTransactionResult = Nothing
				End If
			Catch e As Exception
				boErrorOccurred = True
				szOutputMessage = e.Message
			End Try

			Return (Not boErrorOccurred)
		End Function
		Public Shared Function Get3DSecureAuthenticationRequiredFromPostVariables(nvcFormVariables As NameValueCollection, ByRef trTransactionResult As TransactionResult, ByRef szHashDigest As String, ByRef szOutputMessage As String) As Boolean
			Dim boErrorOccurred As Boolean

			trTransactionResult = Nothing
			szHashDigest = Nothing
			szOutputMessage = ""
			boErrorOccurred = False

			Try
				trTransactionResult = New TransactionResult()

				' hash digest
				If nvcFormVariables("HashDigest") IsNot Nothing Then
					szHashDigest = nvcFormVariables("HashDigest")
				End If

				' transaction status code
				If nvcFormVariables("StatusCode") Is Nothing Then
					szOutputMessage = AddStringToStringList(szOutputMessage, "Expected variable [StatusCode] not received")
					boErrorOccurred = True
				Else
					trTransactionResult.StatusCode = Convert.ToInt32(nvcFormVariables("StatusCode"))
				End If
				' transaction message
				If nvcFormVariables("Message") Is Nothing Then
					szOutputMessage = AddStringToStringList(szOutputMessage, "Expected variable [Message] not received")
					boErrorOccurred = True
				Else
					trTransactionResult.Message = nvcFormVariables("Message")
				End If
				' cross reference of transaction
				If nvcFormVariables("CrossReference") Is Nothing Then
					szOutputMessage = AddStringToStringList(szOutputMessage, "Expected variable [CrossReference] not received")
					boErrorOccurred = True
				Else
					trTransactionResult.CrossReference = nvcFormVariables("CrossReference")
				End If
				' order ID (same as value passed into payment form - echoed back out by payment form)
				If nvcFormVariables("OrderID") Is Nothing Then
					szOutputMessage = AddStringToStringList(szOutputMessage, "Expected variable [OrderID] not received")
					boErrorOccurred = True
				Else
					trTransactionResult.OrderID = nvcFormVariables("OrderID")
				End If
				' transaction date/time (same as value passed into payment form - echoed back out by payment form)
				If nvcFormVariables("TransactionDateTime") Is Nothing Then
					szOutputMessage = AddStringToStringList(szOutputMessage, "Expected variable [TransactionDateTime] not received")
					boErrorOccurred = True
				Else
					trTransactionResult.TransactionDateTime = nvcFormVariables("TransactionDateTime")
				End If
				' order description (same as value passed into payment form - echoed back out by payment form)
				If nvcFormVariables("ACSURL") Is Nothing Then
					szOutputMessage = AddStringToStringList(szOutputMessage, "Expected variable [ACSURL] not received")
					boErrorOccurred = True
				Else
					trTransactionResult.ACSUrl = nvcFormVariables("ACSURL")
				End If
				' address1 (not necessarily the same as value passed into payment form - as the customer can change it on the form)
				If nvcFormVariables("PaREQ") Is Nothing Then
					szOutputMessage = AddStringToStringList(szOutputMessage, "Expected variable [PaREQ] not received")
					boErrorOccurred = True
				Else
					trTransactionResult.PaREQ = nvcFormVariables("PaREQ")
				End If

				If boErrorOccurred Then
					trTransactionResult = Nothing
				End If
			Catch e As Exception
				boErrorOccurred = True
				szOutputMessage = e.Message
			End Try

			Return (Not boErrorOccurred)
		End Function
		Public Shared Function AddStringToStringList(szExistingStringList As String, szStringToAdd As String) As String
			Dim szCommaString As String
			Dim sbReturnString As StringBuilder

			sbReturnString = New StringBuilder()
			szCommaString = ""

			If [String].IsNullOrEmpty(szStringToAdd) Then
				sbReturnString.Append(szExistingStringList)
			Else
				If Not [String].IsNullOrEmpty(szExistingStringList) Then
					szCommaString = ", "
				End If
				sbReturnString.AppendFormat("{0}{1}{2}", szExistingStringList, szCommaString, szStringToAdd)
			End If

			Return (sbReturnString.ToString())
		End Function
		Public Shared Function StringToByteArray(szString As String) As Byte()
			Dim encoding As New System.Text.UTF8Encoding()
			Return encoding.GetBytes(szString)
		End Function
		Public Shared Function ByteArrayToHexString(aByte As Byte()) As String
			Dim sbStringBuilder As StringBuilder
			Dim nCount As Integer = 0

			sbStringBuilder = New StringBuilder()
			For nCount = 0 To aByte.Length - 1
				sbStringBuilder.Append(aByte(nCount).ToString("x2"))
			Next

			Return (sbStringBuilder.ToString())
		End Function
		Public Shared Function ForwardPaddedNumberString(nNumber As Integer, nPaddingAmount As Integer, cPaddingChar As Char) As String
			Dim szReturnString As String
			Dim sbString As StringBuilder
			Dim nCount As Integer = 0

			szReturnString = nNumber.ToString()

			If szReturnString.Length < nPaddingAmount AndAlso nPaddingAmount > 0 Then
				sbString = New StringBuilder()

				For nCount = 0 To nPaddingAmount - szReturnString.Length - 1
					sbString.Append(cPaddingChar)
				Next
				sbString.Append(szReturnString)
				szReturnString = sbString.ToString()
			End If
			Return (szReturnString)
		End Function
		Public Shared Function StripAllWhitespace(szString As String) As String
			Dim sbReturnString As StringBuilder
			Dim nCount As Integer = 0

			If szString Is Nothing Then
				Return (Nothing)
			End If

			sbReturnString = New StringBuilder()

			For nCount = 0 To szString.Length - 1
				If szString(nCount) <> " "C AndAlso szString(nCount) <> ControlChars.Tab AndAlso szString(nCount) <> ControlChars.Lf AndAlso szString(nCount) <> ControlChars.Cr Then
					sbReturnString.Append(szString(nCount))
				End If
			Next
			Return (sbReturnString.ToString())
		End Function
		Public Shared Function CalculateHashDigest(szString As String, szPreSharedKey As String, eHashMethod As HASH_METHOD) As String
			Dim abKey As Byte()
			Dim abBytes As Byte()
			Dim abHashDigest As Byte()
			Dim md5 As MD5
			Dim sha1 As SHA1
			Dim hmacMD5 As HMACMD5
			Dim hmacSHA1 As HMACSHA1

			abKey = StringToByteArray(szPreSharedKey)
			abBytes = StringToByteArray(szString)

			Select Case eHashMethod
				Case HASH_METHOD.HMACMD5
					hmacMD5 = New HMACMD5(abKey)
					abHashDigest = hmacMD5.ComputeHash(abBytes)
					Exit Select
				Case HASH_METHOD.HMACSHA1
					hmacSHA1 = New HMACSHA1(abKey)
					abHashDigest = hmacSHA1.ComputeHash(abBytes)
					Exit Select
				Case HASH_METHOD.MD5
					md5 = New MD5CryptoServiceProvider()
					abHashDigest = md5.ComputeHash(abBytes)
					Exit Select
				Case HASH_METHOD.SHA1
					sha1 = New SHA1CryptoServiceProvider()
					abHashDigest = sha1.ComputeHash(abBytes)
					Exit Select
				Case Else
					Throw New Exception("Invalid hash method: " & eHashMethod.ToString())
			End Select

			Return (ByteArrayToHexString(abHashDigest))
		End Function

		Public Shared Function GenerateStringToHashInitial(szMerchantID As String, szPassword As String, szAmount As String, szCurrencyCode As String, szOrderID As String, szTransactionType As String, _
			szTransactionDateTime As String, szCallbackURL As String, szOrderDescription As String, szPreSharedKey As String, hmHashMethod As HASH_METHOD) As String
			Dim sbReturnString As StringBuilder
			Dim boIncludePreSharedKeyInString As Boolean = False

			sbReturnString = New StringBuilder()

			Select Case hmHashMethod
				Case HASH_METHOD.MD5
					boIncludePreSharedKeyInString = True
					Exit Select
				Case HASH_METHOD.SHA1
					boIncludePreSharedKeyInString = True
					Exit Select
				Case HASH_METHOD.HMACMD5
					boIncludePreSharedKeyInString = False
					Exit Select
				Case HASH_METHOD.HMACSHA1
					boIncludePreSharedKeyInString = False
					Exit Select
			End Select

			If boIncludePreSharedKeyInString Then
				sbReturnString.AppendFormat("PreSharedKey={0}&", szPreSharedKey)
			End If

			sbReturnString.AppendFormat("MerchantID={0}&Password={1}&Amount={2}&CurrencyCode={3}&OrderID={4}&TransactionType={5}" & "&TransactionDateTime={6}&CallbackURL={7}&OrderDescription={8}", szMerchantID, szPassword, szAmount, szCurrencyCode, szOrderID, _
				szTransactionType, szTransactionDateTime, szCallbackURL, szOrderDescription)

			Return (sbReturnString.ToString())
		End Function
		Public Shared Function GenerateStringToHash3DSecureAuthenticationRequired(szMerchantID As String, szPassword As String, trTransactionResult As TransactionResult, szPreSharedKey As String, hmHashMethod As HASH_METHOD) As String
			Dim sbReturnString As StringBuilder
			Dim boIncludePreSharedKeyInString As Boolean = False

			sbReturnString = New StringBuilder()

			Select Case hmHashMethod
				Case HASH_METHOD.MD5
					boIncludePreSharedKeyInString = True
					Exit Select
				Case HASH_METHOD.SHA1
					boIncludePreSharedKeyInString = True
					Exit Select
				Case HASH_METHOD.HMACMD5
					boIncludePreSharedKeyInString = False
					Exit Select
				Case HASH_METHOD.HMACSHA1
					boIncludePreSharedKeyInString = False
					Exit Select
			End Select

			If boIncludePreSharedKeyInString Then
				sbReturnString.AppendFormat("PreSharedKey={0}&", szPreSharedKey)
			End If

			sbReturnString.AppendFormat("MerchantID={0}&Password={1}&StatusCode={2}&Message={3}&CrossReference={4}&OrderID={5}" & "&TransactionDateTime={6}&ACSURL={7}&PaREQ={8}", szMerchantID, szPassword, trTransactionResult.StatusCode, trTransactionResult.Message, trTransactionResult.CrossReference, _
				trTransactionResult.OrderID, trTransactionResult.TransactionDateTime, trTransactionResult.ACSUrl, trTransactionResult.PaREQ)

			Return (sbReturnString.ToString())
		End Function
		Public Shared Function GenerateStringToHash3DSecurePostAuthentication(szMerchantID As String, szPassword As String, szCrossReference As String, szTransactionDateTime As String, szCallbackURL As String, szPaRES As String, _
			szPreSharedKey As String, hmHashMethod As HASH_METHOD) As String
			Dim sbReturnString As StringBuilder
			Dim boIncludePreSharedKeyInString As Boolean = False

			sbReturnString = New StringBuilder()

			Select Case hmHashMethod
				Case HASH_METHOD.MD5
					boIncludePreSharedKeyInString = True
					Exit Select
				Case HASH_METHOD.SHA1
					boIncludePreSharedKeyInString = True
					Exit Select
				Case HASH_METHOD.HMACMD5
					boIncludePreSharedKeyInString = False
					Exit Select
				Case HASH_METHOD.HMACSHA1
					boIncludePreSharedKeyInString = False
					Exit Select
			End Select

			If boIncludePreSharedKeyInString Then
				sbReturnString.AppendFormat("PreSharedKey={0}&", szPreSharedKey)
			End If

			sbReturnString.AppendFormat("MerchantID={0}&Password={1}&CrossReference={2}&TransactionDateTime={3}&CallbackURL={4}&PaRES={5}", szMerchantID, szPassword, szCrossReference, szTransactionDateTime, szCallbackURL, _
				szPaRES)

			Return (sbReturnString.ToString())
		End Function
		Public Shared Function GenerateStringToHashPaymentComplete(szMerchantID As String, szPassword As String, trTransactionResult As TransactionResult, szPreSharedKey As String, hmHashMethod As HASH_METHOD) As String
			Dim sbReturnString As StringBuilder
			Dim boIncludePreSharedKeyInString As Boolean = False

			sbReturnString = New StringBuilder()

			Select Case hmHashMethod
				Case HASH_METHOD.MD5
					boIncludePreSharedKeyInString = True
					Exit Select
				Case HASH_METHOD.SHA1
					boIncludePreSharedKeyInString = True
					Exit Select
				Case HASH_METHOD.HMACMD5
					boIncludePreSharedKeyInString = False
					Exit Select
				Case HASH_METHOD.HMACSHA1
					boIncludePreSharedKeyInString = False
					Exit Select
			End Select

			If boIncludePreSharedKeyInString Then
				sbReturnString.AppendFormat("PreSharedKey={0}&", szPreSharedKey)
			End If

			sbReturnString.AppendFormat("MerchantID={0}&Password={1}&StatusCode={2}&Message={3}&PreviousStatusCode={4}&PreviousMessage={5}&CrossReference={6}" & "&AddressNumericCheckResult={7}&PostCodeCheckResult={8}&CV2CheckResult={9}&ThreeDSecureAuthenticationCheckResult={10}" & "&CardType={11}&CardClass={12}&CardIssuer={13}&CardIssuerCountryCode={14}&Amount={15}&CurrencyCode={16}&OrderID={17}" & "&TransactionType={18}&TransactionDateTime={19}&OrderDescription={20}&Address1={21}&Address2={22}&Address3={23}" & "&Address4={24}&City={25}&State={26}&PostCode={27}&CountryCode={28}&EmailAddress={29}&PhoneNumber={30}", szMerchantID, szPassword, trTransactionResult.StatusCode, trTransactionResult.Message, trTransactionResult.PreviousStatusCode, _
				trTransactionResult.PreviousMessage, trTransactionResult.CrossReference, trTransactionResult.AddressNumericCheckResult, trTransactionResult.PostCodeCheckResult, trTransactionResult.CV2CheckResult, trTransactionResult.ThreeDSecureAuthenticationCheckResult, _
				trTransactionResult.CardType, trTransactionResult.CardClass, trTransactionResult.CardIssuer, trTransactionResult.CardIssuerCountryCode, trTransactionResult.Amount, trTransactionResult.CurrencyCode, _
				trTransactionResult.OrderID, trTransactionResult.TransactionType, trTransactionResult.TransactionDateTime, trTransactionResult.OrderDescription, trTransactionResult.Address1, trTransactionResult.Address2, _
				trTransactionResult.Address3, trTransactionResult.Address4, trTransactionResult.City, trTransactionResult.State, trTransactionResult.PostCode, trTransactionResult.CountryCode, _
				trTransactionResult.EmailAddress, trTransactionResult.PhoneNumber)

			Return (sbReturnString.ToString())
		End Function

		Public Shared Function GenerateStringToHash(szAmount As String, szCurrencyCode As String, szOrderID As String, szTransactionType As String, szTransactionDateTime As String, szCallbackURL As String, _
			szOrderDescription As String, szCustomerName As String, szAddress1 As String, szAddress2 As String, szAddress3 As String, szAddress4 As String, _
			szCity As String, szState As String, szPostCode As String, szCountryCode As String, szSecretKey As String) As String
			Dim sbReturnString As StringBuilder
			sbReturnString = New StringBuilder()

			sbReturnString.AppendFormat("Amount={0}&CurrencyCode={1}&OrderID={2}&TransactionType={3}" & "&TransactionDateTime={4}&CallbackURL={5}&OrderDescription={6}&CustomerName={7}" & "&Address1={8}&Address2={9}&Address3={10}&Address4={11}&City={12}&State={13}&PostCode={14}" & "&CountryCode={15}&SecretKey={16}", szAmount, szCurrencyCode, szOrderID, szTransactionType, szTransactionDateTime, _
				szCallbackURL, szOrderDescription, szCustomerName, szAddress1, szAddress2, szAddress3, _
				szAddress4, szCity, szState, szPostCode, szCountryCode, szSecretKey)

			Return (sbReturnString.ToString())
		End Function
		' This is a "hook" function that is run when the results of the transaction are
		' known.
		' You should put your code that does any post transaction tasks
		' (e.g. updates the order object, sends the customer an email etc) in this function
		Public Shared Function ReportTransactionResult(trTransactionResult As TransactionResult, ByRef szOutputMessage As String) As Boolean
			Dim boErrorOccurred As Boolean = False
			szOutputMessage = ""

			Try
				Select Case trTransactionResult.StatusCode
					' transaction authorised
					Case 0
						Exit Select
					' card referred (treat as decline)
					Case 4
						Exit Select
					' transaction declined
					Case 5
						Exit Select
					' duplicate transaction
					Case 20
						' need to look at the previous status code to see if the
						' transaction was successful
								' transaction authorised
						If trTransactionResult.PreviousStatusCode.Value = 0 Then
								' transaction not authorised
						Else
						End If
						Exit Select
					' error occurred
					Case 30
						Exit Select
					Case Else
						Exit Select

					' put code to update/store the order with the transaction result

				End Select
			Catch e As Exception
				boErrorOccurred = True
				szOutputMessage = e.Message
			End Try
			Return (Not boErrorOccurred)
		End Function
	End Class
End Namespace
