<%@ Page Language="VB" AutoEventWireup="true" CodeFile="PaymentForm.aspx.vb" Inherits="MyCompanyName.PaymentForm" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head id="Head1" runat="server">
    <title>Untitled Page</title>
    <link href="CSS/StyleSheet.css" rel="stylesheet" type="text/css" />
</head>
<body id="BodyTag" runat="server">
    <div style="width: 800px; margin: auto">
        <asp:MultiView ID="PaymentFormMultiView" runat="server" ActiveViewIndex="0">
            <asp:View ID="ResultsView" runat="server">
                <asp:Panel ID="pnMessagePanel" runat="server" Visible="false">
                    <div class="TransactionResultsItem">
                        <div class="TransactionResultsLabel">
                            Payment Processor Response:</div>
                        <div class="TransactionResultsText">
                            <asp:Label ID="lbMessage" runat="server" /></div>
                    </div>
                    <asp:Panel ID="pnDuplicateTransactionPanel" runat="server" Visible="false">
                        <div style="color: #000; margin-top: 10px">
                            A duplicate transaction means that a transaction with these details has already
                            been processed by the payment provider. The details of the original transaction
                            are given below
                        </div>
                        <div class="TransactionResultsItem" style="margin-top: 10px">
                            <div class="TransactionResultsLabel">
                                Previous Transaction Response:</div>
                            <div class="TransactionResultsText">
                                <asp:Label ID="lbPreviousTransactionMessage" runat="server" /></div>
                        </div>
                    </asp:Panel>
                    <div style="margin-top: 10px">
                        <asp:HyperLink ID="hlProcessAnother" runat="server" NavigateUrl="~/StartHere.aspx">Process Another</asp:HyperLink>
                    </div>
                </asp:Panel>
            </asp:View>
            <asp:View ID="PaymentFormView" runat="server">
                <form id="PaymentForm" action="<%= m_szFormAction %>" method="post" >
                <input type="hidden" name="HashDigest" value="<%= m_szHashDigest %>" />
                <input type="hidden" name="MerchantID" value="<%= m_szMerchantID %>" />
                <input type="hidden" name="Amount" value="<%= m_szAmount %>" />
                <input type="hidden" name="CurrencyCode" value="<%= m_szCurrencyCode %>" />
                <input type="hidden" name="OrderID" value="<%= m_szOrderID %>" />
                <input type="hidden" name="TransactionType" value="<%= m_szTransactionType %>" />
                <input type="hidden" name="TransactionDateTime" value="<%= m_szTransactionDateTime %>" />
                <input type="hidden" name="CallbackURL" value="<%= m_szCallbackURL %>" />
                <input type="hidden" name="OrderDescription" value="<%= m_szOrderDescription %>" />
                <div class="ContentRight">
                    <div class="ContentHeader">
                        Order Details
                    </div>
                    <div class="FormItem">
                        <div class="FormLabel">
                            Amount:</div>
                        <div class="FormInputTextOnly">
                            <asp:Label ID="lbAmount" runat="server" />
                        </div>
                    </div>
                    <div class="FormItem">
                        <div class="FormLabel">
                            Order ID:</div>
                        <div class="FormInputTextOnly">
                            <asp:Label ID="lbOrderID" runat="server" />
                        </div>
                    </div>
                    <div class="FormItem">
                        <div class="FormLabel">
                            Order Description:</div>
                        <div class="FormInputTextOnly">
                            <asp:Label ID="lbOrderDescription" runat="server" />
                        </div>
                    </div>
                </div>
                <div class="ContentRight">
                    <div class="ContentHeader">
                        Card Details
                    </div>
                </div>
                <div class="FormItem">
                    <div class="FormLabel">
                        Name On Card:</div>
                    <div class="FormInput">
                        <input type="text" name="CardName" class="InputTextField" value="<%= m_szCustomerName %>"
                            maxlength="50" />
                    </div>
                </div>
                <div class="FormItem">
                    <div class="FormLabel">
                        Card Number:</div>
                    <div class="FormInput">
                        <input type="text" name="CardNumber" class="InputTextField" value="<%= m_szCardNumber %>"
                            maxlength="20" />
                    </div>
                </div>
                <div class="FormItem">
                    <div class="FormLabel">
                        Expiry Date:
                    </div>
                    <div class="FormInput">
                        <select name="ExpiryDateMonth" style="width: 45px;">
				            <%= ListItemCollectionToString(m_licExpiryDateMonths) %>
			            </select>
                        /
                        <select name="ExpiryDateYear" style="width: 55px;">
				            <%= ListItemCollectionToString(m_licExpiryDateYears) %>
                        </select>
                    </div>
                </div>
                <div class="FormItem">
                    <div class="FormLabel">
                        Start Date:
                    </div>
                    <div class="FormInput">
                        <select name="StartDateMonth" style="width: 45px;">
				            <%= ListItemCollectionToString(m_licStartDateMonths) %>
			            </select>
                        /
                        <select name="StartDateYear" style="width: 55px;">
				            <%= ListItemCollectionToString(m_licStartDateYears) %>
                        </select>
                    </div>
                </div>
                <div class="FormItem">
                    <div class="FormLabel">
                        Issue Number:</div>
                    <div class="FormInput">
                        <input type="text" class="InputTextField" name="IssueNumber" value="<%= m_szIssueNumber %>"
                            maxlength="2" style="width: 50px;" />
                    </div>
                </div>
                <div class="FormItem">
                    <div class="FormLabel">
                        CV2:</div>
                    <div class="FormInput">
                        <input type="text" class="InputTextField" name="CV2" value="<%= m_szCV2 %>" maxlength="4"
                            style="width: 50px;" />
                    </div>
                </div>
                <div class="ContentRight">
                    <div class="ContentHeader">
                        Customer Details
                    </div>
                    <div class="FormItem">
                        <div class="FormLabel">
                            Address:</div>
                        <div class="FormInput">
                            <input type="text" class="InputTextField" name="Address1" value="<%= m_szAddress1 %>"
                                maxlength="100" />
                        </div>
                    </div>
                    <div class="FormItem">
                        <div class="FormLabel">
                            &nbsp</div>
                        <div class="FormInput">
                            <input type="text" class="InputTextField" name="Address2" value="<%= m_szAddress2 %>"
                                maxlength="50" />
                        </div>
                    </div>
                    <div class="FormItem">
                        <div class="FormLabel">
                            &nbsp</div>
                        <div class="FormInput">
                            <input type="text" class="InputTextField" name="Address3" value="<%= m_szAddress3 %>"
                                maxlength="50" />
                        </div>
                    </div>
                    <div class="FormItem">
                        <div class="FormLabel">
                            &nbsp</div>
                        <div class="FormInput">
                            <input type="text" class="InputTextField" name="Address4" value="<%= m_szAddress4 %>"
                                maxlength="50" />
                        </div>
                    </div>
                    <div class="FormItem">
                        <div class="FormLabel">
                            City:</div>
                        <div class="FormInput">
                            <input type="text" class="InputTextField" name="City" value="<%= m_szCity %>" maxlength="50" />
                        </div>
                    </div>
                    <div class="FormItem">
                        <div class="FormLabel">
                            State:</div>
                        <div class="FormInput">
                            <input type="text" class="InputTextField" name="State" value="<%= m_szState %>" maxlength="50" />
                        </div>
                    </div>
                    <div class="FormItem">
                        <div class="FormLabel">
                            Post Code:</div>
                        <div class="FormInput">
                            <input type="text" class="InputTextField" name="PostCode" value="<%= m_szPostCode %>"
                                maxlength="50" />
                        </div>
                    </div>
                    <div class="FormItem">
                        <div class="FormLabel">
                            Country:
                        </div>
                        <div class="FormInput">
                            <select name="CountryCode" style="width: 200px;">
				                <%= ListItemCollectionToString(m_licCountryCodes) %>
			                </select>
                        </div>
                    </div>
                    <div class="FormItem">
                        <div class="FormSubmit">
                            <input type="submit" value="Submit For Processing" />
                        </div>
                    </div>
                </div>
                </form>
            </asp:View>
            <asp:View ID="ThreeDSecureAuthenticationRequired" runat="server">
                <form name="ACSForm" action="<%= m_szACSURL %>" method="post" target="ACSFrame">
                    <input type="hidden" name="PaReq" value="<%= m_szPaREQ %>" />
                    <input type="hidden" name="MD" value="<%= m_szCrossReference %>" />
                    <input type="hidden" name="TermUrl" value="<%= m_szTermURL %>" />
                </form>
                <iframe id="ACSFrame" name="ACSFrame" width="800" height="400" frameborder="0" runat="server">
                </iframe>
            </asp:View>
        </asp:MultiView>
    </div>
</body>
</html>
