Imports System.Data
Imports System.Configuration
Imports System.Collections
Imports System.Collections.Generic
Imports System.Text
Imports System.Web
Imports System.Web.Security
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports System.Web.UI.WebControls.WebParts
Imports System.Web.UI.HtmlControls

Namespace MyCompanyName
	Public Partial Class PaymentForm
		Inherits System.Web.UI.Page
		Protected Enum FORM_MODE
			PAYMENT_FORM
			THREE_D_SECURE_AUTHENTICATION_REQUIRED
			RESULTS
		End Enum
		Protected Enum INCOMING_VARIABLE_SOURCE
			SHOPPING_CART_CHECKOUT
			THREE_D_SECURE_AUTHENTICATION_REQUIRED
			RESULTS
		End Enum


		Protected m_fmFormMode As FORM_MODE = FORM_MODE.PAYMENT_FORM
		Private m_boIncomingVariableErrors As Boolean = False

		Protected Friend m_szPaRES As String
		Protected Friend m_szPaREQ As String
		Protected Friend m_szTermURL As String
		Protected Friend m_szACSURL As String
		Protected Friend m_szCrossReference As String

		Protected m_szFormAction As String
		Protected m_szHashDigest As String
		Protected m_szMerchantID As String
		Protected m_szAmount As String
		Protected m_szCurrencyCode As String
		Protected m_szOrderID As String
		Protected m_szTransactionType As String
		Protected m_szTransactionDateTime As String
		Protected m_szCallbackURL As String
		Protected m_szOrderDescription As String
		Protected m_szCustomerName As String
		Protected m_szAddress1 As String
		Protected m_szAddress2 As String
		Protected m_szAddress3 As String
		Protected m_szAddress4 As String
		Protected m_szCity As String
		Protected m_szState As String
		Protected m_szPostCode As String
		Protected m_szCountryCode As String

		Protected m_szCardNumber As String
		Protected m_szExpiryDateMonth As String
		Protected m_szExpiryDateYear As String
		Protected m_szStartDateMonth As String
		Protected m_szStartDateYear As String
		Protected m_szIssueNumber As String
		Protected m_szCV2 As String


		Protected m_licExpiryDateMonths As ListItemCollection
		Protected m_licExpiryDateYears As ListItemCollection

		Protected m_licStartDateMonths As ListItemCollection
		Protected m_licStartDateYears As ListItemCollection

		Protected m_licCountryCodes As ListItemCollection

		Private trTransactionResult As TransactionResult

		Private szOutputMessage As String
		Protected m_szMessage As String
		Protected m_szMessageClass As String
		Protected m_boDuplicateTransaction As Boolean
		Protected m_szPreviousTransactionMessage As String


		Protected Sub Page_Load(sender As Object, e As EventArgs)
			trTransactionResult = Nothing

			m_szFormAction = "https://mms." + [Global].PaymentProcessorDomain & "/Pages/PublicPages/TransparentRedirect.aspx"

			If Request.Form.Count = 0 Then
				m_fmFormMode = FORM_MODE.RESULTS
				m_boIncomingVariableErrors = True

				pnMessagePanel.CssClass = "ErrorMessage"
				lbMessage.Text = "No input variables passed"

				pnMessagePanel.Visible = True
			Else
				If Request.Form("ShoppingCartHashDigest") IsNot Nothing Then
					If Not CheckIntegrityOfIncomingVariables(INCOMING_VARIABLE_SOURCE.SHOPPING_CART_CHECKOUT) Then
						m_boIncomingVariableErrors = True
						m_fmFormMode = FORM_MODE.RESULTS

						pnMessagePanel.CssClass = "ErrorMessage"
						lbMessage.Text = "Variable tampering detected"
						pnMessagePanel.Visible = True
					Else
						m_szFormAction = "https://mms." + [Global].PaymentProcessorDomain & "/Pages/PublicPages/TransparentRedirect.aspx"

						m_szMerchantID = [Global].MerchantID
						' the transaction type - can be SALE or PREAUTH
						m_szTransactionType = Request.Form("TransactionType")
						' the GMT/UTC relative date/time for the transaction (MUST either be in GMT/UTC 
						' or MUST include the correct timezone offset)
						m_szTransactionDateTime = Request.Form("TransactionDateTime")

						m_szCallbackURL = Request.Form("CallbackURL")
						' these variables allow the payment form to be "seeded" with initial values
						m_szCustomerName = Request.Form("CustomerName")
						m_szAddress1 = Request.Form("Address1")
						m_szAddress2 = Request.Form("Address2")
						m_szAddress3 = Request.Form("Address3")
						m_szAddress4 = Request.Form("Address4")
						m_szCity = Request.Form("City")
						m_szState = Request.Form("State")
						m_szPostCode = Request.Form("PostCode")
						m_szCurrencyCode = Request.Form("CurrencyCode")

					End If
				Else
					If Request.Form("HashDigest") IsNot Nothing Then
						If Request.Form("PaREQ") IsNot Nothing Then
							If Not CheckIntegrityOfIncomingVariables(INCOMING_VARIABLE_SOURCE.THREE_D_SECURE_AUTHENTICATION_REQUIRED) Then
								m_boIncomingVariableErrors = True
								m_fmFormMode = FORM_MODE.RESULTS

								pnMessagePanel.CssClass = "ErrorMessage"
								lbMessage.Text = "Variable tampering detected"
								pnMessagePanel.Visible = True
							Else
								m_fmFormMode = FORM_MODE.THREE_D_SECURE_AUTHENTICATION_REQUIRED

								m_szPaREQ = trTransactionResult.PaREQ
								m_szACSURL = trTransactionResult.ACSUrl
								m_szCrossReference = trTransactionResult.CrossReference

								m_szTermURL = PaymentFormHelper.GetSiteSecureBaseURL(Request) & "ThreeDSecureLandingPage.aspx"
							End If
						Else
							m_fmFormMode = FORM_MODE.RESULTS

							pnMessagePanel.Visible = True

							If Not CheckIntegrityOfIncomingVariables(INCOMING_VARIABLE_SOURCE.RESULTS) Then
								m_boIncomingVariableErrors = True

								pnMessagePanel.CssClass = "ErrorMessage"
								lbMessage.Text = "Variable tampering detected"
							Else
								If Not PaymentFormHelper.ReportTransactionResult(trTransactionResult, szOutputMessage) Then
									' handle the case where the results aren't stored correctly
									pnMessagePanel.CssClass = "ErrorMessage"

									' You might want to display the actual exception message during testing
									' If so, comment and uncomment out the two lines below as necessary
										'lbMessage.Text = szOutputMessage;
									lbMessage.Text = "An error has occured"
								Else
									Select Case trTransactionResult.StatusCode
										' transaction authorised
										Case 0
											pnMessagePanel.CssClass = "SuccessMessage"
											Exit Select
										' transaction declined
										Case 5
											pnMessagePanel.CssClass = "ErrorMessage"
											Exit Select
										' duplicate transaction
										Case 20
											pnDuplicateTransactionPanel.Visible = True

											' need to look at the previous status code to see if the
											' transaction was successful
                                            If trTransactionResult.PreviousStatusCode.Value = 0 Then
                                                ' transaction authorised
                                                pnMessagePanel.CssClass = "SuccessMessage"
                                            Else
                                                ' transaction not authorised
                                                pnMessagePanel.CssClass = "ErrorMessage"
                                            End If
                                            lbPreviousTransactionMessage.Text = trTransactionResult.PreviousMessage

                                            Exit Select
                                            ' error occurred
                                        Case 30
                                            pnMessagePanel.CssClass = "ErrorMessage"
                                            Exit Select
                                        Case Else
                                            pnMessagePanel.CssClass = "ErrorMessage"
                                            Exit Select
                                    End Select
									lbMessage.Text = trTransactionResult.Message
								End If
							End If
						End If
					End If
				End If
				PopulateFormItems()
			End If
		End Sub

		Private Function CheckIntegrityOfIncomingVariables(ivsIncomingVariableSource As INCOMING_VARIABLE_SOURCE) As Boolean
			Dim boReturnValue As Boolean = False
			Dim szMessage As String
			Dim szStringToHash As String

			Select Case ivsIncomingVariableSource
				Case INCOMING_VARIABLE_SOURCE.SHOPPING_CART_CHECKOUT
					szStringToHash = PaymentFormHelper.GenerateStringToHash(Request.Form("Amount"), Request.Form("CurrencyCode"), Request.Form("OrderID"), Request.Form("TransactionType"), Request.Form("TransactionDateTime"), Request.Form("CallbackURL"), _
						Request.Form("OrderDescription"), Request.Form("CustomerName"), Request.Form("Address1"), Request.Form("Address2"), Request.Form("Address3"), Request.Form("Address4"), _
						Request.Form("City"), Request.Form("State"), Request.Form("PostCode"), Request.Form("CountryCode"), [Global].SecretKey)

					If Request.Form("ShoppingCartHashDigest") = PaymentFormHelper.CalculateHashDigest(szStringToHash, MyCompanyName.[Global].SecretKey, MyCompanyName.[Global].HashMethod) Then
						boReturnValue = True
					End If

					Exit Select
				Case INCOMING_VARIABLE_SOURCE.THREE_D_SECURE_AUTHENTICATION_REQUIRED

					szStringToHash = Nothing

					If PaymentFormHelper.Get3DSecureAuthenticationRequiredFromPostVariables(Request.Form, trTransactionResult, m_szHashDigest, szMessage) Then
						szStringToHash = PaymentFormHelper.GenerateStringToHash3DSecureAuthenticationRequired([Global].MerchantID, [Global].Password, trTransactionResult, [Global].PreSharedKey, [Global].HashMethod)

						If m_szHashDigest = PaymentFormHelper.CalculateHashDigest(szStringToHash, MyCompanyName.[Global].PreSharedKey, MyCompanyName.[Global].HashMethod) Then
							boReturnValue = True
						End If
					End If
					Exit Select
				Case INCOMING_VARIABLE_SOURCE.RESULTS

					If PaymentFormHelper.getTransactionCompleteResultFromPostVariables(Request.Form, trTransactionResult, m_szHashDigest, szMessage) Then
						szStringToHash = PaymentFormHelper.GenerateStringToHashPaymentComplete([Global].MerchantID, [Global].Password, trTransactionResult, [Global].PreSharedKey, [Global].HashMethod)
						If m_szHashDigest = PaymentFormHelper.CalculateHashDigest(szStringToHash, [Global].PreSharedKey, [Global].HashMethod) Then
							boReturnValue = True
						End If
					End If
					Exit Select
				Case Else
					Throw New Exception("Invalid incoming variable source: " & ivsIncomingVariableSource.ToString())
			End Select

			Return (boReturnValue)
		End Function

		Protected Overrides Sub OnPreRender(e As EventArgs)
			MyBase.OnPreRender(e)

			' need to work out what mode to put the form into
			Select Case m_fmFormMode
				Case FORM_MODE.PAYMENT_FORM
					PaymentFormMultiView.SetActiveView(PaymentFormView)
					Exit Select
				Case FORM_MODE.THREE_D_SECURE_AUTHENTICATION_REQUIRED
					PaymentFormMultiView.SetActiveView(ThreeDSecureAuthenticationRequired)

					ACSFrame.Attributes("src") = PaymentFormHelper.GetSiteSecureBaseURL(Request) & "Loading.htm"
					BodyTag.Attributes("onload") += "document.ACSForm.submit();"
					Exit Select

				Case FORM_MODE.RESULTS
					PaymentFormMultiView.SetActiveView(ResultsView)
					Exit Select
				Case Else
					Throw New Exception("Invalid form mode: " & m_fmFormMode.ToString())
			End Select
		End Sub

		Private Sub PopulateFormItems()
			Dim szWorkingValue As String
			Dim szWorkingDisplayValue As String
			Dim nCount As Integer = 0
			Dim nCurrentYear As Integer
			Dim liListItem As ListItem
			Dim szStringToHash As String

			If m_boIncomingVariableErrors = True Then
				Return
			End If

			Select Case m_fmFormMode
				Case FORM_MODE.PAYMENT_FORM

					m_licExpiryDateMonths = New ListItemCollection()
					m_licExpiryDateYears = New ListItemCollection()
					m_licStartDateMonths = New ListItemCollection()
					m_licStartDateYears = New ListItemCollection()
					m_licCountryCodes = New ListItemCollection()

					' read the values from the shopping cart checkout
					m_szAmount = Request.Form("Amount")
					m_szCurrencyCode = Request.Form("CurrencyCode")
					m_szOrderID = Request.Form("OrderID")
					m_szOrderDescription = Request.Form("OrderDescription")

					' build the has digest for this form
					szStringToHash = PaymentFormHelper.GenerateStringToHashInitial([Global].MerchantID, [Global].Password, m_szAmount, m_szCurrencyCode, m_szOrderID, m_szTransactionType, _
						m_szTransactionDateTime, m_szCallbackURL, m_szOrderDescription, [Global].PreSharedKey, [Global].HashMethod)

					m_szHashDigest = PaymentFormHelper.CalculateHashDigest(szStringToHash, MyCompanyName.[Global].PreSharedKey, MyCompanyName.[Global].HashMethod)


					lbAmount.Text = m_szAmount
					lbOrderID.Text = m_szOrderID
					lbOrderDescription.Text = m_szOrderDescription

					m_licCountryCodes.Add("")

					' TODO ISOCOUNTRY LOOP
					liListItem = New ListItem("United Kingdom", "826")
					liListItem.Selected = True
					m_licCountryCodes.Add(liListItem)

					nCurrentYear = DateTime.Now.Year

					m_licExpiryDateYears.Add("")
					m_licExpiryDateMonths.Add("")

					m_licStartDateYears.Add("")
					m_licStartDateMonths.Add("")

					For nCount = 0 To 9
						' expiry date - start with this year & add 10
                        szWorkingDisplayValue = MyCompanyName.PaymentFormHelper.ForwardPaddedNumberString(nCurrentYear + nCount, 2, "0"c)
						szWorkingValue = szWorkingDisplayValue.Substring(2)
						liListItem = New ListItem(szWorkingDisplayValue, szWorkingValue)
						m_licExpiryDateYears.Add(liListItem)

						' start date - start with this year & minus 10
						szWorkingDisplayValue = System.Convert.ToString(nCurrentYear - nCount)
						szWorkingValue = szWorkingDisplayValue.Substring(2)
						liListItem = New ListItem(szWorkingDisplayValue, szWorkingValue)
						m_licStartDateYears.Add(liListItem)
					Next

					For nCount = 1 To 12
						szWorkingDisplayValue = MyCompanyName.PaymentFormHelper.ForwardPaddedNumberString(nCount, 2, "0"C)
                        liListItem = New ListItem(szWorkingDisplayValue, szWorkingDisplayValue)
						m_licExpiryDateMonths.Add(liListItem)

                        liListItem = New ListItem(szWorkingDisplayValue, szWorkingDisplayValue)
						m_licStartDateMonths.Add(liListItem)
					Next
					Exit Select
			End Select
		End Sub
		Protected Function ListItemCollectionToString(licListItemCollection As ListItemCollection) As String
			Dim sb As New StringBuilder()

			For Each liListItem As ListItem In licListItemCollection
				sb.AppendFormat("<option value=""{0}""", liListItem.Value)
				If liListItem.Selected Then
					sb.Append(" selected")
				End If
				sb.AppendFormat(" >{0}</option>", liListItem.Text)
			Next

			Return sb.ToString()
		End Function
	End Class
End Namespace
