Imports System.Data
Imports System.Configuration
Imports System.Collections
Imports System.Web
Imports System.Web.Security
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports System.Web.UI.WebControls.WebParts
Imports System.Web.UI.HtmlControls

Namespace MyCompanyName
	Public Partial Class StartHere
		Inherits System.Web.UI.Page
		Protected m_szFormAction As String
		Protected m_szHashDigest As String
		Protected m_szMerchantID As String
		Protected m_szAmount As String
		Protected m_szCurrencyCode As String
		Protected m_szOrderID As String
		Protected m_szTransactionType As String
		Protected m_szTransactionDateTime As String
		Protected m_szCallbackURL As String
		Protected m_szOrderDescription As String
		Protected m_szCustomerName As String
		Protected m_szAddress1 As String
		Protected m_szAddress2 As String
		Protected m_szAddress3 As String
		Protected m_szAddress4 As String
		Protected m_szCity As String
		Protected m_szState As String
		Protected m_szPostCode As String
		Protected m_szCountryCode As String

		Protected Sub Page_Load(sender As Object, e As EventArgs)
			Dim szStringToHash As String

			m_szFormAction = PaymentFormHelper.GetSiteSecureBaseURL(Request) & "PaymentForm.aspx"

			m_szMerchantID = [Global].MerchantID

			' the amount in *minor* currency (i.e. �10.00 passed as "1000")
			m_szAmount = Convert.ToString(1000)
			' the currency	- ISO 4217 3-digit numeric (e.g. GBP = 826)
			m_szCurrencyCode = Convert.ToString(826)
			' order ID
			m_szOrderID = "Order-1234"
			' order description
			m_szOrderDescription = "A Test Order"
			' the transaction type - can be SALE or PREAUTH
			m_szTransactionType = "SALE"
			' the GMT/UTC relative date/time for the transaction (MUST either be in GMT/UTC 
			' or MUST include the correct timezone offset)
			m_szTransactionDateTime = DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss zzz")

			m_szCallbackURL = PaymentFormHelper.GetSiteSecureBaseURL(Request) & "PaymentForm.aspx"

			' these variables allow the payment form to be "seeded" with initial values
			m_szCustomerName = "A Customer"
			m_szAddress1 = "14 Some Address"
			m_szAddress2 = ""
			m_szAddress3 = ""
			m_szAddress4 = ""
			m_szCity = "Some City"
			m_szState = "Some State"
			m_szPostCode = "PO57 0DE"

			' the country code - ISO 3166-1  3-digit numeric (e.g. UK = 826)
			' PLEASE NOTE: Currently, do not change this from the value of 826.
			m_szCountryCode = Convert.ToString(826)

			' get the string to be hashed
			szStringToHash = PaymentFormHelper.GenerateStringToHash(m_szAmount, m_szCurrencyCode, m_szOrderID, m_szTransactionType, m_szTransactionDateTime, m_szCallbackURL, _
				m_szOrderDescription, m_szCustomerName, m_szAddress1, m_szAddress2, m_szAddress3, m_szAddress4, _
				m_szCity, m_szState, m_szPostCode, m_szCountryCode, [Global].SecretKey)

			' pass this string into the hash function to create the hash digest
			m_szHashDigest = PaymentFormHelper.CalculateHashDigest(szStringToHash, [Global].SecretKey, [Global].HashMethod)

			lbAmount.Text = m_szAmount
			lbCurrency.Text = m_szCurrencyCode
			lbOrderID.Text = m_szOrderID
			lbOrderDescription.Text = m_szOrderDescription

		End Sub
	End Class
End Namespace
