<?php
    require ("Config.php");
    require_once ("PreProcessPaymentForm.php");

    $Width = 800;
    include ("Templates/FormHeader.tpl");

    switch ($NextFormMode)
    {
        Case FORM_MODE::RESULTS :
            include ("Templates/FinalResultsPanel.tpl");
            break;
            
        Case FORM_MODE::THREE_D_SECURE_AUTHENTICATION_REQUIRED :
            $SiteSecureBaseURL = PaymentFormHelper::getSiteSecureBaseURL();
            include ("Templates/3DSIFrame.tpl");
            break;
            
        Case FORM_MODE::PAYMENT_FORM :
            if (isset($Message) == true && $Message != "")
            {
                include ("Templates/ProcessingErrorResultsPanel.tpl");
            }

            if ($SuppressFormDisplay == false)
            {
                $HashDigest = PaymentFormHelper::calculateHashDigest(
                    PaymentFormHelper::generateStringToHashInitial(
                        $HashMethod, $PreSharedKey, $MerchantID, $Password, $Amount, $CurrencyCode, $OrderID, $TransactionType, $TransactionDateTime, $CallbackURL, $OrderDescription), $PreSharedKey, $HashMethod);
                
                $ExpiryDateMonth = null;
                $ExpiryDateYear = null;
                $StartDateMonth = null;
                $StartDateYear = null;
                $CardNumber = null;
                $IssueNumber=null;
                $CV2 = null;

                // these would be provided by the customer as part of the payment form process, thus are not included in the below hashing
                $CustomerName = "A Customer";
                
                $Address1 = "14 Some Address";
                $Address2 = "";
                $Address3 = "";
                $Address4 = "";
                
                $City = "Some City";
                $State = "Some State";
                $PostCode = "PO57 0DE";
                
                $lilExpiryDateMonthList = PaymentFormHelper::createExpiryDateMonthListItemList($ExpiryDateMonth);
                $lilExpiryDateYearList = PaymentFormHelper::createExpiryDateYearListItemList($ExpiryDateYear);
                $lilStartDateMonthList = PaymentFormHelper::createStartDateMonthListItemList($StartDateMonth);
                $lilStartDateYearList = PaymentFormHelper::createStartDateYearListItemList($StartDateYear);

                $lilISOCountryList = PaymentFormHelper::createISOCountryListItemList();

                include ("Templates/PaymentForm.tpl");
            }
            break;
        default :
            break;
    }
    include ("Templates/FormFooter.tpl");
?>