<?php
    class FORM_MODE {
        const PAYMENT_FORM = 0;
        const THREE_D_SECURE_AUTHENTICATION_REQUIRED = 1;
        const RESULTS = 2;
    }
    class INCOMING_VARIABLE_SOURCE
    {
        const SHOPPING_CART_CHECKOUT = 0;
        const THREE_D_SECURE_AUTHENTICATION_REQUIRED = 1;
        const RESULTS = 2;
    }
    
    class ListItemList
    {
        private $m_lilListItemList;

        public function getCount()
        {
            return count($this -> m_lilListItemList);
        }

        public function getAt($nIndex)
        {
            if ($nIndex < 0 || $nIndex >= count($this -> m_lilListItemList))
            {
                throw new Exception('Array index out of bounds');
            }

            return $this -> m_lilListItemList[$nIndex];
        }

        public function add($szName, $szValue, $boIsSelected)
        {
            $liListItem = new ListItem($szName, $szValue, $boIsSelected);

            $this -> m_lilListItemList[] = $liListItem;
        }

        public function toString()
        {
            $szReturnString = "";

            for ($nCount = 0; $nCount < count($this -> m_lilListItemList); $nCount++)
            {
                $liListItem = $this -> m_lilListItemList[$nCount];

                $szReturnString = $szReturnString . "<option";

                if ($liListItem -> getValue() != null && $liListItem -> getValue() != "")
                {
                    $szReturnString = $szReturnString . " value=\"" . $liListItem -> getValue() . "\"";
                }

                if ($liListItem -> getIsSelected() == true)
                {
                    $szReturnString = $szReturnString . " selected=\"selected\"";
                }

                $szReturnString = $szReturnString . ">" . $liListItem -> getName() . "</option>\n";
            }

            return ($szReturnString);
        }

        //constructor
        public function __construct()
        {
            $this -> m_lilListItemList = array();
        }

    }
    class ListItem
    {
        private $m_szName;
        private $m_szValue;
        private $m_boIsSelected;

        //public properties
        public function getName()
        {
            return $this -> m_szName;
        }

        public function getValue()
        {
            return $this -> m_szValue;
        }

        public function getIsSelected()
        {
            return $this -> m_boIsSelected;
        }

        //constructor
        public function __construct($szName, $szValue, $boIsSelected)
        {
            $this -> m_szName = $szName;
            $this -> m_szValue = $szValue;
            $this -> m_boIsSelected = $boIsSelected;
        }

    }
    class TransactionResult
    {

        private $m_nStatusCode;
        private $m_szMessage;
        private $m_nPreviousStatusCode;
        private $m_szPreviousMessage;
        private $m_szCrossReference;
        private $m_nAmount;
        private $m_nCurrencyCode;
        private $m_szOrderID;
        private $m_szTransactionType;
        private $m_szTransactionDateTime;
        private $m_szOrderDescription;
        private $m_szAddress1;
        private $m_szAddress2;
        private $m_szAddress3;
        private $m_szAddress4;
        private $m_szCity;
        private $m_szState;
        private $m_szPostCode;
        private $m_nCountryCode;
        private $m_bAddressNumericCheckResult;
        private $m_bPostCodeCheckResult;
        private $m_bCV2CheckResult;
        private $m_bThreeDSecureAuthenticationCheckResult;
        private $m_szCardType;
        private $m_szCardClass;
        private $m_szCardIssuer;
        private $m_nCardIssuerCountryCode;
        private $m_szEmailAddress;
        private $m_szPhoneNumber;

        private $m_szMerchantID;
        private $m_szACSURL;
        private $m_szPaREQ;
        private $m_szCallbackUrl;
        private $m_szPaRES;

        public function getStatusCode()
        {
            return $this -> m_nStatusCode;
        }

        public function setStatusCode($nStatusCode)
        {
            $this -> m_nStatusCode = $nStatusCode;
        }

        public function getMessage()
        {
            return $this -> m_szMessage;
        }

        public function setMessage($szMessage)
        {
            $this -> m_szMessage = $szMessage;
        }

        public function getPreviousStatusCode()
        {
            return $this -> m_nPreviousStatusCode;
        }

        public function setPreviousStatusCode($nPreviousStatusCode)
        {
            $this -> m_nPreviousStatusCode = $nPreviousStatusCode;
        }

        public function getPreviousMessage()
        {
            return $this -> m_szPreviousMessage;
        }

        public function setPreviousMessage($szPreviousMessage)
        {
            $this -> m_szPreviousMessage = $szPreviousMessage;
        }

        public function getCrossReference()
        {
            return $this -> m_szCrossReference;
        }

        public function setCrossReference($szCrossReference)
        {
            $this -> m_szCrossReference = $szCrossReference;
        }

        public function getAmount()
        {
            return $this -> m_nAmount;
        }

        public function setAmount($nAmount)
        {
            $this -> m_nAmount = $nAmount;
        }

        public function getCurrencyCode()
        {
            return $this -> m_nCurrencyCode;
        }

        public function setCurrencyCode($nCurrencyCode)
        {
            $this -> m_nCurrencyCode = $nCurrencyCode;
        }

        public function getOrderID()
        {
            return $this -> m_szOrderID;
        }

        public function setOrderID($szOrderID)
        {
            $this -> m_szOrderID = $szOrderID;
        }

        public function getTransactionType()
        {
            return $this -> m_szTransactionType;
        }

        public function setTransactionType($szTransactionType)
        {
            $this -> m_szTransactionType = $szTransactionType;
        }

        public function getTransactionDateTime()
        {
            return $this -> m_szTransactionDateTime;
        }

        public function setTransactionDateTime($szTransactionDateTime)
        {
            $this -> m_szTransactionDateTime = $szTransactionDateTime;
        }

        public function getOrderDescription()
        {
            return $this -> m_szOrderDescription;
        }

        public function setOrderDescription($szOrderDescription)
        {
            $this -> m_szOrderDescription = $szOrderDescription;
        }

        public function getAddress1()
        {
            return $this -> m_szAddress1;
        }

        public function setAddress1($szAddress1)
        {
            $this -> m_szAddress1 = $szAddress1;
        }

        public function getAddress2()
        {
            return $this -> m_szAddress2;
        }

        public function setAddress2($szAddress2)
        {
            $this -> m_szAddress2 = $szAddress2;
        }

        public function getAddress3()
        {
            return $this -> m_szAddress3;
        }

        public function setAddress3($szAddress3)
        {
            $this -> m_szAddress3 = $szAddress3;
        }

        public function getAddress4()
        {
            return $this -> m_szAddress4;
        }

        public function setAddress4($szAddress4)
        {
            $this -> m_szAddress4 = $szAddress4;
        }

        public function getCity()
        {
            return $this -> m_szCity;
        }

        public function setCity($szCity)
        {
            $this -> m_szCity = $szCity;
        }

        public function getState()
        {
            return $this -> m_szState;
        }

        public function setState($szState)
        {
            $this -> m_szState = $szState;
        }

        public function getPostCode()
        {
            return $this -> m_szPostCode;
        }

        public function setPostCode($szPostCode)
        {
            $this -> m_szPostCode = $szPostCode;
        }

        public function getCountryCode()
        {
            return $this -> m_nCountryCode;
        }

        public function setCountryCode($nCountryCode)
        {
            $this -> m_nCountryCode = $nCountryCode;
        }

        public function setAddressNumericCheckResult($bAddressNumericCheckResult)
        {
            $this -> m_bAddressNumericCheckResult = $bAddressNumericCheckResult;
        }

        public function getAddressNumericCheckResult()
        {
            return $this -> m_bAddressNumericCheckResult;
        }

        public function setPostCodeCheckResult($bPostCodeCheckResult)
        {
            $this -> m_bPostCodeCheckResult = $bPostCodeCheckResult;
        }

        public function getPostCodeCheckResult()
        {
            return $this -> m_bPostCodeCheckResult;
        }

        public function setCV2CheckResult($bCV2CheckResult)
        {
            $this -> m_bCV2CheckResult = $bCV2CheckResult;
        }

        public function getCV2CheckResult()
        {
            return $this -> m_bCV2CheckResult;
        }

        public function setThreeDSecureAuthenticationCheckResult($bThreeDSecureAuthenticationCheckResult)
        {
            $this -> m_bThreeDSecureAuthenticationCheckResult = $bThreeDSecureAuthenticationCheckResult;
        }

        public function getThreeDSecureAuthenticationCheckResult()
        {
            return $this -> m_bThreeDSecureAuthenticationCheckResult;
        }

        public function setCardType($szCardType)
        {
            $this -> m_szCardType = $szCardType;
        }

        public function getCardType()
        {
            return $this -> m_szCardType;
        }

        public function setCardClass($szCardClass)
        {
            $this -> m_szCardClass = $szCardClass;
        }

        public function getCardClass()
        {
            return $this -> m_szCardClass;
        }

        public function setCardIssuer($szCardIssuer)
        {
            $this -> m_szCardIssuer = $szCardIssuer;
        }

        public function getCardIssuer()
        {
            return $this -> m_szCardIssuer;
        }

        public function setCardIssuerCountryCode($nCardIssuerCountryCode)
        {
            $this -> m_nCardIssuerCountryCode = $nCardIssuerCountryCode;
        }

        public function getCardIssuerCountryCode()
        {
            return $this -> m_nCardIssuerCountryCode;
        }

        public function setEmailAddress($szEmailAddress)
        {
            $this -> m_szEmailAddress = $szEmailAddress;
        }

        public function getEmailAddress()
        {
            return $this -> m_szEmailAddress;
        }

        public function setPhoneNumber($szPhoneNumber)
        {
            $this -> m_szPhoneNumber = $szPhoneNumber;
        }

        public function getPhoneNumber()
        {
            return $this -> m_szPhoneNumber;
        }

        public function setMerchantID($szMerchantID)
        {
            $this -> m_szMerchantID = $szMerchantID;
        }

        public function getMerchantID()
        {
            return $this -> m_szMerchantID;
        }

        public function setACSURL($szACSURL)
        {
            $this -> m_szACSURL = $szACSURL;
        }

        public function getACSURL()
        {
            return $this -> m_szACSURL;
        }

        public function setPaREQ($szPaREQ)
        {
            $this -> m_szPaREQ = $szPaREQ;
        }

        public function getPaREQ()
        {
            return $this -> m_szPaREQ;
        }

        public function setCallbackUrl($szCallbackUrl)
        {
            $this -> m_szCallbackUrl = $szCallbackUrl;
        }

        public function getCallbackURL()
        {
            return $this -> m_szCallbackUrl;
        }

        public function setPaRES($szPaRES)
        {
            $this -> m_szPaRES = $szPaRES;
        }

        public function getPaRES()
        {
            return $this -> m_szPaRES;
        }

    }
    class PaymentFormHelper
    {
        public static $trTransactionResult;

        public static function addStringToStringList($szExistingStringList, $szStringToAdd)
        {
            $szReturnString = "";
            $szCommaString = "";

            if (strlen($szStringToAdd) == 0)
            {
                $szReturnString = $szExistingStringList;
            }
            else
            {
                if (strlen($szExistingStringList) != 0)
                {
                    $szCommaString = ", ";
                }
                $szReturnString = $szExistingStringList . $szCommaString . $szStringToAdd;
            }

            return ($szReturnString);
        }

        public static function getSiteSecureBaseURL()
        {
            $szReturnString = "";
            $szPortString = "";
            $szProtocolString = "";

            if ($_SERVER["HTTPS"] == "on")
            {
                $szProtocolString = "https://";
                if ($_SERVER["SERVER_PORT"] != 443)
                {
                    $szPortString = ":" . $_SERVER["SERVER_PORT"];
                }
            }
            else
            {
                $szProtocolString = "http://";
                if ($_SERVER["SERVER_PORT"] != 80)
                {
                    $szPortString = ":" . $_SERVER["SERVER_PORT"];
                }
            }

            $szReturnString = $szProtocolString . $_SERVER["SERVER_NAME"] . $szPortString . $_SERVER["SCRIPT_NAME"];

            $boFinished = false;
            $LoopIndex = strlen($szReturnString) - 1;

            while ($boFinished == false && $LoopIndex >= 0)
            {
                if ($szReturnString[$LoopIndex] == "/")
                {
                    $boFinished = true;
                    $szReturnString = substr($szReturnString, 0, $LoopIndex + 1);
                }
                $LoopIndex--;
                ;
            }

            return ($szReturnString);
        }

        public static function createExpiryDateMonthListItemList($ExpiryDateMonth)
        {
            $lilExpiryDateMonthList = new ListItemList();

            for ($LoopIndex = 1; $LoopIndex <= 12; $LoopIndex++)
            {
                $DisplayMonth = $LoopIndex;
                if ($LoopIndex < 10)
                {
                    $DisplayMonth = "0" . $LoopIndex;
                }
                if ($ExpiryDateMonth != "" && $ExpiryDateMonth == $LoopIndex)
                {
                    $lilExpiryDateMonthList -> add($DisplayMonth, $DisplayMonth, true);
                }
                else
                {
                    $lilExpiryDateMonthList -> add($DisplayMonth, $DisplayMonth, false);
                }
            }

            return ($lilExpiryDateMonthList);
        }

        public static function createExpiryDateYearListItemList($ExpiryDateYear)
        {
            $ThisYear = date("Y");
            $ThisYearPlusTen = $ThisYear + 10;

            $lilExpiryDateYearList = new ListItemList();

            for ($LoopIndex = $ThisYear; $LoopIndex <= $ThisYearPlusTen; $LoopIndex++)
            {
                $ShortYear = substr($LoopIndex, strlen($LoopIndex) - 2, 2);
                if ($ExpiryDateYear != "" && $ExpiryDateYear == $ShortYear)
                {
                    $lilExpiryDateYearList -> add($LoopIndex, $ShortYear, true);
                }
                else
                {
                    $lilExpiryDateYearList -> add($LoopIndex, $ShortYear, false);
                }
            }

            return ($lilExpiryDateYearList);
        }

        public static function createStartDateMonthListItemList($StartDateMonth)
        {
            $lilStartDateMonthList = new ListItemList();

            for ($LoopIndex = 1; $LoopIndex <= 12; $LoopIndex++)
            {
                $DisplayMonth = $LoopIndex;
                if ($LoopIndex < 10)
                {
                    $DisplayMonth = "0" . $LoopIndex;
                }
                if ($StartDateMonth != "" && $StartDateMonth == $LoopIndex)
                {
                    $lilStartDateMonthList -> add($LoopIndex, $DisplayMonth, true);
                }
                else
                {
                    $lilStartDateMonthList -> add($LoopIndex, $DisplayMonth, false);
                }
            }

            return ($lilStartDateMonthList);
        }

        public static function createStartDateYearListItemList($StartDateYear)
        {
            $ThisYear = date("Y");

            $lilStartDateYearList = new ListItemList();

            for ($LoopIndex = 2000; $LoopIndex <= $ThisYear; $LoopIndex++)
            {
                $ShortYear = substr($LoopIndex, strlen($LoopIndex) - 2, 2);
                if ($StartDateYear != "" && $StartDateYear == $ShortYear)
                {
                    $lilStartDateYearList -> add($LoopIndex, $ShortYear, true);
                }
                else
                {
                    $lilStartDateYearList -> add($LoopIndex, $ShortYear, false);
                }
            }

            return ($lilStartDateYearList);
        }

        public static function createISOCountryListItemList()
        {
            $lilISOCountryList = new ListItemList();

            $lilISOCountryList -> add("United Kingdom", "826", true);
            
            // TODO ISOCOUNTRY LOOP

            return ($lilISOCountryList);
        }

        public static function calculateHashDigest($szInputString, $szSecretKeyOrPreSharedKey, $szHashMethod)
        {
            switch ($szHashMethod)
            {
                case "MD5" :
                    $hashDigest = md5($szInputString);
                    break;
                case "SHA1" :
                    $hashDigest = sha1($szInputString);
                    break;
                case "HMACMD5" :
                    $hashDigest = hash_hmac("md5", $szInputString, $szSecretKeyOrPreSharedKey);
                    break;
                case "HMACSHA1" :
                    $hashDigest = hash_hmac("sha1", $szInputString, $szSecretKeyOrPreSharedKey);
                    break;
            }

            return ($hashDigest);
        }

        private static function IncludePreSharedKeyInString($szHashMethod)
        {

            $boIncludePreSharedKeyInString = false;

            switch ($szHashMethod)
            {
                case "MD5" :
                case "SHA1" :
                    $boIncludePreSharedKeyInString = true;
                    break;
            }

            return $boIncludePreSharedKeyInString;
        }

        public static function generateStringToHash($szMerchantID, 
                                                    $szPassword,
                                                    $szAmount,
                                                    $szCurrencyCode,
                                                    $szOrderID,
                                                    $szTransactionType,
                                                    $szTransactionDateTime,
                                                    $szCallbackURL,
                                                    $szOrderDescription,
                                                    $szCustomerName,
                                                    $szAddress1,
                                                    $szAddress2,
                                                    $szAddress3,
                                                    $szAddress4,
                                                    $szCity,
                                                    $szState,
                                                    $szPostCode,
                                                    $szCountryCode,
                                                    $szSecretKey)
        {
            $szReturnString = "";

            $szReturnString = "MerchantID=".$szMerchantID.
                              "&Password=".$szPassword.
                              "&Amount=".$szAmount.
                              "&CurrencyCode=".$szCurrencyCode.
                              "&OrderID=".$szOrderID.
                              "&TransactionType=".$szTransactionType.
                              "&TransactionDateTime=".$szTransactionDateTime.
                              "&CallbackURL=".$szCallbackURL.
                              "&OrderDescription=".$szOrderDescription.
                              "&CustomerName=".$szCustomerName.
                              "&Address1=".$szAddress1.
                              "&Address2=".$szAddress2.
                              "&Address3=".$szAddress3.
                              "&Address4=".$szAddress4.
                              "&City=".$szCity.
                              "&State=".$szState.
                              "&PostCode=".$szPostCode.
                              "&CountryCode=".$szCountryCode.
                              "&SecretKey=".$szSecretKey;

            return ($szReturnString);
        }

        public static function generateStringToHashInitial($szHashMethod, $szPreSharedKey, $szMerchantID, $szPassword, $szAmount, $szCurrencyCode, $szOrderID, $szTransactionType, $szTransactionDateTime, $szCallbackURL, $szOrderDescription)
        {

            $szReturnString = "";

            if (self::IncludePreSharedKeyInString($szHashMethod))
            {
                $szReturnString = "PreSharedKey=" . $szPreSharedKey . "&";
            }

            $szReturnString .= "MerchantID=" . $szMerchantID . "&Password=" . $szPassword . "&Amount=" . $szAmount . "&CurrencyCode=" . $szCurrencyCode . "&OrderID=" . $szOrderID . "&TransactionType=" . $szTransactionType . "&TransactionDateTime=" . $szTransactionDateTime . "&CallbackURL=" . $szCallbackURL . "&OrderDescription=" . $szOrderDescription;

            return $szReturnString;
        }

        public static function generateStringToHash3DSecureAuthenticationRequired($trTransactionResult, $szHashMethod, $szPreSharedKey, $szMerchantID, $szPassword)
        {

            $szReturnString = "";

            if (self::IncludePreSharedKeyInString($szHashMethod))
            {
                $szReturnString = "PreSharedKey=" . $szPreSharedKey . "&";
            }

            $szReturnString .= "MerchantID=" . $szMerchantID . "&Password=" . $szPassword . "&StatusCode=" . $trTransactionResult -> getStatusCode() . "&Message=" . $trTransactionResult -> getMessage() . "&CrossReference=" . $trTransactionResult -> getCrossReference() . "&OrderID=" . $trTransactionResult -> getOrderID() . "&TransactionDateTime=" . $trTransactionResult -> getTransactionDateTime() . "&ACSURL=" . $trTransactionResult -> getACSURL() . "&PaREQ=" . $trTransactionResult -> getPaREQ();

            return $szReturnString;
        }

        public static function generateStringToHash3DSecurePostAuthentication($szHashMethod, $szPreSharedKey, $szMerchantID, $szPassword, $szCrossReference, $szTransactionDateTime, $szCallbackURL, $szPaRES)
        {

            $szReturnString = "";

            if (self::IncludePreSharedKeyInString($szHashMethod))
            {
                $szReturnString = "PreSharedKey=" . $szPreSharedKey . "&";
            }

            $szReturnString .= "MerchantID=" . $szMerchantID . "&Password=" . $szPassword . "&CrossReference=" . $szCrossReference . "&TransactionDateTime=" . $szTransactionDateTime . "&CallbackURL=" . $szCallbackURL . "&PaRES=" . $szPaRES;

            return $szReturnString;

        }

        public static function generateStringToHashPaymentComplete($trTransactionResult, $szHashMethod, $szPreSharedKey, $szMerchantID, $szPassword)
        {

            $szReturnString = null;

            if (self::IncludePreSharedKeyInString($szHashMethod))
            {
                $szReturnString = "PreSharedKey=" . $szPreSharedKey . "&";
            }

            $szReturnString .= "MerchantID=" . $szMerchantID . "&Password=" . $szPassword . "&StatusCode=" . $trTransactionResult -> getStatusCode() . "&Message=" . $trTransactionResult -> getMessage() . "&PreviousStatusCode=" . $trTransactionResult -> getPreviousStatusCode() . "&PreviousMessage=" . $trTransactionResult -> getPreviousMessage() . "&CrossReference=" . $trTransactionResult -> getCrossReference() . "&AddressNumericCheckResult=" . $trTransactionResult -> getAddressNumericCheckResult() . "&PostCodeCheckResult=" . $trTransactionResult -> getPostCodeCheckResult() . "&CV2CheckResult=" . $trTransactionResult -> getCV2CheckResult() . "&ThreeDSecureAuthenticationCheckResult=" . $trTransactionResult -> getThreeDSecureAuthenticationCheckResult() . "&CardType=" . $trTransactionResult -> getCardType() . "&CardClass=" . $trTransactionResult -> getCardClass() . "&CardIssuer=" . $trTransactionResult -> getCardIssuer() . "&CardIssuerCountryCode=" . $trTransactionResult -> getCardIssuerCountryCode() . "&Amount=" . $trTransactionResult -> getAmount() . "&CurrencyCode=" . $trTransactionResult -> getCurrencyCode() . "&OrderID=" . $trTransactionResult -> getOrderID() . "&TransactionType=" . $trTransactionResult -> getTransactionType() . "&TransactionDateTime=" . $trTransactionResult -> getTransactionDateTime() . "&OrderDescription=" . $trTransactionResult -> getOrderDescription() . "&Address1=" . $trTransactionResult -> getAddress1() . "&Address2=" . $trTransactionResult -> getAddress2() . "&Address3=" . $trTransactionResult -> getAddress3() . "&Address4=" . $trTransactionResult -> getAddress4() . "&City=" . $trTransactionResult -> getCity() . "&State=" . $trTransactionResult -> getState() . "&PostCode=" . $trTransactionResult -> getPostCode() . "&CountryCode=" . $trTransactionResult -> getCountryCode() . "&EmailAddress=" . $trTransactionResult -> getEmailAddress() . "&PhoneNumber=" . $trTransactionResult -> getPhoneNumber();

            return ($szReturnString);
        }

        public static function checkIntegrityOfIncomingVariables($ivsIncomingVariableSource, $aVariables, $szHashMethod, $szSecreKeyOrPreSharedKey, $szMerchantID, $szPassword)
        {
            $boReturnValue = false;
            $szStringToHash = null;
            $szCalculatedHash = null;

            switch ($ivsIncomingVariableSource)
            {
                Case INCOMING_VARIABLE_SOURCE::SHOPPING_CART_CHECKOUT :
                    $szHash = $aVariables['ShoppingCartHashDigest'];
                    $szStringToHash = self::generateStringToHash(   $szMerchantID,
                                                                    $szPassword,
                                                                    $aVariables["Amount"],
                                                                    $aVariables["CurrencyCode"],
                                                                    $aVariables["OrderID"],
                                                                    $aVariables["TransactionType"],
                                                                    $aVariables["TransactionDateTime"],
                                                                    $aVariables["CallbackURL"],
                                                                    $aVariables["OrderDescription"],
                                                                    $aVariables["CustomerName"],
                                                                    $aVariables["Address1"],
                                                                    $aVariables["Address2"],
                                                                    $aVariables["Address3"],
                                                                    $aVariables["Address4"],
                                                                    $aVariables["City"],
                                                                    $aVariables["State"],
                                                                    $aVariables["PostCode"],
                                                                    $aVariables["CountryCode"],
                                                                    $szSecreKeyOrPreSharedKey);
                    break;
                case INCOMING_VARIABLE_SOURCE::THREE_D_SECURE_AUTHENTICATION_REQUIRED :
                    $szHash = $aVariables['HashDigest'];
                    self::get3DSecureAuthenticationRequiredFromPostVariables($aVariables, self::$trTransactionResult);
                    $szStringToHash = self::generateStringToHash3DSecureAuthenticationRequired(self::$trTransactionResult, $szHashMethod, $szSecreKeyOrPreSharedKey, $szMerchantID, $szPassword);
                    break;
                case INCOMING_VARIABLE_SOURCE::RESULTS :
                    $szHash = $aVariables['HashDigest'];
                    self::getTransactionCompleteResultFromPostVariables($aVariables, self::$trTransactionResult);
                    $szStringToHash = self::generateStringToHashPaymentComplete(self::$trTransactionResult, $szHashMethod, $szSecreKeyOrPreSharedKey, $szMerchantID, $szPassword);
                    break;
            }

            $szCalculatedHash = self::calculateHashDigest($szStringToHash, $szSecreKeyOrPreSharedKey, $szHashMethod);

            if ($szCalculatedHash == $szHash)
            {
                $boReturnValue = true;
            }

            return ($boReturnValue);
        }

        private static function get3DSecureAuthenticationRequiredFromPostVariables($aVariables, &$trTransactionResult)
        {

            $szHashDigest = "";
            $szErrorMessage = "";
            $boErrorActive = false;

            try
            {
                $trTransactionResult = new TransactionResult();

                // hash digest
                if (isset($aVariables["HashDigest"]))
                {
                    $szHashDigest = $aVariables["HashDigest"];
                }

                // transaction status code
                if (!isset($aVariables["StatusCode"]))
                {
                    $szErrorMessage = PaymentFormHelper::addStringToStringList($szErrorMessage, "Expected variable [StatusCode] not received");
                    $boErrorActive = true;
                }
                else
                {
                    if ($aVariables["StatusCode"] == "")
                    {
                        $trTransactionResult -> setStatusCode(null);
                    }
                    else
                    {
                        $trTransactionResult -> setStatusCode(intval($aVariables["StatusCode"]));
                    }
                }
                // transaction message
                if (!isset($aVariables["Message"]))
                {
                    $szErrorMessage = PaymentFormHelper::addStringToStringList($szErrorMessage, "Expected variable [Message] not received");
                    $boErrorActive = true;
                }
                else
                {
                    $trTransactionResult -> setMessage($aVariables["Message"]);
                }

                // cross reference of transaction
                if (!isset($aVariables["CrossReference"]))
                {
                    $szErrorMessage = PaymentFormHelper::addStringToStringList($szErrorMessage, "Expected variable [CrossReference] not received");
                    $boErrorActive = true;
                }
                else
                {
                    $trTransactionResult -> setCrossReference($aVariables["CrossReference"]);
                }

                // currency code (same as value passed into payment form - echoed back out by payment form)
                // order ID (same as value passed into payment form - echoed back out by payment form)
                if (!isset($aVariables["OrderID"]))
                {
                    $szErrorMessage = PaymentFormHelper::addStringToStringList($szErrorMessage, "Expected variable [OrderID] not received");
                    $boErrorActive = true;
                }
                else
                {
                    $trTransactionResult -> setOrderID($aVariables["OrderID"]);
                }

                // transaction date/time (same as value passed into payment form - echoed back out by payment form)
                if (!isset($aVariables["TransactionDateTime"]))
                {
                    $szErrorMessage = PaymentFormHelper::addStringToStringList($szErrorMessage, "Expected variable [TransactionDateTime] not received");
                    $boErrorActive = true;
                }
                else
                {
                    $trTransactionResult -> setTransactionDateTime($aVariables["TransactionDateTime"]);
                }
                // order description (same as value passed into payment form - echoed back out by payment form)
                if (!isset($aVariables["ACSURL"]))
                {
                    $szErrorMessage = PaymentFormHelper::addStringToStringList($szErrorMessage, "Expected variable [ACSURL] not received");
                    $boErrorActive = true;
                }
                else
                {
                    $trTransactionResult -> setACSURL($aVariables["ACSURL"]);
                }
                // address1 (not necessarily the same as value passed into payment form - as the customer can change it on the form)
                if (!isset($aVariables["PaREQ"]))
                {
                    $szErrorMessage = PaymentFormHelper::addStringToStringList($szErrorMessage, "Expected variable [PaREQ] not received");
                    $boErrorActive = true;
                }
                else
                {
                    $trTransactionResult -> setPaREQ($aVariables["PaREQ"]);
                }

            }
            catch (Exception $e)
            {
                $boErrorActive = true;
                $szErrorMessage = $e -> getMessage();
            }

            return (!$boErrorActive);
        }

        private static function get3DSecurePostAuthenticationFromPostVariables($aVariables, &$trTransactionResult)
        {

            //$this->trTransactionResult = null;
            $szErrorMessage = "";
            $boErrorActive = false;

            try
            {
                $trTransactionResult = new TransactionResult();

                // cross reference of transaction
                if (!isset($aVariables["MD"]))
                {
                    $szErrorMessage = PaymentFormHelper::addStringToStringList($szErrorMessage, "Expected variable [MD] not received");
                    $boErrorActive = true;
                }
                else
                {
                    //$trTransactionResult -> setCrossReference($aVariables["MD"]);
                    $szCrossReference = $aVariables["MD"];
                }

                if (!isset($aVariables["PaRes"]))
                {
                    $szErrorMessage = PaymentFormHelper::addStringToStringList($szErrorMessage, "Expected variable [PaRes] not received");
                    $boErrorActive = true;
                }
                else
                {
                    //$trTransactionResult -> setPaRES($aVariables["PaRes"]);
                    $szPaRES = $aVariables["PaRes"];
                }
            }
            catch (Exception $e)
            {
                $boErrorActive = true;
                $szErrorMessage = $e -> getMessage();
            }

            return (!$boErrorActive);
        }

        private static function getTransactionCompleteResultFromPostVariables($aVariables, &$trTransactionResult)
        {

            //$this->trTransactionResult = null;
            $szErrorMessage = "";
            $boErrorActive = false;

            try
            {
                $trTransactionResult = new TransactionResult();

                // hash digest
                if (isset($aVariables["HashDigest"]))
                {
                    $szHashDigest = $aVariables["HashDigest"];
                }

                // transaction status code
                if (!isset($aVariables["StatusCode"]))
                {
                    $szErrorMessage = PaymentFormHelper::addStringToStringList($szErrorMessage, "Expected variable [StatusCode] not received");
                    $boErrorActive = true;
                }
                else
                {
                    if ($aVariables["StatusCode"] == "")
                    {
                        $trTransactionResult -> setStatusCode(null);
                    }
                    else
                    {
                        $trTransactionResult -> setStatusCode(intval($aVariables["StatusCode"]));
                    }
                }
                // transaction message
                if (!isset($aVariables["Message"]))
                {
                    $szErrorMessage = PaymentFormHelper::addStringToStringList($szErrorMessage, "Expected variable [Message] not received");
                    $boErrorActive = true;
                }
                else
                {
                    $trTransactionResult -> setMessage($aVariables["Message"]);
                }
                // status code of original transaction if this transaction was deemed a duplicate
                if (!isset($aVariables["PreviousStatusCode"]))
                {
                    $szErrorMessage = PaymentFormHelper::addStringToStringList($szErrorMessage, "Expected variable [PreviousStatusCode] not received");
                    $boErrorActive = true;
                }
                else
                {
                    if ($aVariables["PreviousStatusCode"] == "")
                    {
                        $trTransactionResult -> setPreviousStatusCode(null);
                    }
                    else
                    {
                        $trTransactionResult -> setPreviousStatusCode(intval($aVariables["PreviousStatusCode"]));
                    }
                }
                // status code of original transaction if this transaction was deemed a duplicate
                if (!isset($aVariables["PreviousMessage"]))
                {
                    $szErrorMessage = PaymentFormHelper::addStringToStringList($szErrorMessage, "Expected variable [PreviousMessage] not received");
                    $boErrorActive = true;
                }
                else
                {
                    $trTransactionResult -> setPreviousMessage($aVariables["PreviousMessage"]);
                }
                // cross reference of transaction
                if (!isset($aVariables["CrossReference"]))
                {
                    $szErrorMessage = PaymentFormHelper::addStringToStringList($szErrorMessage, "Expected variable [CrossReference] not received");
                    $boErrorActive = true;
                }
                else
                {
                    $trTransactionResult -> setCrossReference($aVariables["CrossReference"]);
                }
                // amount (same as value passed into payment form - echoed back out by payment form)
                if (!isset($aVariables["Amount"]))
                {
                    $szErrorMessage = PaymentFormHelper::addStringToStringList($szErrorMessage, "Expected variable [Amount] not received");
                    $boErrorActive = true;
                }
                else
                {
                    if ($aVariables["Amount"] == "")
                    {
                        $trTransactionResult -> setAmount(NULL);
                    }
                    else
                    {
                        $trTransactionResult -> setAmount($aVariables["Amount"]);
                    }
                }

                if (!isset($aVariables["CurrencyCode"]))
                {
                    $szErrorMessage = PaymentFormHelper::addStringToStringList($szErrorMessage, "Expected variable [CurrencyCode] not received");
                    $boErrorActive = true;
                }
                else
                {
                    if ($aVariables["CurrencyCode"] == "")
                    {
                        $trTransactionResult -> setCurrencyCode(NULL);
                    }
                    else
                    {
                        $trTransactionResult -> setCurrencyCode($aVariables["CurrencyCode"]);
                    }
                }
                // currency code (same as value passed into payment form - echoed back out by payment form)
                // order ID (same as value passed into payment form - echoed back out by payment form)
                if (!isset($aVariables["OrderID"]))
                {
                    $szErrorMessage = PaymentFormHelper::addStringToStringList($szErrorMessage, "Expected variable [OrderID] not received");
                    $boErrorActive = true;
                }
                else
                {
                    $trTransactionResult -> setOrderID($aVariables["OrderID"]);
                }
                // transaction type (same as value passed into payment form - echoed back out by payment form)
                if (!isset($aVariables["TransactionType"]))
                {
                    $szErrorMessage = PaymentFormHelper::addStringToStringList($szErrorMessage, "Expected variable [TransactionType] not received");
                    $boErrorActive = true;
                }
                else
                {
                    $trTransactionResult -> setTransactionType($aVariables["TransactionType"]);
                }
                // transaction date/time (same as value passed into payment form - echoed back out by payment form)
                if (!isset($aVariables["TransactionDateTime"]))
                {
                    $szErrorMessage = PaymentFormHelper::addStringToStringList($szErrorMessage, "Expected variable [TransactionDateTime] not received");
                    $boErrorActive = true;
                }
                else
                {
                    $trTransactionResult -> setTransactionDateTime($aVariables["TransactionDateTime"]);
                }
                // order description (same as value passed into payment form - echoed back out by payment form)
                if (!isset($aVariables["OrderDescription"]))
                {
                    $szErrorMessage = PaymentFormHelper::addStringToStringList($szErrorMessage, "Expected variable [OrderDescription] not received");
                    $boErrorActive = true;
                }
                else
                {
                    $trTransactionResult -> setOrderDescription($aVariables["OrderDescription"]);
                }
                // address1 (not necessarily the same as value passed into payment form - as the customer can change it on the form)
                if (!isset($aVariables["Address1"]))
                {
                    $szErrorMessage = PaymentFormHelper::addStringToStringList($szErrorMessage, "Expected variable [Address1] not received");
                    $boErrorActive = true;
                }
                else
                {
                    $trTransactionResult -> setAddress1($aVariables["Address1"]);
                }
                // address2 (not necessarily the same as value passed into payment form - as the customer can change it on the form)
                if (!isset($aVariables["Address2"]))
                {
                    $szErrorMessage = PaymentFormHelper::addStringToStringList($szErrorMessage, "Expected variable [Address2] not received");
                    $boErrorActive = true;
                }
                else
                {
                    $trTransactionResult -> setAddress2($aVariables["Address2"]);
                }
                // address3 (not necessarily the same as value passed into payment form - as the customer can change it on the form)
                if (!isset($aVariables["Address3"]))
                {
                    $szErrorMessage = PaymentFormHelper::addStringToStringList($szErrorMessage, "Expected variable [Address3] not received");
                    $boErrorActive = true;
                }
                else
                {
                    $trTransactionResult -> setAddress3($aVariables["Address3"]);
                }
                // address4 (not necessarily the same as value passed into payment form - as the customer can change it on the form)
                if (!isset($aVariables["Address4"]))
                {
                    $szErrorMessage = PaymentFormHelper::addStringToStringList($szErrorMessage, "Expected variable [Address4] not received");
                    $boErrorActive = true;
                }
                else
                {
                    $trTransactionResult -> setAddress4($aVariables["Address4"]);
                }
                // city (not necessarily the same as value passed into payment form - as the customer can change it on the form)
                if (!isset($aVariables["City"]))
                {
                    $szErrorMessage = PaymentFormHelper::addStringToStringList($szErrorMessage, "Expected variable [City] not received");
                    $boErrorActive = true;
                }
                else
                {
                    $trTransactionResult -> setCity($aVariables["City"]);
                }
                // state (not necessarily the same as value passed into payment form - as the customer can change it on the form)
                if (!isset($aVariables["State"]))
                {
                    $szErrorMessage = PaymentFormHelper::addStringToStringList($szErrorMessage, "Expected variable [State] not received");
                    $boErrorActive = true;
                }
                else
                {
                    $trTransactionResult -> setState($aVariables["State"]);
                }
                // post code (not necessarily the same as value passed into payment form - as the customer can change it on the form)
                if (!isset($aVariables["PostCode"]))
                {
                    $szErrorMessage = PaymentFormHelper::addStringToStringList($szErrorMessage, "Expected variable [PostCode] not received");
                    $boErrorActive = true;
                }
                else
                {
                    $trTransactionResult -> setPostCode($aVariables["PostCode"]);
                }
                // country code (not necessarily the same as value passed into payment form - as the customer can change it on the form)
                if (!isset($aVariables["CountryCode"]))
                {
                    $szErrorMessage = PaymentFormHelper::addStringToStringList($szErrorMessage, "Expected variable [CountryCode]mail not received");
                    $boErrorActive = true;
                }
                else
                {
                    if ($aVariables["CountryCode"] == "")
                    {
                        $trTransactionResult -> setCountryCode(NULL);
                    }
                    else
                    {
                        $trTransactionResult -> setCountryCode($aVariables["CountryCode"]);
                    }
                }

                if (!isset($aVariables["AddressNumericCheckResult"]))
                {
                    $szErrorMessage = PaymentFormHelper::addStringToStringList($szErrorMessage, "Expected variable [AddressNumericCheckResult] not received");
                    $boErrorActive = true;
                }
                else
                {
                    if ($aVariables["AddressNumericCheckResult"] == "")
                    {
                        $trTransactionResult -> setAddressNumericCheckResult(null);
                    }
                    else
                    {
                        $trTransactionResult -> setAddressNumericCheckResult($aVariables["AddressNumericCheckResult"]);
                    }
                }
                if (!isset($aVariables["PostCodeCheckResult"]))
                {
                    $szErrorMessage = PaymentFormHelper::addStringToStringList($szErrorMessage, "Expected variable [PostCodeCheckResult] not received");
                    $boErrorActive = true;
                }
                else
                {
                    if ($aVariables["PostCodeCheckResult"] == "")
                    {
                        $trTransactionResult -> setPostCodeCheckResult(null);
                    }
                    else
                    {
                        $trTransactionResult -> setPostCodeCheckResult($aVariables["PostCodeCheckResult"]);
                    }
                }
                if (!isset($aVariables["CV2CheckResult"]))
                {
                    $szErrorMessage = PaymentFormHelper::addStringToStringList($szErrorMessage, "Expected variable [CV2CheckResult] not received");
                    $boErrorActive = true;
                }
                else
                {
                    if ($aVariables["CV2CheckResult"] == "")
                    {
                        $trTransactionResult -> setCV2CheckResult(null);
                    }
                    else
                    {
                        $trTransactionResult -> setCV2CheckResult($aVariables["CV2CheckResult"]);
                    }
                }
                if (!isset($aVariables["ThreeDSecureAuthenticationCheckResult"]))
                {
                    $szErrorMessage = PaymentFormHelper::addStringToStringList($szErrorMessage, "Expected variable [ThreeDSecureAuthenticationCheckResult] not received");
                    $boErrorActive = true;
                }
                else
                {
                    if ($aVariables["ThreeDSecureAuthenticationCheckResult"] == "")
                    {
                        $trTransactionResult -> setThreeDSecureAuthenticationCheckResult(null);
                    }
                    else
                    {
                        $trTransactionResult -> setThreeDSecureAuthenticationCheckResult($aVariables["ThreeDSecureAuthenticationCheckResult"]);
                    }
                }
                if (!isset($aVariables["CardType"]))
                {
                    $szErrorMessage = PaymentFormHelper::addStringToStringList($szErrorMessage, "Expected variable [CardType] not received");
                    $boErrorActive = true;
                }
                else
                {
                    if ($aVariables["CardType"] == "")
                    {
                        $trTransactionResult -> setCardType(null);
                    }
                    else
                    {
                        $trTransactionResult -> setCardType($aVariables["CardType"]);
                    }
                }
                if (!isset($aVariables["CardClass"]))
                {
                    $szErrorMessage = PaymentFormHelper::addStringToStringList($szErrorMessage, "Expected variable [CardClass] not received");
                    $boErrorActive = true;
                }
                else
                {
                    if ($aVariables["CardClass"] == "")
                    {
                        $trTransactionResult -> setCardClass(null);
                    }
                    else
                    {
                        $trTransactionResult -> setCardClass($aVariables["CardClass"]);
                    }
                }
                if (!isset($aVariables["CardIssuer"]))
                {
                    $szErrorMessage = PaymentFormHelper::addStringToStringList($szErrorMessage, "Expected variable [CardIssuer] not received");
                    $boErrorActive = true;
                }
                else
                {
                    if ($aVariables["CardIssuer"] == "")
                    {
                        $trTransactionResult -> setCardIssuer(null);
                    }
                    else
                    {
                        $trTransactionResult -> setCardIssuer($aVariables["CardIssuer"]);
                    }
                }
                if (!isset($aVariables["CardIssuerCountryCode"]))
                {
                    $szErrorMessage = PaymentFormHelper::addStringToStringList($szErrorMessage, "Expected variable [CardIssuerCountryCode] not received");
                    $boErrorActive = true;
                }
                else
                {
                    if ($aVariables["CardIssuerCountryCode"] == "")
                    {
                        $trTransactionResult -> setCardIssuerCountryCode(null);
                    }
                    else
                    {
                        $trTransactionResult -> setCardIssuerCountryCode(intval($aVariables["CardIssuerCountryCode"]));
                    }
                }
                if (!isset($aVariables["EmailAddress"]))
                {
                    $szErrorMessage = PaymentFormHelper::addStringToStringList($szErrorMessage, "Expected variable [EmailAddress] not received");
                    $boErrorActive = true;
                }
                else
                {
                    if ($aVariables["EmailAddress"] == "")
                    {
                        $trTransactionResult -> setEmailAddress(null);
                    }
                    else
                    {
                        $trTransactionResult -> setEmailAddress($aVariables["EmailAddress"]);
                    }
                }
                if (!isset($aVariables["PhoneNumber"]))
                {
                    $szErrorMessage = PaymentFormHelper::addStringToStringList($szErrorMessage, "Expected variable [PhoneNumber] not received");
                    $boErrorActive = true;
                }
                else
                {
                    if ($aVariables["PhoneNumber"] == "")
                    {
                        $trTransactionResult -> setPhoneNumber(null);
                    }
                    else
                    {
                        $trTransactionResult -> setPhoneNumber($aVariables["PhoneNumber"]);
                    }
                }
            }
            catch (Exception $e)
            {
                $boErrorActive = true;
                $szErrorMessage = $e -> getMessage();
            }

            return (!$boErrorActive);
        }

        // This is a "hook" function that is run when the results of the transaction are
        // known.
        // You should put your code that does any post transaction tasks
        // (e.g. updates the order object, sends the customer an email etc) in this function
        public static function reportTransactionResult(&$OutputMessage)
        {
            $ErrorOccurred = false;
            $OutputMessage = "Environment specific function reportTransactionResults() needs to be implemented by merchant developer";    
            
            try
            {
                switch (self::$trTransactionResult->getStatusCode())
                {
                    // transaction authorised
                    case 0:
                        $MessageClass = "SuccessMessage";
                        break;
                    // transaction declined
                    case 5:
                        $MessageClass = "ErrorMessage";
                        break;
                    // duplicate transaction
                    case 20:
                        $DuplicateTransaction = true;
        
                        // need to look at the previous status code to see if the
                        // transaction was successful
                        if (self::$trTransactionResult->getPreviousStatusCode() == 0)
                        {
                            // transaction authorised
                            $MessageClass = "SuccessMessage";
                        }
                        else
                        {
                            // transaction not authorised
                            $MessageClass = "ErrorMessage";
                        }
                        $PreviousTransactionMessage = self::$trTransactionResult->getPreviousMessage();
        
                        break;
                    // error occurred
                    case 30:
                        $MessageClass = "ErrorMessage";
                        break;
                    default:
                        $MessageClass = "ErrorMessage";
                        break;
                }
                $Message = self::$trTransactionResult->getMessage();
    
                // put code to update/store the order with the transaction result
                
            }  
            catch (Exception $e)
            {
                $ErrorOccurred = true;
                $Message = $e->getMessage();
            }
            return (!$ErrorOccurred);
        }
    }
?>