<?php
    include ("Config.php");
    require_once ("PaymentFormHelper.php");

    $ResetFormVariables = false;
    $SuppressFormDisplay = false;
    $BodyAttributes = "";
    $FormAction = "";
    $FormAttributes = "";
    $Message = "";
    $MessageClass = "";
    $DuplicateTransaction = false;
    $PreviousTransactionMessage = "";
    
    if (!isset($_POST))
    {
        $NextFormMode = FORM_MODE::PAYMENT_FORM;
        $Message = "No input variables passed";
        $MessageClass = "ErrorMessage";
        $SuppressFormDisplay = true;
    }
    else
    {
        if (isset($_POST['ShoppingCartHashDigest']))
        {
            if (PaymentFormHelper::checkIntegrityOfIncomingVariables(INCOMING_VARIABLE_SOURCE::SHOPPING_CART_CHECKOUT, $_POST, $HashMethod, $SecretKey, $MerchantID, $Password))
            {
                $ResetFormVariables = false;
                $NextFormMode = FORM_MODE::PAYMENT_FORM;
                $FormAction = "https://mms." . $PaymentProcessorDomain . "/Pages/PublicPages/TransparentRedirect.aspx";

                $Amount = $_POST['Amount'];
                $CurrencyCode = $_POST['CurrencyCode'];
                $OrderID = $_POST['OrderID'];
                $OrderDescription = $_POST['OrderDescription'];

                $TransactionType = $_POST['TransactionType'];
                $TransactionDateTime = $_POST['TransactionDateTime'];
                $CallbackURL = $_POST['CallbackURL'];
                
                $CardName = $_POST["CustomerName"];
                $Address1 = $_POST["Address1"];
                $Address2 = $_POST["Address2"];
                $Address3 = $_POST["Address3"];
                $Address4 = $_POST["Address4"];
                $City = $_POST["City"];
                $State = $_POST["State"];
                $PostCode = $_POST["PostCode"];
                $CurrencyCode = $_POST["CurrencyCode"];
            }
            else
            {
                $NextFormMode = FORM_MODE::PAYMENT_FORM;
                $Message = "Variable tampering detected";
                $MessageClass = "ErrorMessage";
                $SuppressFormDisplay = true;
            }
        }
        elseif (isset($_POST['HashDigest']))
        {
            if (isset($_POST['PaREQ']))
            {
                if (PaymentFormHelper::checkIntegrityOfIncomingVariables(INCOMING_VARIABLE_SOURCE::THREE_D_SECURE_AUTHENTICATION_REQUIRED, $_POST, $HashMethod, $PreSharedKey, $MerchantID, $Password))
                {
                    $NextFormMode = FORM_MODE::THREE_D_SECURE_AUTHENTICATION_REQUIRED;
                    $BodyAttributes = " onload=\"document.Form.submit();\"";
                    $FormAction = PaymentFormHelper::$trTransactionResult->getACSURL();
                    $FormAttributes = " target=\"ACSFrame\"";
                    
                    $PaREQ = PaymentFormHelper::$trTransactionResult->getPaREQ();
                    $CrossReference = PaymentFormHelper::$trTransactionResult->getCrossReference();
                    $TermURL = PaymentFormHelper::getSiteSecureBaseURL() . "ThreeDSecureLandingPage.asp";
                    
                }
                else
                {
                    $NextFormMode = FORM_MODE::PAYMENT_FORM;
                    $Message = "Variable tampering detected";
                    $MessageClass = "ErrorMessage";
                    $SuppressFormDisplay = true;
                }
            }
            else
            {
                $NextFormMode = FORM_MODE::RESULTS;
                $FormAction = "PaymentForm.php";

                if (PaymentFormHelper::checkIntegrityOfIncomingVariables(INCOMING_VARIABLE_SOURCE::RESULTS, $_POST, $HashMethod, $PreSharedKey, $MerchantID, $Password))
                {
                    if (PaymentFormHelper::reportTransactionResult($OutputMessage))
                    {
                        switch (PaymentFormHelper::$trTransactionResult->getStatusCode())
                        {
                            // transaction authorised
                            case 0:
                                $MessageClass = "SuccessMessage";
                                break;
                            // transaction declined
                            case 5:
                                $MessageClass = "ErrorMessage";
                                break;
                            // duplicate transaction
                            case 20:
                                $DuplicateTransaction = true;
                
                                // need to look at the previous status code to see if the
                                // transaction was successful
                                if (PaymentFormHelper::$trTransactionResult->getPreviousStatusCode() == 0)
                                {
                                    // transaction authorised
                                    $MessageClass = "SuccessMessage";
                                }
                                else
                                {
                                    // transaction not authorised
                                    $MessageClass = "ErrorMessage";
                                }
                                $PreviousTransactionMessage = PaymentFormHelper::$trTransactionResult->getPreviousMessage();
                
                                break;
                            // error occurred
                            case 30:
                                $MessageClass = "ErrorMessage";
                                break;
                            default:
                                $MessageClass = "ErrorMessage";
                                break;
                        }
                        $Message = PaymentFormHelper::$trTransactionResult->getMessage();
                        
                    } else {
                         // handle the case where the results aren't stored correctly
                        $MessageClass = "ErrorMessage";

                        // You might want to display the actual exception message during testing
                        // If so, comment and uncomment out the two lines below as necessary
                        $Message = "An error has occured";
                        //$Message = $OutputMessage;
                    }
                }
                else
                {
                    $NextFormMode = FORM_MODE::PAYMENT_FORM;
                    $Message = "Variable tampering detected";
                    $MessageClass = "ErrorMessage";
                    $SuppressFormDisplay = true;
                }
            }
        }
    }

    // Reset the form variables if required
    if ($ResetFormVariables == true)
    {
        $CardName = "";
        $CardNumber = "";
        $ExpiryDateMonth = "";
        $ExpiryDateYear = "";
        $StartDateMonth = "";
        $StartDateYear = "";
        $IssueNumber = "";
        $CV2 = "";
        $Address1 = "";
        $Address2 = "";
        $Address3 = "";
        $Address4 = "";
        $City = "";
        $State = "";
        $PostCode = "";
        $CountryShort = "";
    }

?>