<?php
    require ("Config.php");
    require_once ("PaymentFormHelper.php");

    $Width = 800;
    $Width = 800;
    $BodyAttributes = "";
    $FormAttributes = "";
    $FormAction = "PaymentForm.php";
    
    include ("Templates/FormHeader.tpl");

    // the amount in *minor* currency (i.e. �10.00 passed as "1000")
    $Amount = strval(1000);
    // the currency - ISO 4217 3-digit numeric (e.g. GBP = 826)
    $CurrencyCode = strval(826);
    // order ID
    $OrderID = "Order-1234";
    // the transaction type - can be SALE or PREAUTH
    $TransactionType = "SALE";
    // the GMT/UTC relative date/time for the transaction (MUST either be in GMT/UTC 
    // or MUST include the correct timezone offset)
    $TransactionDateTime = date('Y-m-d H:i:s P');
    // Callback URL
    $CallbackURL = PaymentFormHelper::getSiteSecureBaseURL() . "PaymentForm.php";
    // order description
    $OrderDescription = "A Test Order";
    // these variables allow the payment form to be "seeded" with initial values
    $CustomerName = "A Customer";
    $Address1 = "14 Some Address";
    $Address2 = "";
    $Address3 = "";
    $Address4 = "";
    $City = "Some City";
    $State = "Some State";
    $PostCode = "PO57 0DE";
    // the country code - ISO 3166-1  3-digit numeric (e.g. UK = 826)
    // PLEASE NOTE: This needs to remain as ISO Country Code 826 at present in the Sample Page
    $CountryCode = strval(826);

    // get the string to be hashed
    $StringToHash = PaymentFormHelper::generateStringToHash($MerchantID,
                                                            $Password,
                                                            $Amount,
                                                            $CurrencyCode,
                                                            $OrderID,
                                                            $TransactionType,
                                                            $TransactionDateTime,
                                                            $CallbackURL,
                                                            $OrderDescription,
                                                            $CustomerName,
                                                            $Address1,
                                                            $Address2,
                                                            $Address3,
                                                            $Address4,
                                                            $City,
                                                            $State,
                                                            $PostCode,
                                                            $CountryCode,
                                                            $SecretKey);
                                                              
    // pass this string into the hash function to create the hash digest
    $HashDigest = PaymentFormHelper::calculateHashDigest($StringToHash, $SecretKey, $HashMethod);

    include ("Templates/StartHereForm.tpl");
    include ("Templates/FormFooter.tpl");
